/*  $Id: zProgressBar.h,v 1.3 1998/07/27 16:34:53 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef ZPROGRESSBAR_H
#define ZPROGRESSBAR_H

#include "qprogres.h"
#include "../../../src/components/BaseComp.h"
#include "../../../src/main.h"


class
zProgressBar : public BaseComponent
{
   private:
	QProgressCtrl *look;
	QString *orient, *type;
   public:
	//Constructor
	zProgressBar(QWidget *parent);
	
	//Attribute Information passing
	virtual void fillAttributes();
        virtual void interpretAttributes();
	
	//Write your intialization routine for source dumping
	virtual void writeInits();

	//Fill in your initial members + member info
	virtual void fillMembInfo();

	//Of what type are you?
	virtual char *queryQType() { return "QProgressCtrl"; }


/******************************************************************************
		SPECIAL PURPOSE QUERIES, RARELY NECESARY
******************************************************************************/
	//About
	virtual char *aboutComp()
	{ 
	 return "Component by: Sam Magnuson\nOriginal Widget by: Tim D. Gilman";
 	}

        //Should be instantiated?
        virtual int instantiate() { return 1; }

        //Constructor overload (for instantiating in parent)
        //Returning 0 is the same as returning "(this,name)"
        virtual char *specialInit() { return 0; }

   	 //This is to cause the linking/including of a special file.
         //Only of use in external components.
    	virtual int externalLinkage() { return 1;}

	//This will be the string used in the class definition, only use
	//if your component inherits something different the queryQType() 
	//returns.
        virtual char *specialInher() { return 0; }

	//Use this only if you want this widget not to be cut/copyable, mostly
	//because it has more interworkings, or you don't want multiple ones
	//etc..
	virtual int copyAble() { return 1; }
};

/******************************************************************************
 Uncomment if you intend to link this in dynamically, otherwise not necesary
******************************************************************************/
extern "C"
{
        zProgressBar *yourself(QWidget *parent);
}
#endif
