/*  $Id: zTableView.cc,v 1.3 1998/07/27 16:34:54 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zTableView.h"

zTableView::zTableView(QWidget *parent) 
					: BaseComponent(parent,"tableview")
{
	look = new tmpTableView(this,"foo");
	resize(200,110);
	setLook(look);
}

void 
zTableView::fillAttributes()
{
	genericFillAttrib();

	ADDATTRIB("Number of Rows",look->numRows(),W_TEXT);

	ADDATTRIB("Number of Columns",look->numCols(),W_TEXT);

	ADDATTRIB("X Offset",look->xOffset(),W_TEXT);

	ADDATTRIB("Y Offset",look->yOffset(),W_TEXT);

	ADDATTRIB("Cell Height",look->cellHeight(),W_TEXT);

	ADDATTRIB("Cell Width",look->cellWidth(),W_TEXT);

	ADDATTRIB("Auto Update",look->autoUpdate(),W_TRUE);

}

void 
zTableView::interpretAttributes()
{
	genericInterpAttrib();

	QString i;

	look->setNumRows(attrib->giveIntValue("Number of Rows"));
	look->setNumCols(attrib->giveIntValue("Number of Columns"));
	look->setXOffset(attrib->giveIntValue("X Offset"));
	look->setYOffset(attrib->giveIntValue("Y Offset"));
	look->setCellHeight(attrib->giveIntValue("Cell Height"));
	look->setCellWidth(attrib->giveIntValue("Cell Width"));
	look->setAutoUpdate(attrib->giveBoolValue("Auto Update"));
	
}

void
zTableView::writeInits()
{
	if(global->queryHeader().find("qtablevw.h") == -1)
		addHead("#include <qtablevw.h>");

	QString i;

	i.sprintf("setNumRows(%d);\n",
		look->numRows());
	WRITEATTRIB("Number of Rows",i);

	i.sprintf("setNumCols(%d);\n",
		look->numCols());
	WRITEATTRIB("Number of Columns",i);

	i.sprintf("setXOffset(%d);\n",
		look->xOffset());
	WRITEATTRIB("X Offset",i);

	i.sprintf("setYOffset(%d);\n",
		look->yOffset());
	WRITEATTRIB("Y Offset",i);

	i.sprintf("setCellWidth(%d);\n",
		look->cellWidth());
	WRITEATTRIB("Cell Width",i);

	i.sprintf("setCellHeight(%d);\n",
		look->cellHeight());
	WRITEATTRIB("Cell Height",i);
	
	i.sprintf("setAutoUpdate(%s);\n",
		strBool(look->autoUpdate()));
	WRITEATTRIB("Auto Update",i);

        if(!tooltipData->isEmpty())
        {
                QString p;
                if(noFuncs() == TRUE)
                        p = name();
                else
                        p = "this";

                i.sprintf(
                "QToolTip::add(%s,\"%s\");\n"
                        ,p.data(),tooltipData->data());
                writeLine(i);
        }

        i.sprintf(
        "setGeometry(%d,%d,%d,%d);\n"
                ,x()+3,y()+3,width(),height());
        writeInParent(i);

        if(*uiStyle == "Motif")
               i.sprintf("setStyle(MotifStyle);\n");
        else if(*uiStyle == "Default")
                i = "";
        else if(*uiStyle == "Windows")
                i.sprintf("setStyle(WindowsStyle);\n");
        if(!i.isEmpty()) writeInParent(i);
}

void
zTableView::fillMembInfo()
{
        //fills generic virtual protected stuffs
        genericFillMembInfo();

	addMember("void paintCell(QPainter *p, int row, int col)","","/* This function should at least have this comment - but preferably more as this function needs to be over-ridden.*/\n");
	addMember("void setupPainter(QPainter *p)");
        
	//empty destructor
        addMember("destructor()","","",0,2,1);

        //very generic constructor
        addMember("constructor(QWidget *parent=0, char *name=0)",
                        "init(parent,name)","",0,2,1);

}

/******************************************************************************
 Uncomment if you intend to link this in dynamically, otherwise not necesary
******************************************************************************/
extern "C"
{
        zTableView *yourself(QWidget *parent)
        {
                return (new zTableView(parent));
        }
}
