/*  $Id: zTableView.h,v 1.3 1998/07/27 16:34:54 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef ZTABLEVIEW_H
#define ZTABLEVIEW_H

#include "../../../src/components/BaseComp.h"
#include "../../../src/main.h"

//This is just so I will override the pure virtual function paintCell()
//Also so I have acecss to protected members
class tmpTableView : public QTableView
{
       public:
        friend class zTableView;
         tmpTableView(QWidget *parent, const char *name=0) :
                        QTableView(parent,name)
        { }
      protected:
        virtual void paintCell(class QPainter *, int , int ) { }
};

class
zTableView : public BaseComponent
{
   private:
	tmpTableView *look;
   public:
	//Constructor
	zTableView(QWidget *parent);
	
	//Attribute Information passing
	virtual void fillAttributes();
        virtual void interpretAttributes();
	
	//Write your intialization routine for source dumping
	virtual void writeInits();

	//Fill in your initial members + member info
	virtual void fillMembInfo();

	virtual int canHaveChildren() { return 0; }

	//Of what type are you?
	virtual char *queryQType() { return "QTableView"; }


/******************************************************************************
		SPECIAL PURPOSE QUERIES, RARELY NECESARY
******************************************************************************/
        //Should be instantiated?
        virtual int instantiate() { return 1; }

        //Constructor overload (for instantiating in parent)
        //Returning 0 is the same as returning "(this,name)"
        virtual char *specialInit() { return 0; }

	//This will be the string used in the class definition, only use
	//if your component inherits something different the queryQType() 
	//returns.
        virtual char *specialInher() { return 0; }

	//Use this only if you want this widget not to be cut/copyable, mostly
	//because it has more interworkings, or you don't want multiple ones
	//etc..
	virtual int copyAble() { return 1; }
};

/******************************************************************************
 Uncomment if you intend to link this in dynamically, otherwise not necesary
******************************************************************************/
extern "C"
{
        zTableView *yourself(QWidget *parent);
}
#endif
