/*  $Id: AttributeItem.h,v 1.6 1998/07/27 16:34:55 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef ATTRIBUTEITEM_H
#define ATTRIBUTEITEM_H

#include "main.h"

#include <qlistbox.h>
#include <qstring.h>
#include <qcolor.h>
#include <qstrlist.h>

#ifndef BASECOMP_H
enum ATTRIB_TYPE { W_LIST, W_FILE, W_TEXT, W_TRUE, W_COLOR};
#endif

class
AttributeItem : public QListBoxItem
{
    private:
	ATTRIB_TYPE optionType;
	QString *myCaption, *myCurrentValue;
	QString *strings;
	QColor currColor;
	int currentInteger, written;
	static int wid;
	int numItems;
	void clearNews();

    public:
	
	AttributeItem(char *,char *,ATTRIB_TYPE,int=0,...);
	AttributeItem(char *,int,ATTRIB_TYPE,int=0,...);
	AttributeItem(char *,QColor,ATTRIB_TYPE); 
	AttributeItem(char *,bool,ATTRIB_TYPE);
	AttributeItem(char *,char *, ATTRIB_TYPE,QStrList *);
	~AttributeItem();

	ATTRIB_TYPE type() { return optionType; }
	initItem(char *, char *, ATTRIB_TYPE, QStrList *);
	void resizeHLines(int);
	int count() { return numItems; }
	QString string(int x) { return strings[x]; }
	virtual const char *text() const { return myCaption->data(); }
	QColor queryColor() { return currColor; }
	QString queryCaption() { return *myCaption; }
	QString queryValue() 
	 { return myCurrentValue->isNull() ? (QString)"" : *myCurrentValue; }
	int queryWritten() { return written; }
	void setWritten(int x) { written = x; }
	void setValue(QString p);
	void setColor(QColor p) { currColor = p; }

    protected:
	virtual void paint(QPainter *);
	virtual int height(const QListBox *) const;
	virtual int width(const QListBox *) const;
};

#endif
