/*  $Id: Attributes.h,v 1.9 1998/07/28 03:10:09 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */


#ifndef ATTRIBUTES_H
#define ATTRIBUTES_H

#include "version.h"
#include "main.h"
#include "myListBox.h"
#include "ColorSelect.h"
#include "Hint.h"
#include "AttributeItem.h"
#include "components/BaseComp.h"
#include "components/CompIO.h"

#include <qpopmenu.h>
#include <qpushbt.h>
#include <qcombo.h>
#include <qlined.h>
#include <qdict.h>
#include <fstream.h>

class
Attributes : public QWidget
{
	Q_OBJECT
	BaseComponent *bc;
	myListBox *attributeList;
	bool validTextChange;
	QComboBox *objectList, *men;
	QPushButton *browser, *custCol;
	Hint *hintButt;
	QLineEdit *textBox;
        QDict<AttributeItem> attribDict;
	AttributeItem *workingAttribute;
	int popShow, isSerial;
	int locateValue();
	QString oldCapt;

    public:
	Attributes(QWidget *parent=0,char *name=0);
    	~Attributes() { clearAttributes(); }
	void addAttribute(AttributeItem *newEntry);
    void removeAttribute(int x) { attributeList->removeItem(x); }
	void resetObj() { bc = 0; }
	void clearAttributes();
	
	void render(bool x) 
	{ attributeList->setAutoUpdate(x); if(x) attributeList->repaint(); }

	void setValue(int, QString);
	void setValue(QString, QString);
	
	QString giveCapt(int);
	
	QString giveValue(int);
	QString giveValue(char *);
	
	int giveWritten(int);
	int giveWritten(char *);

	int giveIntValue(int);
	int giveIntValue(char *);

	bool giveBoolValue(char *);
	bool giveBoolValue(int);
	
	QColor giveColor(char *);
	//QColor *giveColor(int);

	void setTextBox(QString);
	
	int numVals() { return attributeList->count(); }

	void setSerialize(int =-1);

	void addObject(char *description, int change=1,int where=-1);
    public slots:
	void applyf();

	void menuChangeAttribute(int);

	void dblClick(int);
	void changeToAttribute(int);
	void choseObject(int);
	void textChangeAttribute(const char *);
	void gotoColors();
	void gotoFiles();
    
 	void removeObject(int);
	void clearObjects();
	void changeObject(char *,int);
	void changeToObject(int x);
	int currentObject() { return bc ? bc->queryPosition() : 0; }

    signals:
	void madeChange(int);

     protected:
	virtual void resizeEvent(QResizeEvent *e);
};

#endif
