/*  $Id: ColorSelect.cc,v 1.3 1998/07/27 16:34:55 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "ColorSelect.h"

ColorSelect::ColorSelect(QWidget *parent, char *name, QColor p) 
			: QDialog(parent,name,TRUE)
{
	

	setCaption("Colour Selection");
	resize(335,337);
	setBackgroundColor(QColor("black"));
	
	label4 = new QLabel(this, "label4");
	label4->setText("B");
	label4->setFont(QFont("times",14));
	label4->setAlignment(AlignHCenter | AlignVCenter);
	label4->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label4->setGeometry(130,258,30,27);
	label4->setBackgroundColor(QColor("blue"));
	
	scroll3 = new QScrollBar(0,255,
			         1,5,
				 0,QScrollBar::Vertical,this, "scroll3");
	scroll3->setGeometry(130,19,29,237);
	
	scroll2 = new QScrollBar(0,255,
				 1,5,
				 0,QScrollBar::Vertical,this,"scroll2");
	scroll2->setGeometry(81,19,29,236);
	
	label3 = new QLabel(this, "label3");
	label3->setText("G");
	label3->setFont(QFont("times",14));
	label3->setAlignment(AlignHCenter | AlignVCenter);
	label3->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label3->setGeometry(81,257,30,27);
	label3->setBackgroundColor(QColor("green"));
	
	label2 = new QLabel(this, "label2");
	label2->setText("R");
	label2->setFont(QFont("times",14));
	label2->setAlignment(AlignHCenter | AlignVCenter);
	label2->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label2->setGeometry(35,258,29,26);
	label2->setBackgroundColor(QColor("red"));
	
	lcd3 = new QLCDNumber(this, "lcd3");
	lcd3->setNumDigits(3);
	lcd3->setSegmentStyle(QLCDNumber::Flat);
	lcd3->setGeometry(112,288,49,38);
	
	lcd1 = new QLCDNumber(this, "lcd1");
	lcd1->setNumDigits(3);
	lcd1->setSegmentStyle(QLCDNumber::Flat);
	lcd1->setGeometry(12,288,49,37);
	
	lcd2 = new QLCDNumber(this, "lcd2");
	lcd2->setNumDigits(3);
	lcd2->setSegmentStyle(QLCDNumber::Flat);
	lcd2->setGeometry(63,288,48,38);
	
	scroll1 = new QScrollBar(0,255,
				 1,5,
				 0,QScrollBar::Vertical,this, "scroll1");
	scroll1->setGeometry(35,20,29,234);
	
	label1 = new QLabel(this, "label1");
	label1->setAlignment(AlignLeft | AlignTop);
	label1->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label1->setGeometry(171,21,150,266);
	
	button2 = new QPushButton(this, "button2");
	button2->setText("Cancel");
	button2->setFont(QFont("times",14));
	button2->setEnabled((bool)1);
	button2->setDefault((bool)0);
	button2->setAutoResize((bool)0);
	button2->setGeometry(247,291,71,37);
	
	button1 = new QPushButton(this, "button1");
	button1->setText("Save");
	button1->setFont(QFont("times",14));
	button1->setEnabled((bool)1);
	button1->setDefault((bool)0);
	button1->setAutoResize((bool)0);
	button1->setGeometry(174,292,66,36);
	
	initPreDef(QColor("red"),171,21);
	initPreDef(QColor("blue"),201,21);
	initPreDef(QColor("green"),231,21);
	initPreDef(QColor("black"),261,21);
	initPreDef(QColor("white"),291,21);
	//-------------------------
        initPreDef(QColor(192,192,192),171,41);
        initPreDef(QColor(250,110,236),201,41);
        initPreDef(QColor(0,145,140),231,41);
        initPreDef(QColor(236,216,32),261,41);
        initPreDef(QColor(255,153,0),291,41);


	setColour(p);
	QObject::connect(scroll1,SIGNAL(valueChanged(int)),
		this,SLOT(makeColour(int)));
	QObject::connect(scroll1,SIGNAL(valueChanged(int)),
		lcd1,SLOT(display(int)));
	QObject::connect(scroll2,SIGNAL(valueChanged(int)),
		this,SLOT(makeColour(int)));
	QObject::connect(scroll2,SIGNAL(valueChanged(int)),
		lcd2,SLOT(display(int)));
	QObject::connect(scroll3,SIGNAL(valueChanged(int)),
		this,SLOT(makeColour(int)));
	QObject::connect(scroll3,SIGNAL(valueChanged(int)),
		lcd3,SLOT(display(int)));
	QObject::connect(button1,SIGNAL(clicked()),
		this,SLOT(accept()));
	QObject::connect(button2,SIGNAL(clicked()),
		this,SLOT(reject()));
}

void
ColorSelect::initPreDef(QColor p,int xish, int yish)
{
        label5 = new QLabel(this, "label5");
        label5->setAlignment(AlignLeft | AlignTop);
        label5->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
        label5->setGeometry(xish,yish,30,20);
        label5->setBackgroundColor(p);
        label5->installEventFilter(this);
}

void 
ColorSelect::setColour(QColor p)
{
	currCol = p;

        lcd1->display(p.red());
	lcd2->display(p.green());
        lcd3->display(p.blue());

	scroll3->setValue(p.blue());
	scroll2->setValue(p.green());
	scroll1->setValue(p.red());

	label1->setBackgroundColor(p);
}

void
ColorSelect::makeColour(int)
{
	currCol.setRgb((int)lcd1->value(),(int)lcd2->value(),
		(int)lcd3->value());
	label1->setBackgroundColor(currCol);
}


bool 
ColorSelect::eventFilter(QObject *o,QEvent *e)
{
	if(e->type() == Event_MouseButtonRelease)
	{
		QWidget *otwo = (QWidget *)o;
		setColour(otwo->backgroundColor());
	}
	return FALSE;
}

