/*  $Id: DebugItem.cc,v 1.3 1998/07/27 16:34:55 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "DebugItem.h"

int DebugItem::wid = 0;

DebugItem::DebugItem(char *capt, char *_command, char *_file, int _line)
{
    QString file(_file);
    myCaption = capt;

    myBaseComp = 0;
    for(int x = 0; !myBaseComp && x < BaseComponent::count(); x++)
    {
	QString compare;
	if(!BaseComponent::at(x)->staticClass())
	    compare.sprintf("temp%d.",BaseComponent::at(x));
	else
	    compare.sprintf("%s.",BaseComponent::at(x)->staticClass());

	if(file.find(compare.data()) != -1) myBaseComp = BaseComponent::at(x);
    }

    if(myBaseComp)	
	function = myBaseComp->functionWith(_line);
    else
    {
	if(!file.find("main.h")) function.setFunc(0);
	if(!file.find("main.cpp")) function.setFunc(1);
    }
}

void
DebugItem::paint(QPainter *p)
{
    p->setFont(QFont(configs->queryFontN(), configs->queryFontS()));
    QFontMetrics fm = p->fontMetrics();
    int y = fm.ascent() + fm.leading() / 2;

    p->drawText(0,y,(char *)myCaption.data());
}

int
DebugItem::height(const QListBox *) const
{
    return configs->queryFontHeight();
}

int
DebugItem::width(const QListBox *lb) const
{
    if(!wid) wid = lb->width();
    return wid-5;
}

