#include "FancyButton.h"
#include <qapp.h>

FancyButton::FancyButton(QWidget * parent, const char * name)   : QLabel(parent, name)
{
    setMouseTracking(TRUE);
    setAlignment(AlignCenter);
    mousePressed = FALSE;
}


void 
FancyButton::enterEvent(QEvent *)
{
    setFrameStyle(QFrame::WinPanel | QFrame::Raised);
    repaint();
}


void
FancyButton::leaveEvent(QEvent *)
{
    setFrameStyle(QFrame::NoFrame);
    repaint();
}

void 
FancyButton::mousePressEvent(QMouseEvent *)
{
    setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
    repaint();
    mousePressed = TRUE;
}

void 
FancyButton::mouseReleaseEvent(QMouseEvent *e)
{
    if (mousePressed = TRUE && QApplication::widgetAt(mapToGlobal(e->pos()), TRUE) == this) {
	setFrameStyle(QFrame::WinPanel | QFrame::Raised);
	repaint();
	emit clicked();
    }
    mousePressed = FALSE;
}

