/*  $Id: Globals.cc,v 1.7 1998/08/30 19:03:35 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "Globals.h"
#include <qlayout.h>

Globals::Globals(QWidget *parent, char *name) : 
	QTabDialog(parent,name,FALSE)
{
    QWidget *w;
    QHBoxLayout *lay;

	setOkButton(0);
        setCaption("Globals Editor");
	resize(650,400);
	
	w = new QWidget(this);
	lay = new QHBoxLayout(w);
	header1 = new SyntaxEdit(w,"Main Header","Main Header:\nThe header will get placed into main.h\nas you see here, with the addition of QTEZ_OUTP\nwill be #defined as the QtEZ version\nyou are using now if you wished to place a comment\nabout the QtEZ development version into it. By\nreloading this QtEZ will try to figure out\nall Qt related #include(s) for you.");
	lay->addWidget(header1);
	QObject::connect(header1,SIGNAL(madeChange()),this,SLOT(refChange()));
	ADDTOOLTIP(header1,
		"This will form main.h and will be included by all files.");
	header1->setFont(QFont(configs->queryFontN(),configs->queryFontS()));
	addTab(w,"Main &Header");

	w = new QWidget(this);
	lay = new QHBoxLayout(w);
	main1 = new SyntaxEdit(w,"Main Function","Main Function:\nThis will be appended to main.cc\nQtEZ will not start the Qt event loop before\nthis, but rather execute this, then start it.");
	lay->addWidget(main1);
	QObject::connect(main1,SIGNAL(madeChange()),this,SLOT(refChange()));
	ADDTOOLTIP(main1, "This will be appended to the main() function.");
	main1->setFont(QFont(configs->queryFontN(),configs->queryFontS()));
	addTab(w,"Main &Function");

	w = new QWidget(this);
	lay = new QHBoxLayout(w);
	freeHand = new SyntaxEdit(w,"Raw Source","Raw Source:\nThis is a place to put all source code you\ncannot put into objects in the environment. You\ncan put regular C functions here or even whole\nclasses, This will be put into the main.cpp\nBEFORE the main() function. If you need a\nprototype for this be sure to put it into\nthe Main Header (on this dialog).");
	lay->addWidget(freeHand);
	QObject::connect(freeHand,SIGNAL(madeChange()),this,SLOT(refChange()));
	ADDTOOLTIP(freeHand,
		"Put source here that doesn't belong in other objects.");
	freeHand->setHighlight(FALSE);
	freeHand->setFont(QFont(configs->queryFontN(),configs->queryFontS()));
	addTab(w,"Raw Source");

	w = new QWidget(this);
	lay = new QHBoxLayout(w);
	comment1 = new SyntaxEdit(w,"Comments","Comments and Signature:\nYou can place comments about your program,\ndocumentation for the program or source code,\nor your own signature so people know who wrote it.\nThis will not make it to the final\nproject when dumped as c++ source code,\nbut will be available to users who\nwant to know who created it.");
	lay->addWidget(comment1);
	QObject::connect(comment1,SIGNAL(madeChange()),this,SLOT(refChange()));
	ADDTOOLTIP(comment1,
		"This is where an author can sign and document a program.");
	comment1->setHighlight(FALSE);
	comment1->setFont(QFont(configs->queryFontN(),configs->queryFontS()));
	addTab(w,"Comments and Signature");

}

void
Globals::refChange()
{
	emit madeChange(0);
}

void
Globals::enterEvent(QEvent *)
{
        QString x = configs->queryFontN();
        if(x != header1->font().family() ||
           configs->queryFontS() != header1->font().pointSize())
        {
                header1->setFont(QFont(configs->queryFontN(),
                configs->queryFontS()));
                main1->setFont(QFont(configs->queryFontN(),
                configs->queryFontS()));
		comment1->setFont(QFont(configs->queryFontN(),
                configs->queryFontS()));
		freeHand->setFont(QFont(configs->queryFontN(),
                configs->queryFontS()));
	
	}
}


int
Globals::isEmpty()
{
    return queryHeader().isEmpty() && queryFunction().isEmpty() && queryComment().isEmpty() &&
	queryFreeHand().isEmpty();

}
