/*  $Id: Globals.h,v 1.5 1998/07/27 16:34:56 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef GLOBALS_H
#define GLOBALS_H

#include "main.h"
#include "SyntaxEdit.h"
#include <qtabdlg.h>


class
Globals : public QTabDialog
{
    private:
	Q_OBJECT
	SyntaxEdit *header1, *main1, *comment1, *freeHand;
    public:
	Globals(QWidget *parent=0, char *name=0);

       int isEmpty();

	void clear() { clearComment(); clearHeader(); clearFunction();
		       clearFreeHand(); }

	void setFonts(QFont fnt) 
	{ header1->setFont(fnt); main1->setFont(fnt); comment1->setFont(fnt); }
	void setAutoUpdate(bool p)
	{ header1->setAutoUpdate(p); 
	  main1->setAutoUpdate(p); comment1->setAutoUpdate(p);}

	void appendComment(const char *text) { comment1->append(text); }
	QString queryComment() { return comment1->text(); }
	void clearComment() { comment1->clear(); }

	void appendHeader(const char *text) { header1->append(text); }
	QString queryHeader() { return header1->text(); }
	void clearHeader() { header1->clear(); }
	
	void appendFunction(const char *text) { main1->append(text); }	
	void clearFunction() { main1->clear(); }
	QString queryFunction() { return main1->text(); }

    	void appendFreeHand(const char *text) { freeHand->append(text); }
    	void clearFreeHand() { freeHand->clear(); }
    	QString queryFreeHand() { return freeHand->text(); }

    protected:
	virtual void enterEvent(QEvent *e);

     public slots:
	void refChange();

    signals:
	void madeChange(int);
};

#endif
