/*  $Id: MembMod.h,v 1.4 1998/07/27 16:35:00 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef MEMBMOD_H
#define MEMBMOD_H

#include "main.h"
#include <qradiobt.h>
#include <qlined.h>
#include <qpushbt.h>
#include <qstring.h>
#include <qlabel.h>
#include <qchkbox.h>
#include <qbttngrp.h>

class
MemberModifiers : public QDialog
{
	Q_OBJECT
	QString *holdProto;
	int holdVirt, newd, holdMode;
	QPushButton *save, *cancel;
	QLineEdit *definition, *passon;
	QCheckBox *defined, *virtuel;
	QLabel *lab1,*lab2;
	QButtonGroup *mode;
	QRadioButton *priv, *prot, *pub, *sig, *slot;
    public:
	MemberModifiers(QWidget *parent, char *name) 
					: QDialog(parent,name,TRUE)
	{

		setGeometry(0,0,470,170);

		lab1 = new QLabel("Definition:",this,"lab");
		lab1->setGeometry(0,0,300,55);
		lab1->setAlignment(AlignTop | AlignLeft);
		lab1->setFrameStyle( QFrame::Panel | QFrame::Raised );

		lab2 = new QLabel("Base Intializer",this,"lab2");
		lab2->setGeometry(0,55,300,55);
                lab2->setAlignment(AlignTop | AlignLeft);
                lab2->setFrameStyle( QFrame::Panel | QFrame::Raised );

		save = new QPushButton("save",this,"save");
		save->setGeometry(0,140,235,30);
		QObject::connect(save,SIGNAL(clicked()),
	                         this,SLOT(saveMemb()));
	
		cancel = new QPushButton("cancel",this,"cancel");
		cancel->setGeometry(235,140,235,30);
		QObject::connect(cancel,SIGNAL(clicked()),
				   this,SLOT(cancelMemb()));

		definition = new QLineEdit(this,"definition");
		definition->setGeometry(20,20,260,30);

		passon = new QLineEdit(this,"passon");
		passon->setGeometry(20,75,260,30);

		virtuel = new QCheckBox("Virtual Member",this,"virtuel");
		virtuel->setGeometry(5,110,100,30);

		defined = new QCheckBox("Declared/Defined Here",this,
			"defined");
		defined->setGeometry(130,110,150,30);

		mode = new QButtonGroup("Mode",this,"mode");
		mode->setGeometry(310,0,150,140);
		QObject::connect(mode,SIGNAL(pressed(int)),
			         this,SLOT(modeChose(int)));	
	
		priv = new QRadioButton("Private",this);
		priv->setGeometry(320,20,130,20);
		mode->insert(priv);

		prot = new QRadioButton("Protected",this);
		prot->setGeometry(320,40,130,20);
		mode->insert(prot);
	
		pub  = new QRadioButton("Public",this);
		pub->setGeometry(320,60,130,20);
		mode->insert(pub);

		sig  = new QRadioButton("Signal",this);
		sig->setGeometry(320,80,130,20);
		mode->insert(sig);

		slot = new QRadioButton("Public Slot",this);
		slot->setGeometry(320,100,130,20);
		mode->insert(slot);
	}
	void
	getNew()
	{
		QRadioButton *t;
		
		definition->setText("");
		passon->setEnabled(TRUE);
		passon->setText("");
		virtuel->setChecked(FALSE);
		defined->setChecked(TRUE);
		newd = 1;
		holdMode = 2;
		for(int x = 0; x < 5; x++)
		{
			t = (QRadioButton *)mode->find(x);
			t->setChecked(FALSE);
		}
		t = (QRadioButton *)mode->find(holdMode);
		t->setChecked(TRUE);
		show();
	}
	void
	getModify(const char *p, const char *bi, int v,int m,int d)
	{
		QString b(p);
		b = b.left(b.find('(')); b = b.stripWhiteSpace();

		QRadioButton *t;

		definition->setText(p);
		if(b == "constructor")
		{
			passon->setEnabled(TRUE);
			passon->setText(bi);
		}
		else
		{
			passon->setEnabled(FALSE);
			passon->setText("");
		}

		virtuel->setChecked((bool)v);
		defined->setChecked((bool)d);
                for(int x = 0; x < 5; x++)
                {
                        t = (QRadioButton *)mode->find(x);
                        t->setChecked(FALSE);
                }
		t = (QRadioButton *)mode->find(m);
		t->setChecked(TRUE);
		newd = 0;
		holdMode = m;
		show();
	}
    public slots:
	void
	modeChose(int x)
	{
		holdMode = x;
	}

	void
	saveMemb()
	{
		emit member((char *)definition->text(),
			(char *)passon->text(),
			(int)virtuel->isChecked(),holdMode, 
			(int)defined->isChecked(),newd);
		hide();
	}			
	
	void
	cancelMemb()
	{
		hide();
	}
     signals:
	void member(char *proto, char *pass, int vir, int mod, int def, int n);
};

#endif
		
