/*  $Id: MenuBar.h,v 1.7 1998/07/30 22:14:57 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef MENUBAR_H
#define MENUBAR_H

#include "version.h"
#include "main.h"
#include "AboutScr.h"
#include "Hint.h"

#include <qprogdlg.h>
#include <qsocknot.h>

#ifdef __USE_KDE
        #include <kmenubar.h>
#else
        #include <qmenubar.h>
#endif


class
CompileWindow : public QMultiLineEdit
{
     public:
	CompileWindow(QWidget *p) : QMultiLineEdit(p) { }
        void goDown(char *p) { append(p); pageDown(FALSE); }
};

class
MenuBar : public QWidget
{
	Q_OBJECT
	int childPID;

	#ifdef __USE_KDE
		KMenuBar *theMenu;
	#else
		QMenuBar *theMenu;
	#endif

	QString currFile;
	QLabel *chang,*xyLabel;
	Hint *hintButt;
	QPushButton *shortCut;
        CompileWindow *compileWindow;
	QProgressDialog *level;
	QPopupMenu *fileMenu, *editMenu, *windowMenu, *helpMenu, *runMenu;
	BaseComponent *project;
	QString workingComp;
	int sigSlotId, configId, attribId; 
	int toolBarId, srcEdId, glbEdId, mnuEdId,projectId;
	QSocketNotifier *ntStanO, *ntStanE;
    void makeShortCuts();

   public:
	MenuBar(QWidget *parent=0, char *name=0);
	int clearWidgets();

    void showLevel(int x);
    void stepLevel();
    void hideLevel();
    int wasLevelCanceled();
   
    public slots:
	void xy(int,int);
	void copyComponent();
	void cutComponent();
	void pasteComponent();
	void importDialog();
	void exportDialog();
	void changeMade();
	void configDialog();
	void propertiesDialog();
	void gnuProject();
	void gnuWidget();
	void runProgram();
	int compileProgram(int,int=0);
	void debugProgram();
	void makeProgram();
	void makeProgramAll();
	void stopProgram();
	void projectGone();
	void saveAs();
	void revert();
	void saveSource();
	void openProject();
	void save();
	void helpDialog();
	void aboutDialog();
	void end();
	void showProject();
	void showToolBar();
	void showSigSlot();
	void showGlobal();
	void showSource();
	void showMenuBar();
	void idO(int);
	void idE(int);

	void raiseS();
	void lowerS();
	void lockS();

   protected:
	virtual bool event(QEvent *);
	virtual bool eventFilter(QObject *, QEvent *); 

   signals:
	void enoughStop();
};
#endif
