/*  $Id: MnuEditor.h,v 1.5 1998/07/27 16:35:00 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef MNUEDITOR_H
#define MNUEDITOR_H
#include "main.h"
#include "myListBox.h"
#include "MnuItem.h"
#include "Hint.h"
#include "components/BaseComp.h"
#include "components/LinkList.h"

class
MnuEditor : public QWidget
{
	Q_OBJECT
	int currLevel, passOn;
	private:
	 QComboBox *objSlotList, *objList;
	 QComboBox *slotList;
	 QListBox *shtcutList;
	 QPushButton *stpUp;
	 myListBox *mnuList;
	 Hint *hintButt;
	 QLineEdit *capt;
	 QLineEdit *nam;
	 QCheckBox *chkd;
	 QCheckBox *enab;
	 QCheckBox *altK, *ctlK, *sftK;
	 QPushButton *stpDown;
	 QPushButton *rmvMnuItem, *addMnuItem;
	 QLabel *label1;
	 QLabel *label2;
         int mnuListIsEmpty();
	 BaseComponent *bc;
	public:
	 MnuEditor(QWidget *parent=0, char *name=0);
	 void addObject(char *desc,int where=-2);
	 void addParent(char *desc);
	 void resetObj() 
	{ bc = 0; clearObjects(); objList->clear(); mnuList->clear(); }
	 void removeObject(int);
	 void changeParent(char *,int);
	 void changeObject(char *,int);
	 int getTop(int);
	protected:
         virtual void leaveEvent(QEvent *) { if(bc) bc->menuApplyAttribs(); }
	signals:
	public slots:
	 void clearObjects();
	 void changeToObject(int);
	 void choseSlotObj(int);
	 void upLevel();
	 void downLevel();
	 void takeEffect();
	 void rmvItm();
	 void addItm();
	 void clearList(); 
	 void takeEffect(int);
	 void takeEffect(const char *p);
	 void selectMnu(int x);
	 void choseTop(int);
	 void fillShrtCut();
};
#endif
