/*  $Id: MnuItem.cc,v 1.4 1998/07/27 16:35:00 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "MnuItem.h"

int MnuItem::wid = 0;

MnuItem::MnuItem(char *cap, char *na, int conO, int conS,
                char *scut, int chk, int ena, int lev) : QListBoxItem()
{
    captio = new QString(cap);
    nam = new QString(na);

    conObj = conO;
    conSlot = conS;

    shrtcut = new QString(scut);

    chkd = chk;
    enab = ena;
    level = lev;
}

MnuItem::MnuItem(int x)
{
	captio = new QString("");
	nam = new QString("");
	conObj = -1;
	conSlot = 0;
	shrtcut = new QString("");
	chkd = 0;
	enab = 1;
	level = x;
}

MnuItem::~MnuItem()
{
	delete captio;
	delete nam;
	delete shrtcut;
}

void
MnuItem::paint(QPainter *p)
{
        p->setFont(QFont(configs->queryFontN(), configs->queryFontS()));
        QFontMetrics fm = p->fontMetrics();
        int y = fm.ascent() + fm.leading() / 2;

        p->drawLine(0,configs->queryFontHeight()+1,
			wid,configs->queryFontHeight()+1);

	p->drawText(level*8,y,(char *)captio->data());
        p->drawText(wid/3,y,(char *)nam->data());
        p->drawText((wid/3)*2,y,(char *)shrtcut->data());
}

int
MnuItem::height(const QListBox *) const
{
        return configs->queryFontHeight() + 2;
}

int
MnuItem::width(const QListBox *lb) const
{
        if(!wid) wid = lb->width();
        return wid-5;
}

void
MnuItem::setItem(QString cap, QString na, int conO, int conS,
                QString scut, int chk, int ena, int lev)
{

        *captio = cap;
        *nam = na;

        conObj = conO;
        conSlot = conS;

        *shrtcut = scut;

        chkd = chk;
        enab = ena;
        level = lev;
}

