/*  $Id: ProjectViewer.h,v 1.3 1998/07/27 16:35:01 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef PROJECTVIEWER_H
#define PROJECTVIEWER_H

#define PROJECT_SEP 10
#include "main.h"
#include <qlist.h>
#include "myListBox.h"
#include "Hint.h"

class
RefBaseComp
{
	int _lev, _par, _vis, _ref;
   public:
	RefBaseComp(int l, int p, int i)
	{ _lev = l; _par = p; _vis = i; _ref=0;}
	int lev() { return _lev; }
	int par() { return _par; }
	
	int ref() { return _ref; }
	void setRef(int x) { _ref = x; }

	void setVis(int x) { _vis = x; }
	int isVis() { return _vis; }
};

class
ProjectItem : public QListBoxItem
{
	QString cptn;
	int level,isParent,isLast, myPosition, childShow, hasChanged;
	static int wid;
   public:
	ProjectItem(char *capt, int lev, int par, int pos, int sc, int chg)
	    { cptn = capt; level = lev; isParent = par; isLast = 0;
	      myPosition = pos; childShow = sc; hasChanged = chg; }

	char *retDesc() { return cptn.data(); }
	int queryPosition() { return myPosition; }
	int retLevel() { return level; }
	int retParent() { return isParent; }
	void setLast(int x) { isLast = x; }
	int retLast() { return isLast; }
        int validX(int x);
    protected:
	virtual void paint(QPainter *p);
	virtual int width(const QListBox *lb) const;
	virtual int height(const QListBox *lb) const;
};

class
ProjectViewer : public QWidget
{
	Q_OBJECT
	Hint *hintButt;
	QList<RefBaseComp> baseList;
	myListBox *projList;
     public:
	ProjectViewer(QWidget *parent, char *name);
	~ProjectViewer() { }

	void buildTree();
	void showBuiltTree();

	void clear() { projList->clear(); baseList.clear(); }
	int currentObj() 
	{ ProjectItem *i;
	  i = (ProjectItem *)projList->zItem(projList->currentItem()); 
	  return i->queryPosition(); }
	void removeObject(int x);
	void moveObject(int was, int is);
     protected:
	virtual void resizeEvent(QResizeEvent *e);
	virtual bool eventFilter(QObject *o, QEvent *e);
      public slots:
	void highlighted(int);
	void changeToObject(int x); 
};

#endif
