/*  $Id: SaveClass.cc,v 1.6 1998/07/30 00:07:25 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "SaveClass.h"
#include <qdir.h>


QString SaveClass::holdDir("");

SaveClass::SaveClass(char *name, char *stClss) : 
			QDialog(0,name,TRUE)
{
	setCaption("Save Class");
	resize(303,263);

	label2 = new QLabel(this, "label2");
	label2->setText("Starting Directory:");
       	label2->setFont(QFont("times",14));
	label2->setAlignment(AlignLeft | AlignTop);
	label2->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label2->setGeometry(7,52,293,72);

	label3 = new QLabel(this, "label3");
	label3->setText("Class Name:");
	label3->setFont(QFont("times",14));
	label3->setAlignment(AlignLeft | AlignTop);
	label3->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label3->setGeometry(8,129,292,73);
	
        sDir = new QLineEdit(this, "sDir");
        sDir->setFont(QFont("times",18));
	sDir->setText(holdDir.data());
        sDir->setFrame((bool)1);
        sDir->setGeometry(17,77,271,36);

	sClass = new QLineEdit(this, "sClass");
	sClass->setFont(QFont("times",18));
	if(stClss) sClass->setText(stClss);
	sClass->setFrame((bool)1);
	sClass->setGeometry(16,153,273,37);
	
	widgName = new QLabel(this, "widgName");
	widgName->setText(name);
	widgName->setFont(QFont("times",24));
	widgName->setAlignment(AlignHCenter | AlignVCenter);
	widgName->setFrameStyle(QFrame::Raised | QFrame::Panel);
	widgName->setGeometry(5,1,293,47);

	hintButt = new Hint("Source Saving:\nYou use this dialog to save source code of\nyour dialog to disk. First note what is being save in the top\nmost label there should be a name stating what this is\ngoing to effect. Then type in the directory you wish it to \ntry storing it in.Finally enter the classname of this \nobject (not the same as the object name). If there are no\nconflicts(ie existant files, it will be written).",this,"hintButt");
	hintButt->move(268,1);
	
	button1 = new QPushButton(this, "button1");
	button1->setText("&Cancel");
	button1->setFont(QFont("times",18));
	button1->setEnabled((bool)1);
	button1->setDefault((bool)0);
	button1->setAutoResize((bool)0);
	button1->setGeometry(203,208,100,48);
	
	button2 = new QPushButton(this, "button2");
	button2->setText("&Save");
	button2->setFont(QFont("times",18));
	button2->setEnabled((bool)1);
	button2->setDefault((bool)1);
	button2->setAutoResize((bool)0);
	button2->setGeometry(3,209,100,49);
	
	QObject::connect(button2,SIGNAL(clicked()),this,SLOT(accept()));
	QObject::connect(button1,SIGNAL(clicked()),this,SLOT(reject()));
}

QString
SaveClass::getSave()
{
    QString i = "";
    int x = 0;
    while(!x)
    {
	x = exec();
	if(x == Rejected)
	    return "";
	else
	{
	    if((QString)sClass->text() == "")
		x = 0;
	    else
	    {
		i = sDir->text();
		i += "/"; 
		i += sClass->text();
	    }
	}
    }

    // double check that it isn't empty, if so put in pwd
    QString tmpDir(sDir->text()); 
    if(tmpDir.isEmpty()) 
    {
	    i.insert(0,QDir::currentDirPath());
	    sDir->setText(QDir::currentDirPath());
    }

    holdDir = sDir->text();
    return i;
}

