/*  $Id: SigSlotEdit.h,v 1.3 1998/07/27 16:35:02 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef SIGSLOTEDIT_H
#define SIGSLOTEDIT_H

#include "main.h"
#include "myListBox.h"
#include "Hint.h"
#include "components/BaseComp.h"

#include <qcombo.h>
#include <qlabel.h>
#include <qradiobt.h>


class
SigSlotEditItem : public QListBoxItem
{
        int chk, ena;
        QString *capt;
     public:
        SigSlotEditItem(char *foo) : QListBoxItem()
        { ena = 1; chk = 0; capt= new QString (foo); }
	void setEna(int x) { ena = x; }
        void setChk(int x) { chk = x; }
        void toggle() { chk = !chk; }
	int statusChk() { return chk; }
	int statusEna() { return ena; }
	QString statusCapt() { return *capt; }
        virtual void paint(QPainter *);
        virtual int height(const QListBox *) const;
        virtual int width(const QListBox *) const;
};

class
SigSlotEdit : public QWidget
{
	 Q_OBJECT
	private:
	 BaseComponent *bcSig, *bcSlot;
	 QLabel *label2;
	 myListBox *sigList;
	 QLabel *label1;
	 myListBox *slotList;
	 int currentSlotObj;
	 Hint *hintButt;
	 QComboBox *slotObjList;
	 QComboBox *sigObjList;
	 QRadioButton *radio1;
	 QRadioButton *radio2;
	 void removeWhiteSpace(QString &);
	public:
	 SigSlotEdit(QWidget *parent=0, char *name=0);

	 void addObject(char *description, int change=1, int where=-1);
	 void clearObjects() { clearSigObj(); clearSlotObj(); }
	 void clearSigObj()  { sigObjList->clear(); }
	 void clearSlotObj() { slotObjList->clear();}
	 void removeObject(int x);
	 void removeSig(int x)  { sigObjList->removeItem(x);  }
	 void removeSlot(int x) { slotObjList->removeItem(x); }
	 void render(int);
	 void addSlot(QString, int);
	 void addSignal(QString);
	 void clearSlots() { slotList->clear(); }
	 void clearSignals() { sigList->clear(); }
	 void renderConnected();

	 int currSlotObj() { return slotObjList->currentItem(); }
	 int currSigObj() { return sigObjList->currentItem(); }
	 int currSig() { return sigList->currentItem(); }
	 int sigCount() { return sigList->count(); }
	 int slotCount() { return slotList->count(); }
	 QListBoxItem *slotAt(int x) { return slotList->zItem(x); }
	protected:
	 virtual void enterEvent(QEvent *e);
	 virtual void resizeEvent(QResizeEvent *e);
	 virtual bool eventFilter(QObject *, QEvent *e);
	signals:
	 void madeChange(int);
	public slots:
	 void oki(int) { renderConnected(); }
	 void choseSlotObj(int obj);
	 void changeToObject(int x);
	 void CSlotObj(int);
	 void choseSigObj(int obj);
};
#endif
