/*  $Id: SyntaxEdit.h,v 1.4 1998/08/30 18:46:32 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef SYNTAXEDIT_H
#define SYNTAXEDIT_H

#include "Hint.h"
#include <qmlined.h>
#include <qscrbar.h>

#include <iostream.h>

class
SyntaxEdit : public QMultiLineEdit
{
 	private:
        Q_OBJECT
	   bool HghLgh;
	   Hint *ht;

        public:
           SyntaxEdit(QWidget *parent, char *name, char *hint=0) :
                                QMultiLineEdit(parent,name) 
	{ht=0; HghLgh = TRUE; if(hint) ht = new Hint(hint,this,"ht"); }
	    void setHighlight(bool p) { HghLgh = p; }
            void toEnd(bool x) { end(x); }
            void toBegin(bool x) { home(x); }
         protected:
           virtual void keyReleaseEvent(QKeyEvent *k);
	   virtual void resizeEvent(QResizeEvent *e)
	   { QMultiLineEdit::resizeEvent(e);
	     if(ht)
	     {
		int more = 15;
		ht->move((width()-ht->width())-more,0); 
	     }
	     }

        signals:
           void madeChange();
};

#endif
