/*  $Id: BaseComp.cc,v 1.20 1998/08/30 18:48:32 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */


#define TOGRID(x) (x / snapTo)
#define CHKINC(x,y) if(toWrite.find(x) != -1 && includes.find(y) == -1) { QString i; i.sprintf("#include <%s>\n",y);includes += i.data(); }

#include "BaseComp.h"
#include "CompIO.h"

#include "qbitmap.h"
#include "pix/lock.h"

#include "LinkList.h"
#include "../SaveClass.h"
#include "zMenuBar.h"
#include <qkeycode.h>
#include "../SigSlo.h"
#include "../YesNo.h"
#include "KnownComp.h"

#include "../MenuBar.h"
extern MenuBar *menubar;

#include <qobjcoll.h>
#include <qregexp.h>
#include <qwidcoll.h>
#include <qfiledlg.h>
#include <qtooltip.h>
#ifdef __USE_KDE
#include <kapp.h>
#else
#include <qapp.h>
#endif

#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>

void comment(ofstream &, char *);

#if defined(FORCE_DYNLIB) || defined(__ELF__) || defined(AOUT)
#include <dlfcn.h>
#endif

/*
	ACTION
		0)	nothing, null, zip, zilch..
		1)	resizing (on the E)
		2)	resizing (on the W)
		3)	resizing (on the N)
		4)	resizing (on the S)
		5)	moving
		6) 	being opened (ie opening a .qtz)
		7)     	 resizing (on the SE)
		8) 	resizing (on the SW)
		9)	resizing (on the NE)
		10)	resizing (on the NW)
*/

//Used to designate a temp write (for simple compilation) and a full write
//(for saving as source)
int BaseComponent::isTemp = 0;

//Special provisions for different sets (kde initially)
QString BaseComponent::whichApp;

//The place the makefile is
QString BaseComponent::finalPath("");

// Generate Make's and Main?
int BaseComponent::gMM;

// This is the file I'm currently working on
ofstream BaseComponent::workingFile;

// This is the value within the snap to grid on the main widget
int BaseComponent::snapTo=0;

// Holds some data before put to Makefile
QString BaseComponent::MakeFile;

// Holds include data between writes
QString BaseComponent::includes;
// Hold special stuff to be put into the main function
QString BaseComponent::mainAux;

// This is the number of components on the layout
int BaseComponent::currPos=0;

//Current parent
int BaseComponent::currPar=0;
//current object
int BaseComponent::currObj=0;

// This is the point at which you click, and they are adjusted according to the
// grid if one exists
QPoint BaseComponent::click;
QPoint BaseComponent::perm;

// List of fonts
QStrList *BaseComponent::fontList = 0; 

// These are utilized in multiple component selection
int BaseComponent::mult_sel = 0;
QList<BaseComponent> BaseComponent::sel_list;

// This is the list of components currently in the "lists"
QList<int> BaseComponent::boxesList;

// This is the action being taken on the widget at the moment (documenation
// above)
COMP_ACTION BaseComponent::action;

//This is the widget that will be given setMainWidget() in the main function
int BaseComponent::mainWidget;

//This will count the number of preceding lines automatically put into a 
//function
int BaseComponent::genCount = 0;

//These are the program only cflags, lflags and target. You can find system
//wide ones in the configuration editor.
QString BaseComponent::CFlags = "";
QString BaseComponent::LFlags = "";
QString BaseComponent::target = "target";

#include <time.h>

BaseComponent::BaseComponent(QWidget *parent, char *name) 
    : QWidget(parent, name)
{

//Initialize variables
    myHeader = new QString(""); specClass = new QString(""); 
    libLocate = new QString(""); changed = new QString("");
    iconPix = new QString("");
    locked = 0;myPosition = -1;myMenu = 0;stretch=0; _vis=1; managed=0;
    _showChildren = 1; _level=0; boxesList.setAutoDelete(TRUE);
	
    /* I want to append some that are always defined */
    defList.setAutoDelete(TRUE);
    addWritten("Width"); addWritten("Height"); addWritten("Left"); 
    addWritten("Top"); addWritten("Name"); addWritten("Application");
    addWritten("Application");   
 
    myType = new QString;
    resetType();

    currentMemb = -1; 
    memberInfo = new LinkList;

    uiStyle = new QString("");
    tooltipData = new QString("");

    flag = 0; myLook = 0; paintee = 0; currPar = -1; _mode = M_PRIVATE;

//Set initial values
    if(parent) 
    {
	BaseComponent *tmpPar = (BaseComponent *)parent;
	setPosition(memberInfo->insertObject(tmpPar));
    }
    else
    {
	menuContent = new QList<QPopupMenu>;
	menuContent->setAutoDelete(TRUE);	
	setMouseTracking(TRUE);	
	setPosition(currPos);
	currPar = currPos;
    }
    ++currPos;

    if(!parent && (!mainWidget || !at(mainWidget))) mainWidget = myPosition;
    if(!parent) currObj = myPosition; 

    popMenu = new QPopupMenu;
    popMenu->insertItem("Attributes",this,SLOT(attShow()));
    popMenu->insertItem("Source Editor",this,SLOT(souShow()));
    popMenu->insertItem("Signal/Slot Editor",this,SLOT(sigShow()));
    QString p = queryQType(); if(!parent || p == "MenuBar")
        popMenu->insertItem("Menubar Editor",this,SLOT(menShow()));
    popMenu->insertSeparator();
  if(myPosition)
  {
    popMenu->insertItem("Raise",this,SLOT(raiseComp()));
    popMenu->insertItem("Lower",this,SLOT(lowerComp()));
    if(parent) lockId = popMenu->insertItem("Lock",this,SLOT(toggleLock()));
    popMenu->insertSeparator();
    popMenu->insertItem("Cut",this,SLOT(cutComp()));
    popMenu->insertItem("Copy",this,SLOT(copyComp()));
    popMenu->insertItem("Paste",this,SLOT(pasteComp()));
    popMenu->insertItem("Delete",this,SLOT(delShow()));
    popMenu->insertSeparator();
  }
    if(aboutComp()) popMenu->insertItem("About Component",this,SLOT(aboShow()));

    if(!myPosition)
    {
	fontList = (QStrList *) configs->queryFontList();
	snapTo = 0;CFlags = "";LFlags = "";target = "target";gMM = 1;
	#ifdef __USE_KDE
		setApp("KDE");
	#else
		setApp("Generic");
	#endif
	*uiStyle = "Default"; makeStyle(uiStyle);
    }
    else
    {*uiStyle=BaseComponent::at(mainWidget)->queryStyle(); makeStyle(uiStyle);}
    setFocusPolicy(QWidget::StrongFocus);

    QString newName = nextName(name,0);
    if(!parent && myPosition) menu->addParent(newName.data());
    setName(newName.data());
    fillBoxes();
    changeName(newName.data());

    if(action != A_OPEN)
    {
	projView->buildTree();
	QObject::connect(this,SIGNAL(currentW(int)),
		attrib,SLOT(changeToObject(int)));
	QObject::connect(this,SIGNAL(currentW(int)),
		source,SLOT(changeToObject(int)));
	QObject::connect(this,SIGNAL(currentW(int)), 
		sigSlot,SLOT(changeToObject(int)));
	QObject::connect(this,SIGNAL(currentW(int)),
		projView,SLOT(changeToObject(int)));
	QObject::connect(this,SIGNAL(currentW(int)),
		menu,SLOT(changeToObject(int)));
	QObject::connect(this,SIGNAL(currentW(int)),
		toolBar,SLOT(changeObj(int)));
	toolBar->setParent(myPosition);
    }
}

BaseComponent::~BaseComponent()
{
    hide();

    BaseComponent *par = (BaseComponent *) parentWidget();
    if(!par) par = this;

    //kill my children before I die
    QObjectList *p = queryList("BaseComponent",0,TRUE,FALSE);
    QObjectListIt p2(*p);
    at(0)->makeChange(myPosition);
    while(p2.current())
    {
	delete p2.current();
	++p2;
    }
    delete p;

    if(action != A_CLOSE)
    {
	if(myPosition > 0)
	{
	    currObj = myPosition -1;
	    if(currPar == myPosition && myPosition) 
		setCurrPar(prevParent(currPar));
	}
	if(myPosition == mainWidget) 
	    mainWidget = fromTopLev(toTopLev(myPosition)+1) == -1 ? 0 :
			 fromTopLev(toTopLev(myPosition)+1);

	memberInfo->remove(-1,this);
	sigSlot->removeObject(myPosition);
	attrib->removeObject(myPosition);
	menu->removeObject(myPosition);
	source->removeObject(myPosition);
        shiftPositions(myPosition);
	
	if(!parentWidget()) fillBoxes();
    }
    else
    {
	if(par->queryPosition() == currPar) boxesList.clear();
	currObj = 0;
	--currPos;
    }

    projView->removeObject(myPosition);

    QString i;
    i.sprintf("%s/QtEZ/temp%d.cpp",getenv("HOME"),this);
    unlink(i.data());
    i.sprintf("%s/QtEZ/temp%d.h",getenv("HOME"),this);
    unlink(i.data());
    i.sprintf("%s/QtEZ/temp%d.o",getenv("HOME"),this);
    unlink(i.data());
    i.sprintf("%s/QtEZ/htemp%d.cpp",getenv("HOME"),this);
    unlink(i.data());
    i.sprintf("%s/QtEZ/htemp%d.o",getenv("HOME"),this);
    unlink(i.data());
	
    if(myPosition > 0 && at(myPosition-1) && action != A_CLOSE)
    {
	at(myPosition-1)->giveFocus();
    }
    else
    {
	attrib->clearAttributes();
	menu->clearList();
    }

    delete specClass;
    delete iconPix;
    delete popMenu;	
    delete memberInfo;
    delete changed;
    delete myType;
    delete uiStyle;
    delete tooltipData;
    delete libLocate;
    delete myHeader;
    defList.clear();

    if(myMenu)
    {
	menuContent->clear();
	delete menuContent;
    }
    sel_list.removeRef(this);
}

void
BaseComponent::setPosition(int x)
{
    if(currObj == myPosition) currObj = x; 
    myPosition = x;
}

// This is to shift down when an object is deleted, so there isn't a space
// taken after it is deleted
void
BaseComponent::shiftPositions(int start)
{
    for(int x = start + 1; x < count(); x++) 
	at(x)->setPosition(at(x)->queryPosition() - 1);
    currPos--;
}

void
BaseComponent::setCurrPar(int x)
{
    currPar = x; 
    fillBoxes();
    if(!parentWidget()) menu->changeToObject(x); 
}

void
BaseComponent::fillBoxes()
{
    BaseComponent *par = at(currPar);
    if(!par)
    {
	if(currPar < 0) return;
	setCurrPar(prevParent(currPar));
    }

    int x;
    boxesList.clear();
    attrib->clearObjects();   source->clearObjects();
    menu->clearObjects();   sigSlot->clearObjects();

    for(x = 0; x < count(); x++)
    {
	if(at(x) && ((x == currPar || par->isMyChild(at(x))) ||
	   (!myPosition && !at(x)->parentWidget())))
	{
	    boxesList.append(new int(x));
	}
    }
    for(x = 0; x < count(); x++)
    {
	if(x != currPar && at(x) &&
	   (at(x)->queryLevel() == par->queryLevel() ||
	    at(x)->queryLevel() == par->queryLevel()-1))
	{
	    boxesList.append(new int(x));
	}
    }

    for(x = 0; x < boxesList.count(); x++)
    {
	    QString i = at(*boxesList.at(x))->qualifiedName();
	    if(at(*boxesList.at(x))->queryLevel() >
	       at(*boxesList.first())->queryLevel()) i.insert(0,"  ");
	    attrib->addObject(i.data());
	    source->addObject(i.data());
	    menu->addObject(i.data());
	    sigSlot->addObject(i.data());
    }

}

//From number relative the boxes to a real components position id
int
BaseComponent::boxToPosition(int toFind)
{
    int toRet=0;
    if(!at(currPar)) return toRet;

    if(toFind < boxesList.count()) toRet = *boxesList.at(toFind);
    return toRet;
}

//From number relative the real components position id to the boxes
int
BaseComponent::positionToBox(int toFind)
{
    int toRet = 0;
    if(!at(currPar)) return toRet;

    for(int x = 0; x < boxesList.count(); x++) 
	if(toFind == *boxesList.at(x)) toRet =  x;
    return toRet;
}

// Slot fallen into so that generic action can be taken before the table is
// filled
void
BaseComponent::showAttribs()
{
    if(currObj != myPosition) giveFocus();
    attrib->clearAttributes();
    attrib->render(FALSE);
    fillAttributes();
    attrib->render(TRUE);
}

//Change has been made to this a component
void 
BaseComponent::makeChange(int x)
{ 
    //Top most guy will emit it to the rest of the program 
    if(action != A_OPEN && !myPosition) 
    {
	emit changeMade();
	if(x) at(x)->makeChange(x);
    }

    BaseComponent *par = (BaseComponent *)parentWidget();
    //pass on to my parent that I have changed
    if(par) par->makeChange(par->queryPosition()); 

    QString oldChanged(changed->data());
    *myHeader = "";
    *changed = ""; 

    if(!oldChanged.isEmpty()) projView->showBuiltTree();
}

void
BaseComponent::applyAttribs()
{
    for(int x = 0; x < attrib->numVals(); x++)
       if(attrib->giveWritten(x)) addWritten(attrib->giveCapt(x).data());

    interpretAttributes();
    if(action != A_OPEN)
    {
	if(myLook) myLook->repaint();
	repaint();
    }
}

// This slot is fallen into when the main program asks for the combo box that
// reflects available functions
void
BaseComponent::showMembs()
{
    if(currObj != myPosition) giveFocus();
    fillMembs();
    if((currentMemb == -1 && memberInfo->count() >= 0) ||
       currentMemb >= memberInfo->count()) currentMemb = 0;
    if(currentMemb != -1)
    {
	source->changeToMemb(currentMemb);
    	fillSource();
    }
}

// This slot is used to place the source into memory
void
BaseComponent::applySource(int signalSlotEditor)
{
    if(currentMemb != -1 && !signalSlotEditor) saveSource();
    else if(signalSlotEditor) saveSigSlo();
}

void
BaseComponent::fillSlotTable()
{
    source->renderSlots(0);
    sigSlot->render(0);
    source->clearSlots();
    sigSlot->clearSlots();
    for(int y = 0, x = 0; x < memberInfo->count(); x++)
    {
	if(memberInfo->mode(x) == M_PUB_SLOT || memberInfo->mode(x) == M_SIGNAL)
	{
	    source->addSlot(*memberInfo->memb(x),
			    at(currObj)->memberInfo->connected(
				SignalConnect(currObj,  
					      source->queryCurrentMemb(),  
					      myPosition,y++)));
	    sigSlot->addSlot(memberInfo->membName(x), memberInfo->mode(x));
	}
    }
    sigSlot->render(1);
    source->renderSlots(1);
}

void
BaseComponent::fillSigTable()
{
    sigSlot->render(0);
    sigSlot->clearSignals();
    for(int x = 0; x < memberInfo->count(); x++)
    {
	if(memberInfo->mode(x) == M_SIGNAL)
	    sigSlot->addSignal(memberInfo->membName(x));
    }
    if(currObj != myPosition) giveFocus();
    sigSlot->render(1);
}

void
BaseComponent::showSource(int memb)
{
    currentMemb = memb;
    fillSource();
}

void
BaseComponent::fillMembs()
{
    source->clearMembs();
    int t;
    for(int x = 0; x < memberInfo->count(); x++)
    {
	t = 0;
	if(memberInfo->mode(x) == M_SIGNAL)
	    t = 2;
	else if(!memberInfo->define(x))
	    t = 3;
	else if(memberInfo->isReadOnly(x))
	    t = 4;
	else if(!memberInfo->source(x)->isEmpty())
	    t = 1;
	source->addMemb(memberInfo->memb(x)->data(),t);
    }
}

void
BaseComponent::fillSource()
{
    if(currentMemb > memberInfo->count()-1) return;

    source->setMembInfo(memberInfo->header().data(),
			memberInfo->source(currentMemb)->data(),
			memberInfo->baseInit(currentMemb)->data(),
			memberInfo->virt(currentMemb),
			memberInfo->mode(currentMemb),
			memberInfo->define(currentMemb),
			memberInfo->isReadOnly(currentMemb));
}

void
BaseComponent::saveSource()
{
	memberInfo->setSource(currentMemb, source->querySource());
}

void
BaseComponent::saveSigSlo()
{
    SigSlotEditItem *t;

    SignalConnect toConn;
    toConn.setSigOwner(myPosition);
    toConn.setSlotOwner(boxToPosition(sigSlot->currSlotObj()));
    toConn.setSig(memberInfo->signal(sigSlot->currSig()));

    for(int y = 0; y < sigSlot->slotCount(); y++)
    {
	toConn.setSlot(y);
	t = (SigSlotEditItem *)sigSlot->slotAt(y);

	memberInfo->setConnect(toConn,t->statusChk());
    }
}

void
BaseComponent::modifyMenu(int where, QString cap, QString na, int conO, 
			  int conS, QString scut, int chk, int ena, int lev)
{
    memberInfo->modifyMenu(where,cap,na,conO,conS,scut,chk,ena,lev);
    if(action != A_OPEN) makeMenu();
}

void
BaseComponent::makeMenu()
{
    if(parentWidget() || !canHaveChildren()) return; 

    at(0)->makeChange(myPosition);

    if(!myMenu)
    {
	myMenu = new zMenuBar(this);
	myMenu->show();
    }

    menuContent->clear();
    myMenu->queryBar()->clear();
	
    int workLev,lastLev=0,toWrite=-1,cnt =-1;
    QList<QPopupMenu> popStack;
    for(int currItem = 0; currItem < memberInfo->menuCount(); currItem++)
    {
	workLev = memberInfo->menu(currItem)->queryLev();
	if(!workLev)
	{
	    int y = currItem;
	    if(y != memberInfo->menuCount()-1) y++;

	    menuContent->append(new QPopupMenu(0,
				       memberInfo->menu(y)->queryName()));
	    popStack.append(menuContent->last());

	    menuContent->last()->setCheckable(TRUE);
            QString s = memberInfo->menu(currItem)->queryCapt();

            if(s == "-")
                myMenu->queryBar()->insertSeparator();
            else
                myMenu->queryBar()->insertItem(
                    memberInfo->menu(currItem)->queryCapt(),
                    menuContent->last(),currItem);
	}
	else if(workLev == lastLev)
	{
	    QString c = memberInfo->menu(currItem)->queryCapt();
	    if(c == "-")
		popStack.last()->insertSeparator();
	    else
	    {
		popStack.last()->insertItem(c.data(),currItem);
		popStack.last()->connectItem(currItem,this,SLOT(menShow()));
		popStack.last()->setItemChecked(
		    currItem,(bool)memberInfo->menu(currItem)->queryChk());
		popStack.last()->setItemEnabled(
		    currItem,(bool)memberInfo->menu(currItem)->queryEna());
	    }
	}
	else if(workLev > lastLev)
	{
	    if(workLev != 1)
	    {
		QPopupMenu *lastPop = popStack.last();
		menuContent->append(new QPopupMenu(0,
				   memberInfo->menu(currItem)->queryName()));
		popStack.append(menuContent->last());

		menuContent->last()->insertItem(
		    memberInfo->menu(currItem)->queryCapt(),currItem);
                menuContent->last()->setCheckable(TRUE);
                menuContent->last()->setItemChecked(
                    currItem,(bool)memberInfo->menu(currItem)->queryChk());
                menuContent->last()->setItemEnabled(
                    currItem,(bool)memberInfo->menu(currItem)->queryEna());
                menuContent->last()->connectItem(currItem,this,SLOT(menShow()));

		QString t = lastPop->text(lastPop->idAt(lastPop->count()-1));
		lastPop->removeItemAt(lastPop->count()-1);
		lastPop->insertItem(t.data(),menuContent->last(),currItem);
	    }
	    else
	    {
		menuContent->last()->insertItem(
		    memberInfo->menu(currItem)->queryCapt(),currItem);
		menuContent->last()->connectItem(currItem,this,SLOT(menShow()));
		menuContent->last()->setItemChecked(
		    currItem,(bool)memberInfo->menu(currItem)->queryChk());
		menuContent->last()->setItemEnabled(
		    currItem,(bool)memberInfo->menu(currItem)->queryEna());
	    }
	}
	else if(workLev < lastLev)
	{
	    for(int y = 0; y < lastLev-workLev; y++) popStack.removeLast();
	    popStack.last()->insertItem(
		memberInfo->menu(currItem)->queryCapt(),currItem);
	    popStack.last()->connectItem(currItem,this,SLOT(menShow()));
	    popStack.last()->setItemChecked(
		currItem,(bool)memberInfo->menu(currItem)->queryChk());
	    popStack.last()->setItemEnabled(
		currItem,(bool)memberInfo->menu(currItem)->queryEna());
	}

	lastLev = workLev;
    }
}
			
void
BaseComponent::insertMenu(int where)
{
    memberInfo->insertMenu(where);
    makeMenu();
}

void
BaseComponent::removeMenu(int where)
{
    memberInfo->removeMenu(where);
    makeMenu();
}

char
*BaseComponent::getClassName(char *maind)
{
    static QString i;

    if(isTemp)	
    {
	if(!hasChanged())
	{
	    i = changed->data(); 
	    i = i.left(i.find(' ')+1); i = i.left(i.findRev('/')+1);
	    i += queryYType();    
	}
	else
	    i.sprintf("%s/QtEZ/temp%d",getenv("HOME"),this);
    }
    else
    {
	if(!queryPosition())
	    i = maind;
	else
	    i = openFile();
    }

    //If for some reason the component demands a static class name
    //then it will be used with the above dir selected.
    if(staticClass() && isTemp)
    {
	QString t(i.left(i.findRev('/')+1).data());
	i.sprintf("%s%s",t.data(), staticClass());
    }

    QString className = i.right((i.length() - i.findRev('/'))-1);
    className = className.left(className.findRev('.'));
    *myType = className.data();

    return i.data();

#if 0
    if(isTemp && !hasChanged())
    {
        i = changed->data();
        i = i.right((i.length() - i.find(' '))-1);
        hpName = i.left(i.findRev('/')+1);
        hfName = i.right((i.length() - i.findRev('/'))-1);
        hfName = hfName.left(hfName.findRev('.'));

        i = changed->data();
        i = i.left(i.find(' ')+1);
        cpName = i.left(i.findRev('/')+1);
        cfName = i.right((i.length() - i.findRev('/'))-1);
        cfName = cfName.left(cfName.findRev('.'));
    }
#endif
}

//each component that has children or has some functions defined will be 
//instructed to writeYourself() when necesary. This will include calling the 
//virtual function writeInits() maind is to set the dir where the main.cpp, 
//main.h and Makefile will reside: mocd is what needs to be appended to the 
//makefile object list
void
BaseComponent::writeYourself(QString *filename, QString *maind,QString *mocd)
{
    consCount = 0;
    int x, xxx;
    int tempSigO, tempSlotO, tempSig, tempSlot,out;
    QObjectList *p = queryList("BaseComponent",0,TRUE,FALSE);
    QObjectListIt listIt(*p);

    LinkList *tempList;
    BaseComponent *temp;
    includes = "";

    QString pathName, className, i, mainPath;
    QString cpName, cfName, hpName, hfName;
    if(isTemp && !hasChanged())
    {
        i = changed->data();
        i = i.right((i.length() - i.find(' '))-1);
        hpName = i.left(i.findRev('/')+1);
        hfName = i.right((i.length() - i.findRev('/'))-1);
        hfName = hfName.left(hfName.findRev('.'));

        i = changed->data();
        i = i.left(i.find(' ')+1);
        cpName = i.left(i.findRev('/')+1);
        cfName = i.right((i.length() - i.findRev('/'))-1);
        cfName = cfName.left(cfName.findRev('.'));
    }

    QString topL = maind->data();
    topL = topL.right((topL.length() - topL.findRev('/'))-1);
    topL = topL.left(topL.findRev('.'));

    mainPath = maind->left(maind->findRev('/')+1).data();
    *maind = "";

    if(filename->isEmpty()) return;
	
    pathName = filename->left(filename->findRev('/')+1);

    className = filename->right((filename->length()-filename->findRev('/'))-1);
    className = className.left(className.findRev('.'));

    //Decide widget's header's filename
    if(hasChanged() || !isTemp)
    {
	    i.sprintf("%s%s.h",pathName.data(),className.data());
	    i = openFile(i,pathName,isTemp);
	    hpName = i.left(i.findRev('/')+1);
	    hfName = i.right((i.length() - i.findRev('/'))-1);
	    hfName = hfName.left(hfName.findRev('.'));
    }
    myHeader->sprintf("%s%s.h",hpName.data(),hfName.data());
	
    //Generate widget's main file
    i.sprintf("%s%s.cpp",pathName.data(),className.data());
    if(hasChanged() || !isTemp)
    {
	    i = openFile(i,pathName,isTemp);
	    cpName = i.left(i.findRev('/')+1);
	    cfName = i.right((i.length() - i.findRev('/'))-1);
	    cfName = cfName.left(cfName.findRev('.'));
    }
    i.sprintf("#include \"%s\"\n\n",myHeader->data());
    writeLine(i);
    for(x = 0; x < memberInfo->count(); x++)
    {
	QString b,bi;

	if(memberInfo->isDestructor(x))
	{
	    if(!memberInfo->source(x)->isEmpty())
	    {
		b = memberInfo->membNoDefs(x).data();
		b = b.right(b.length() - b.find('('));
		i.sprintf("%s::~%s%s\n",className.data(),
			  className.data(),b.data());
		writeLine(i);
		writeLine("{\n");
                	memberInfo->setStartLine(x,genCount);
		p->removeLast();
		i.sprintf("%s\n",memberInfo->source(x)->data());
		writeLine(i);
		writeLine("}\n\n");
	    }
	}
	else if(memberInfo->isConstructor(x))
	{			
	    b = memberInfo->membNoDefs(x).data(); 
	    b = b.right(b.length() - b.find('('));

	    bi = memberInfo->baseInit(x)->data();
  	    bi.replace(QRegExp("init"),
		specialInher() ? specialInher() : queryQType());
	    bi = parseInitSpecial(bi);

	    if(!bi.isEmpty())
		i.sprintf("%s::%s%s \n\t: %s\n",
			  className.data(), className.data(),
			  b.data(),bi.data());
	    else
		i.sprintf("%s::%s%s\n\n",
			  className.data(),className.data(),b.data());

	    writeLine(i);
	    writeLine("{\n");
	    memberInfo->setStartLine(x,genCount);
	    p->insert(0,this);
	    listIt = *p; listIt.toFirst();


	    //instantiate all my children
	    while(listIt.current())
	    {
		temp = (BaseComponent *) listIt.current();
           
		if(temp != this && temp->instantiate())
		{
		    QString a;
		    QString type = temp->specialInher() 
			&& temp->noFuncs() ? 
			temp->specialInher() :
			temp->queryYType();


		    if(a = temp->specialInit())
		    {
			i.sprintf("%s = new %s%s;\n",
				  temp->name(), type.data(),
				  a.data());
		    }
		    else
		    {
			i.sprintf(
			    "%s = new %s(this, \"%s\");\n",
			    temp->name(), 
			    type.data(),
			    temp->name());
		    }
		    writeLine(i);
		}
		else
		    writeInits();

		if(temp->noFuncs() == TRUE) temp->writeInits();
		writeLine("\n");
		++listIt;
	    }

	    //if I have a menubar, do that
	    if(myMenu) 
	    {
		myMenu->writeMenus();
		writeLine("\n");
	    }

	    //handle grid layout if requested
	    if(isManaged())
	    {
		i.sprintf("myGrid = new QGridLayout(this,%d,%d,0,-1,\"myGrid\");\n",
			  width()/snapTo,height()/snapTo);
		writeLine(i);

		for(x = 0; x < count(); x++)
		{
		    temp = at(x);
		    if(!isMyChild(temp)) continue;

		    i.sprintf("myGrid->addMultiCellWidget(%s,%d,%d,%d,%d);\n",
			      temp->name(),
/*from/to row */	      TOGRID(temp->y()),TOGRID(temp->y()+temp->height()),
/*from/to col */	      TOGRID(temp->x()),TOGRID(temp->x()+temp->width()));
		    writeLine(i);
		}
	    }

	    //signal/slot connections
	    listIt = *p;
	    QString sigOwn, slotOwn;
	    for(int zax = 0; zax < count(); zax++)
	    {
		temp = at(zax);
		tempList = temp->membInfo();
		for(int y = 0; y < tempList->connectCount(); y++)
		{
		    tempSigO  = tempList->connect(y)->querySigOwner();
		    tempSig   = tempList->connect(y)->querySig();
		    tempSlotO = tempList->connect(y)->querySlotOwner();
		    tempSlot  = tempList->connect(y)->querySlot();

		    BaseComponent *par = (BaseComponent *) parentWidget();

		    QString tempSLPar, tempSIPar;
		    if(at(tempSlotO)->parentWidget())	
			tempSLPar = at(tempSlotO)->parentWidget()->name();
		    if(at(tempSigO)->parentWidget())
			tempSIPar = at(tempSigO)->parentWidget()->name();

		    if(tempSlotO == myPosition)
			slotOwn = "this";
		    else if(par && par->queryPosition() == tempSlotO)
			slotOwn = "parentWidget()";
		    else if(!tempSLPar.isNull() && tempSLPar != name() &&
			    tempSLPar != tempSIPar)
			slotOwn.sprintf("%s->%s", tempSLPar.data(),
					at(tempSlotO)->name());
		    else
			slotOwn = at(tempSlotO)->name();

		    if(tempSigO == myPosition)
			sigOwn = "this";
		    else if(par && par->queryPosition() == tempSigO)
			sigOwn = "parentWidget()";
		    else if(!tempSIPar.isNull() && tempSIPar != name() &&
			    tempSLPar != tempSIPar)
			sigOwn.sprintf("%s->%s", tempSIPar.data(),
				       at(tempSigO)->name());
		    else
			sigOwn = at(tempSigO)->name();
			
//If the signal and slot are me, or one of my children...
		    if((at(tempSlotO) == this || isMyChild(at(tempSlotO))) &&
		       (at( tempSigO) == this || isMyChild(at( tempSigO)))   
//The following tangled shite just says if the slot isn't empty and it is  
//defined within this class, please connect it 
                   && (( !at(tempSlotO)->membInfo()->
                       source(at(tempSlotO)->membInfo()->
                              signalSlot(tempSlot))->isEmpty() ||
                       !at(tempSlotO)->membInfo()->
                       define(at(tempSlotO)->membInfo()->
                              signalSlot(tempSlot))) ||
                at(tempSlotO)->membInfo()->mode(at(tempSlotO)->membInfo()->
                              signalSlot(tempSlot)) == M_SIGNAL ))
                {
			i.sprintf(
		    "QObject::connect(%s,SIGNAL(%s),\n\t\t%s,%s);\n",
			    sigOwn.data(),
                            at(tempSigO)->membInfo()->membName(tempSig).data(),
			    slotOwn.data(),
			    at(tempSlotO)->membInfo()->signalSlotStr(tempSlot));
			writeLine(i);
		    }
		}
	    }
	    p->removeLast();

	    if(numChildren() || !noFuncs()) postWriteInits();

	    consCount = genCount - memberInfo->startLine(x);
	    i = memberInfo->source(x)->data();
	    i.replace(QRegExp("\n"),"\n\t");
	    writeLine(i);
	    writeLine("\n}\n\n");
	}
    }
    for(x = 0; x < memberInfo->count(); x++)
    {
	if(!memberInfo->source(x)->isEmpty() && !memberInfo->isConstructor(x) &&
	   !memberInfo->isDestructor(x))
	{
	    writeLine(memberInfo->retType(x));

	    QString mbmPart; 
	    mbmPart.sprintf("\n%s::", className.data());

	    QString rghtPart = memberInfo->membNoDefs(x).data();
	    i = rghtPart.data();
	    if(rghtPart.left(1) == "*" || rghtPart.left(1) == "&")
		i.insert(1,mbmPart.data());
	    else
		i.insert(0,mbmPart.data());
	    i+="\n";
	    writeLine(i);
	    writeLine("{\n");
	    memberInfo->setStartLine(x,genCount);
	    i = memberInfo->source(x)->data();
	    i.replace(QRegExp("\n"),"\n\t");
	    writeLine(i);
	    writeLine("\n}\n\n");
	}
	// if I don't write the function, set the startline to -1 
	else memberInfo->setStartLine(x,-1);
    }

    //Now actually generate header file
    if(hasChanged() || !isTemp) openFile(myHeader->data(),0,1);

    //This resets the iterator for the list to dump!
    delete p; p = queryList("BaseComponent",0,TRUE,FALSE);
    listIt = *p;

    writeLine("#ifndef QTEZ_OUTP\n");
    i.sprintf(" #define QTEZ_OUTP \"%s\"\n", __VERSION);
    writeLine(i);
    writeLine("#endif\n\n");
    i.sprintf("#ifndef %s_H\n",className.upper().data());
    writeLine(i);
    i.sprintf("#define %s_H\n\n",className.upper().data());
    writeLine(i);
    writeLine("/* Project Specific Includes */\n");
    i.sprintf("#include \"%smain.h\"\n",mainPath.data());
    writeLine(i);	
    for(x=myPosition+1; x < count(); x++)
    {
	//If the widget is my child
	if(isMyChild(at(x))) 
	{
	    if(!at(x)->noFuncs())
	    {
		i.sprintf("#include \"%s\"\n",at(x)->queryHeaderPath());
		writeLine(i);
	    }

	    if(at(x)->queryLibLocate() && at(x)->externalLinkage())
	    {
		QString incFil;
		incFil = at(x)->queryLibLocate(); 
		incFil.replace(QRegExp("\\.qtl"),".h");

		i.sprintf("#include \"%s\"\n",incFil.data());
		writeLine(i);
	    }
	}
    }
    writeLine("\n/* Library Includes */\n");
    writeLine(includes);
    if(!header().isEmpty())
    {
	    writeLine("\n/* Class Includes */\n");
	    writeLine(header());
	    writeLine("\n\n");
    }
    writeLine("\nclass\n");

    i.sprintf("%s : public %s\n",className.data(),
	specialInher() ? specialInher() : queryQType());
    writeLine(i);

    writeLine("{\n");
    out = 0;
    for(x = 0; x < memberInfo->count(); x++)
    {
	if(memberInfo->passInspection(x,M_PUB_SLOT))
	{
	    writeLine(" Q_OBJECT\n");
	    out = 1;
	}
	else if(memberInfo->mode(x) == M_SIGNAL && 
		memberInfo->define(x))
	{
	    writeLine(" Q_OBJECT\n");
	    out = 1;
	}
	if(out) break;
    }

    doDeclaration(M_PRIVATE,className);

    doDeclaration(M_PUBLIC,className);
    if(numChildren())
    {
	writeLine(" friend int main(int, char **);\n");
	BaseComponent *par = (BaseComponent *) parentWidget();
	while(par)
	{
		i.sprintf(" friend class %s;\n",par->specialInher() ?
                    par->specialInher() : par->queryYType());
		writeLine(i);
		par = (BaseComponent *) par->parentWidget();
	}
    }

    doDeclaration(M_PROTECTED,className);
	
    doDeclaration(M_SIGNAL,className);

    doDeclaration(M_PUB_SLOT,className);

    writeLine("};\n");
    writeLine("#endif\n");

    if(out)
    {
	mocd->sprintf("%s%s",hpName.data(),hfName.data());
	i.sprintf("%sh%s.cpp: %s%s.h\n",
		  hpName.data(),hfName.data(),
		  hpName.data(), hfName.data());
	MakeFile += i;
	i.sprintf("\t$(MOC) %s%s.h -o %sh%s.cpp\n\n",
		  hpName.data(),hfName.data(),hpName.data(),
		  hfName.data());	
	MakeFile += i;
    }

    maind->sprintf("%s%s",cpName.data(),cfName.data());
    i.sprintf("%s%s.o: %s%s.h\n\n",
              cpName.data(), cfName.data(),hpName.data(),hfName.data());
    MakeFile += i;

    //I need to think a little about this, but for now the only thing
    //affected by the changing is the temporary writes, basically because
    //I assume if you dump it to source it's a one way trip for now.
    if(isTemp) 
	changed->sprintf("%s%s.cpp %s%s.h",cpName.data(), cfName.data(),
			 hpName.data(), hfName.data());
    delete p;
}

void
BaseComponent::newMemb(char *proto, char *bi, int virt, int mode, int def)
{
    memberInfo->add(proto, bi, "", virt,mode, def);
    for(int x = 0; x < memberInfo->count(); x++)
	if(*memberInfo->memb(x) == proto) currentMemb = x;
    fillSigTable();
    showMembs();
    at(0)->makeChange(myPosition);
}

void
BaseComponent::modMemb(char *proto,char *bi, int virt, int mode, int def,int fu)
{
    memberInfo->setMemb(fu,proto);
    memberInfo->setBaseInit(fu,bi);
    memberInfo->setVirt(fu,virt);
    memberInfo->setMode(fu,mode);
    memberInfo->setDef(fu,def);
    fillSigTable();
    showMembs();
    at(0)->makeChange(myPosition);
}

void
BaseComponent::delMemb(int fu)
{
    memberInfo->remove(fu,this);
    showMembs();
    fillSigTable();
    fillSlotTable();
    at(0)->makeChange(myPosition);
}

//build a list and return it of all the slots in me in a linked list of strings
//make sure to delete right away
QStrList
*BaseComponent::querySlots()
{
    QStrList *p = new QStrList(TRUE);
    for(int x = 0; x < memberInfo->count(); x++)
	if(memberInfo->mode(x) == M_PUB_SLOT) 
	    p->append(memberInfo->memb(x)->data());
    return p;
}

LinkList
*BaseComponent::membInfo()
{
    return memberInfo;
}

int
BaseComponent::numChildren(bool recursive)
{
    QObjectList *ol = queryList("BaseComponent",0,TRUE,recursive);
    int toRet = ol->count();
    delete ol;

    return toRet;
}

int
BaseComponent::isMyChild(BaseComponent *e)
{
    QObjectList *ol = queryList("BaseComponent",0,TRUE,FALSE);
    int toRet = ol->findRef(e) == -1 ? 0 : 1;
    delete ol;

    return toRet;
}

//returns id of the next component that has children after from
int
BaseComponent::nextParent(int from)
{
    int toRet = -1;

    for(int x = from+1; toRet == -1 && x < count(); x++)
    {
	if(at(x) && at(x)->numChildren() && 
	   at(x)->queryLevel() <= at(from)->queryLevel())  toRet = x;
    }
    return toRet;
}

//return the id of the component immediatly before from with children of its own.
int
BaseComponent::prevParent(int from)
{
    int toRet = -1;

    for(int x = from-1; toRet == -1 && x >= 0; x--)
    {
	if(at(x) && at(x)->numChildren())  toRet = x;
    }
    return toRet;
}

//returns true if this object has no defined functions
bool
BaseComponent::noFuncs()
{
    int y = 0;
    for(int x = 0; x < memberInfo->count(); x++)
    {
	if((!memberInfo->define(x) || 
	    memberInfo->source(x)->isEmpty()) && !numChildren())
	    y++;
    }
    return (bool) (y == memberInfo->count());
}

//instructs set to write itself in a source format to be compiled.
void
BaseComponent::writeToFile(int temporary)
{
    isTemp = temporary;
    memberInfo->fixConnections();
	
    int out,x;
    QString i(3000),hold,*t = new QString("");
    QString pathName;
    BaseComponent *temp;
	 
    QString mMoc = "", mSrc = ""; mainAux = "";

    //Generate seperate files
    MakeFile = "";

    //this goes along with the other comment about changed garbage
    if(isTemp)
    {
	if(hasChanged())
	    i.sprintf("%s/QtEZ/temp%d",getenv("HOME"),this);
	else
	    i = changed->left(changed->find(' ')+1);
    }
    /* This is to ask where the main.h, main.cpp, and Makefile should go */
    else 
	i = openFile();
	
    if(i.isEmpty() || i.isNull() || i == "/") return;

    //If for some reason the component demands a static class name
    //then it will be used with the above dir selected.
    if(staticClass() && isTemp)
    {
	QString t = i.data();
	i.sprintf("%s%s",t.left(t.findRev('/')+1).data(),staticClass());
    }	

    pathName = i.data();
    QList<QString> files; files.setAutoDelete(TRUE); QList<BaseComponent> ref;
    for(x = count()-1; x >= 0; x--)
    {
	temp = at(x);
	if(temp->hasChanged() || !isTemp) temp->resetType();
	QString p = temp->queryQType();
	if(!temp->noFuncs() || p.isEmpty())	
	{
	    ref.append(temp); 
	    files.append(new QString(temp->getClassName(pathName.data())));
	}
    }
    /* Loop through forwards so children are created first, so parents can
       include their children's files. */
    while(files.first())
    {
	ref.first()->writeYourself(files.first(),&i,t); 
	files.removeFirst(); ref.removeFirst();
	if(!i.isEmpty() && !i.isNull()) 
 	{
	    mSrc += i;
	    mSrc += ".foo ";
	} 
	if(!t->isEmpty())
	{
	    mMoc += t->data();	
	    mMoc += ".foo ";
	}
	*t = "";
	i = pathName.data(); 
    }
    pathName = i.left(i.findRev('/')+1).data();
	
    if(pathName.isNull() || !at(mainWidget)->genMakMain()) return;

    includes = "";

    //decide main header filename
    i.sprintf("%smain.h",pathName.data());
    QString mhInc(openFile(i,pathName,isTemp).data());

    //Generate the main code file
    if(hasChanged() || !isTemp) 
    {
	int xy;
	i.sprintf("%smain.cpp",pathName.data());
	openFile(i,pathName,isTemp);
	i.sprintf("%smain.foo ",pathName.data());
	mSrc += i;
	writeLine("/* Main Include */\n");
	i.sprintf("#include \"%s\"\n\n",mhInc.data());
	writeLine(i);
	writeLine("/* Top Level Widget Includes */\n");
	for(xy = 0; xy < count(); xy++)
	{
	    QString testHP = at(xy)->queryHeaderPath();
	    if((!at(xy)->parentWidget() && 
		(!at(xy)->noFuncs() || at(xy)->numChildren())) && !testHP.isEmpty())
	    {
		i.sprintf("#include \"%s\"\n",testHP.data());
		writeLine(i);
	    }
	}
	writeLine("\n/* Function Definitions (globals editor)*/\n");
	i = global->queryFreeHand().data();
	writeLine(i);
	writeLine("\n\nint\n");
	writeLine("main(int argc,char **argv)\n");
	writeLine("{\n");

	for(xy = 0; xy < count(); xy++)
	{	
	    temp = at(xy);
	    if(!temp->parentWidget() && temp->instantiate())
	    {
		QString a;
		QString type = temp->specialInher()
		    && temp->noFuncs() ?
		    temp->specialInher() :
		    temp->queryYType();
		if(a = temp->specialInit())
		{
		    i.sprintf("%s %s%s;\n",
			      type.data(),temp->name(),a.data());
		}
		else
		{
		    i.sprintf(
			"%s %s(0, \"%s\");\n",
			type.data(),temp->name(),temp->name());
		}
		writeLine(i);
		if(temp->noFuncs() && !temp->numChildren()) temp->writeInits();
	    }
	}
	writeLine("\n");

	int tempSig, tempSigO, tempSlot, tempSlotO;
	QString sigOwn, slotOwn;
	for(int zax = 0; zax < count(); zax++)
	{
	    temp = at(zax);
	    LinkList *tempList = temp->membInfo();
	    for(int y = 0; y < tempList->connectCount(); 
		y++)
	    {
		tempSigO  = tempList->connect(y)->querySigOwner();
		tempSig   = tempList->connect(y)->querySig();
		tempSlotO = tempList->connect(y)->querySlotOwner();
		tempSlot  = tempList->connect(y)->querySlot();

		BaseComponent *par = (BaseComponent *) parentWidget();

		QString tempSLPar, tempSIPar;
		if(at(tempSlotO)->parentWidget())	
		    tempSLPar = at(tempSlotO)->parentWidget()->name();
		if(at(tempSigO)->parentWidget())
		    tempSIPar = at(tempSigO)->parentWidget()->name();

		if(tempSlotO == -1)
		    slotOwn.sprintf("&%s",at(0)->name());
		else if(at(tempSlotO) && at(tempSlotO)->parentWidget())
                    slotOwn.sprintf("%s.%s",
                     at(tempSlotO)->parentWidget()->name(),
                     at(tempSlotO)->name());
		else
		    slotOwn.sprintf("&%s",at(tempSlotO)->name());

		if(tempSigO == -1)
		    sigOwn.sprintf("&%s",at(0)->name());
		else if(at(tempSigO) && at(tempSigO)->parentWidget())
                    sigOwn.sprintf("%s.%s",
                     at(tempSigO)->parentWidget()->name(),
                     at(tempSigO)->name());
		else
		    sigOwn.sprintf("&%s",at(tempSigO)->name());
			
//If the signal or slot eminates from a top level or a top level's 
//immediate child and is pointed at another top level widget or another
//top level's immediate child.
		    if(((!at(tempSlotO)->parentWidget() || 
			!at(tempSigO)->parentWidget()) &&
			(tempSigO != tempSlotO && 
			 !at(tempSlotO)->isMyChild(at(tempSigO)) &&
		         !at(tempSigO)->isMyChild(at(tempSlotO))))
//The following tangled shite just says if the slot isn't empty and it is  
//defined within this class, please connect it   
		   && (
			( !at(tempSlotO)->membInfo()->
		       source(at(tempSlotO)->membInfo()->
			      signalSlot(tempSlot))->isEmpty() ||
		       !at(tempSlotO)->membInfo()->
		       define(at(tempSlotO)->membInfo()->
			      signalSlot(tempSlot))) ||
		at(tempSlotO)->membInfo()->mode(at(tempSlotO)->membInfo()->
                              signalSlot(tempSlot)) == M_SIGNAL ))
		{     
                        i.sprintf(
                    "QObject::connect(%s,SIGNAL(%s),\n\t\t%s,%s);\n",
                            sigOwn.data(),
                            at(tempSigO)->membInfo()->membName(tempSig).data(),
                            slotOwn.data(),
                            at(tempSlotO)->membInfo()->signalSlotStr(tempSlot));                        writeLine(i);
		}
    	    }
	}
	writeLine(mainAux);
	i.sprintf("\n%s.setMainWidget(&%s);\n",
		  at(0)->name(), at(mainWidget)->name());
	writeLine(i);			
	i = global->queryFunction().data();
	writeLine(i);
	i.sprintf("%s.show();\n",at(mainWidget)->name());
	writeLine(i);
	i.sprintf("return %s.exec();\n",at(0)->name());
	writeLine(i);
	writeLine("}\n");
    }        
    else
    {
	i.sprintf("%smain.foo ",pathName.data());
	mSrc += i;
    }

    //Now actually generate main.h
    openFile(mhInc,0,1);
    writeLine("#ifndef MAINHEADER_H\n#define MAINHEADER_H\n\n");
    writeLine("/* Main Header Includes */\n");
    i = global->queryHeader().data();
    writeLine(i);
    writeLine("\n/* Main.cpp Includes*/\n");
    writeLine(includes);
    writeLine("\n#endif\n");

    //Generate the Makefile
    finalPath = pathName.data();
    i.sprintf("%sMakefile",pathName.data());
    openFile(i,pathName,isTemp);
    i.sprintf("CC = %s\n",configs->queryCPP());
    writeLine(i);
	
    QString other("");
    for(x = 0; x < count(); x++)
    {
	if(at(x)->queryLibLocate() && at(x)->externalLinkage())
	{
	    i = at(x)->queryLibLocate(); 
	    i.replace(QRegExp("\\.qtl"),".a ");
	    other += i.data();
	}
    }
    if(!other.isEmpty())
    {
	i.sprintf("OTHER_OBJ = %s\n",other.data());
	writeLine(i);
    }

    i.sprintf("CFLAGS = -I%s %s %s",configs->queryQtInc(), configs->queryCFlags(),CFlags.data());

    if(configs->queryShouldDebug()) 
	i += "-g";
    if(BaseComponent::queryApp() == "KDE")
    {
	QString t;
	t.sprintf(" -I%s",
		  configs->queryKDEInc());
	i.append(t.data());
    }
    i.append("\n");
    writeLine(i);

    i.sprintf("LFLAGS = -L%s %s %s -lqt",
	      configs->queryQtLib(),configs->queryLFlags(),LFlags.data());
    if(BaseComponent::queryApp() == "KDE")
    {
	QString t;
	t.sprintf(" -L%s -lkdeui -lkdecore -L%s -lXext -lX11",
		configs->queryKDELib(), configs->queryXLib());
	i.append(t.data());
    }
    i.append("\n");
    writeLine(i);

    if(!mMoc.isEmpty())
    {
	i.sprintf("MOC = %s\n\n",configs->queryMoc());
	writeLine(i);
	mMoc.replace(QRegExp("\\.foo"),".h");
	i.sprintf("MOCSRC = %s\n",mMoc.data());
	writeLine(i);
	mMoc.replace(QRegExp("\\.h"),".cpp");
	out = 0;
	while((out = mMoc.find(" ",out)) != -1 )
	{ 
	    int where = mMoc.findRev("/",out)+1;
	    mMoc.insert(where,"h"); 
	    out += 2; //move beyond space found
	}
	i.sprintf("MOC_CC = %s\n",mMoc.data());
	writeLine(i);
	mMoc.replace(QRegExp("\\.cpp"),".o");
	i.sprintf("MOC_OBJ = %s\n\n",mMoc.data());
	writeLine(i); 
    }
    else writeLine("\n");
    
    mSrc.replace(QRegExp("\\.foo"),".cpp"); i.resize(3000);
    i.sprintf("SRC = %s\n",mSrc.data());
    writeLine(i);
    mSrc.replace(QRegExp("\\.cpp"),".o"); i.resize(3000);
    i.sprintf("OBJ = %s %s %s\n",mMoc.isEmpty() ? "" : "$(MOC_CC)",
	      mSrc.data(),other.isEmpty() ? "" : "$(OTHER_OBJ)");
    writeLine(i);
    i.sprintf("TARGET = %s\n",target.data());
    writeLine(i);
    writeLine(".SUFFIXES: .cpp\n\n");

    writeLine(".cpp.o: $(SRC)\n\t$(CC) $(CFLAGS) -c $*.cpp -o $@\n\n");
    writeLine("all: $(TARGET)\n\n");
    writeLine("tarclean:\n\trm -f $(TARGET) core\n\n");
    i.sprintf("clean:\n\trm -f $(OBJ) %s\n\n",mMoc.isEmpty() ? "" : "$(MOC_CC)");
    writeLine(i);
    writeLine("distclean: clean\n\trm -f core *~ $(TARGET)\n\n");
    i.sprintf("$(TARGET): tarclean %s $(OBJ)\n\trm -f $(TARGET)\n",
	      mMoc.isEmpty() ? "" : "$(MOC_CC)");
    writeLine(i);
    writeLine("\t$(CC) $(CFLAGS) -o $(TARGET) $(OBJ) $(LFLAGS)\n\n");
    writeLine(MakeFile);	

    workingFile.close();
    delete t;

    projView->showBuiltTree();
}

QString 
BaseComponent::openFile(QString toOpen, QString pdir, int overWrite)
{
    int ok = 0;
    QString temp = toOpen,k;

    if(toOpen.isEmpty())
    {
	SaveClass p((char *)name(),queryStaticClass());

	do
	{
	    ok = 0;
	    toOpen = p.getSave();
	    if(!toOpen.isEmpty())
	    {
		struct stat fdStat;
		QString pth;
		pth = toOpen.left(toOpen.findRev('/')+1).data();
		if(stat(pth.data(),&fdStat) == -1)
		{
		    if(mkdir(pth.data(),0755) == -1)
		    {
			QMessageBox blah;
			blah.setText("Failure.");
			blah.show();
			ok = 1;
		    }
		}
		else
		{
		    if(!(fdStat.st_mode & S_IFDIR))
		    {
			QMessageBox blah;
			blah.setText("Not a dir.");
			blah.show();
			ok = 1;
		    }
		}	
	    }
	    else
		toOpen = "";
	} while(ok);

    }
    else
    {
	do
	{
	    toOpen = temp;

	    workingFile.close();
	    workingFile.open(toOpen.data(),ios::noreplace);
	    if(workingFile.fail() && !overWrite && 
	       !configs->queryOverWrite())
	    {
		YesNo yn(0,"yn");
				
		k.sprintf("Overwrite %s?",toOpen.data());
		if(!yn.doit(k.data()))
		{
		    temp = QFileDialog::getSaveFileName(
			pdir.data());
		    if(temp.isNull()) temp = "";
		    toOpen = "";
		}
	    }
	} while(toOpen.isEmpty());
	workingFile.close();
	workingFile.open(toOpen.data());
	k = toOpen.right(toOpen.length()-toOpen.findRev('.'));
	if(k == ".cpp" || k == ".h")
	{
	    //Standard Header Garbage
	    time_t *t = new time_t; time(t);
	    writeLine(
		"/***********************************************\n");
	    writeLine(
		"** Source Dump From QtEZ http://qtez.zax.net/qtez\n");
	    writeLine(
		"** ---------------------------------------------\n");
	    k.sprintf("** Dumped: %s",ctime(t));
	    writeLine(k.data());
	    k.sprintf("**     To: %s\n",toOpen.data());
	    writeLine(k.data());
	    k.sprintf("**     By: %s\n",getenv("USER"));
	    writeLine(k.data());
	    writeLine(
		"***********************************************/\n\n");
	    delete t;
	}
    }
    genCount = 0;
    return toOpen;
}

void
BaseComponent::writeInParent(QString toWrite)	
{
	if(!numChildren() && noFuncs())
	{
		toWrite.insert(0, parentWidget() ? "->" : "." );
	        toWrite.insert(0,name());
	}
	writeLine(toWrite);
}

void
BaseComponent::writeLine(QString toWrite, int tab)
{
    static int workingLevel = 0;

    genCount += toWrite.contains('\n');

    if(toWrite.find('}') != -1) workingLevel--;
    if(tab) { for(int x = 0; x < workingLevel; x++) toWrite.insert(0,'\t'); }

    if(hasChanged() || !isTemp) workingFile << toWrite;
//For Debugging
//  if(hasChanged() || !isTemp) cout << toWrite;

    if(toWrite.find('{') != -1) workingLevel++;

    //Qt stuff
    CHKINC("QButtonGroup","qbttngrp.h")
	CHKINC("QSocketNotifier","qsocknot.h")
	CHKINC("QDialog","qdialog.h")
	CHKINC("QPainter","qpainter.h")
	CHKINC("QWidget","qwidget.h")
	CHKINC("QSlider","qslider.h")
	CHKINC("QMultiLineEdit","qmlined.h")
	CHKINC("QTimer","qtimer.h")
	CHKINC("QList","qlist.h")
	CHKINC("QScrollBar","qscrbar.h")
	CHKINC("QRadioButton","qradiobt.h")
	CHKINC("QListBox","qlistbox.h")
	CHKINC("QCheckBox","qchkbox.h")
	CHKINC("QMenuBar","qmenubar.h")
	CHKINC("QPopupMenu","qpopmenu.h")
	CHKINC("Key_","qkeycode.h")
	CHKINC("QComboBox","qcombo.h")
	CHKINC("QLCDNumber","qlcdnum.h")
	CHKINC("QMessageBox","qmsgbox.h")
	CHKINC("QString","qstring.h")
	CHKINC("QPushButton","qpushbt.h")
	CHKINC("QLabel","qlabel.h")
	CHKINC("QLineEdit","qlined.h")
	CHKINC("QPixmap","qpixmap.h")
	CHKINC("QApplication","qapp.h")
	CHKINC("QToolTip","qtooltip.h")
	CHKINC("QGridLayout","qlayout.h")
	CHKINC("QFileDialog","qfiledlg.h")

	//KDE stuff
        CHKINC("KApplication","kapp.h")
        CHKINC("KMenuBar","kmenubar.h")
	}
	
void
BaseComponent::changeName(char *p, int check)
{
    BaseComponent *par = (BaseComponent *)parentWidget();
    if(!par) par = this;
    int too = par->queryPosition() + par->numChildren(TRUE);

    QString t(p),i; t.replace(QRegExp("[ \t\n\\*]"),"");

    int match = 0, fnum1, fnum2;

    if(check && t != name())
    {
	fnum1 = t.find('[');

	for(int x = par->queryPosition(); x < too; x++)
	{
	    if(!par->isMyChild(at(x))) continue;

	    i = at(x)->name();
	    fnum2 = i.find('[');

	    if(fnum2 != -1 && fnum1 == -1) i = i.left(fnum2);
		
	    if(t == i && x != myPosition)
	    {
		if(!match)
		{
		    QString yow;
		    yow.sprintf(
			"Name in use (%s).\nIncorporate into an array?"
			,p);

		    YesNo yn(0,"yn");
		    if(!yn.doit(yow.data())) return;
		    match = 1;
		    if(fnum1 != -1) t = t.left(fnum1);
		}	
		at(x)->changeName(
		    at(x)->nextName(t.data(),1).data(),0);
	    }
	}
    }
    if(configs->queryToolTips()) QToolTip::remove(this);
    if(match)
    {
	t = nextName(t.data(),1);
	i = qualifiedName(t.data());
	ADDTOOLTIP(this,i.data());
	setName(t.data());
	if(myLook) myLook->setName(t.data());
	if(!parentWidget()) menu->changeParent(i.data(),myPosition);
	if(at(currPar) == par)
	{
	    menu->changeObject(i.data(),myPosition-currPar);
	    attrib->changeObject(i.data(),myPosition-currPar);
	    source->changeObject(i.data(),myPosition-currPar);
	}
    }
    else
    {
	i = qualifiedName(p);
	ADDTOOLTIP(this,i.data());
	setName(t.data());
	if(myLook) myLook->setName(t.data());
	if(!parentWidget()) menu->changeParent(i.data(),myPosition);
	if(at(currPar) == par)
	{
	    menu->changeObject(i.data(),myPosition-currPar);
	    attrib->changeObject(i.data(),myPosition-currPar);
	    source->changeObject(i.data(),myPosition-currPar);
	}
    }
}

void
BaseComponent::makeStyle(GUIStyle e)
{
    setStyle(e);
    if(myLook) myLook->setStyle(e);
    if(!myPosition) 
#ifdef __USE_KDE	
	KApplication::setStyle(e);
#else
    QApplication::setStyle(e);
#endif

    if(e == MotifStyle)
	*uiStyle = "Motif";
    else if(e == WindowsStyle)
	*uiStyle = "Windows";
}
	
void
BaseComponent::makeStyle(QString *e)
{
    *uiStyle = e->data();

    if(*e == "Motif")
	setStyle(MotifStyle);
    else if(*e == "Windows")
	setStyle(WindowsStyle);
    else
    {
	setStyle(QApplication::style());
	*uiStyle = "Default";
    }

    if(myLook) myLook->setStyle(style());
    if(!myPosition) 
#ifdef __USE_KDE
	KApplication::setStyle(style());
#else
    QApplication::setStyle(style());
#endif
}

void
BaseComponent::setLook()
{
    if(action != A_OPEN)
    {
	fillBoxes();
	fillMembInfo();
    }
    installEventFilter(this);
    setMouseTracking(TRUE);
    setActive(0);
    changeName((char *)name());

    if(myPosition) 
    { *uiStyle=BaseComponent::at(mainWidget)->queryStyle(); makeStyle(uiStyle);}

    if(action != A_OPEN) at(0)->makeChange(myPosition);

    projView->buildTree();
}

void 
BaseComponent::setLook(QWidget *p)
{
    if(action != A_OPEN)
    {
	fillBoxes();
	fillMembInfo();
    }
    setActive(0);
	
    myLook = p;
    changeName((char *)name());
    if(myLook)
    {
	myLook->installEventFilter(this);
	myLook->setMouseTracking(TRUE);
    }

    if(myPosition) 
    { *uiStyle=BaseComponent::at(mainWidget)->queryStyle(); makeStyle(uiStyle);}

    if(action != A_OPEN) at(0)->makeChange(myPosition);
    repaint();
    projView->buildTree();
}

void
BaseComponent::setLook(QPixmap p)
{
    if(action != A_OPEN)
    {
	fillBoxes();
	fillMembInfo();
    }
    setActive(0);

    QLabel *fakeLook = new QLabel(this,name());
    fakeLook->setAlignment(AlignVCenter | AlignHCenter);
    fakeLook->setPixmap(p);
    fakeLook->installEventFilter(this);
    fakeLook->setMouseTracking(TRUE);
    fakeLook->setBackgroundColor(QColor("white"));
    myLook = fakeLook;
    changeName((char *)name());

    if(action != A_OPEN) at(0)->makeChange(myPosition);
    repaint();
    projView->buildTree();
}

bool
BaseComponent::loneWidget()
{
    return (bool)!myLook;
}

bool
BaseComponent::eventFilter(QObject *, QEvent *evt)
{
    QString p = queryQType();
    if(p != "MenuBar")
    {
	//Catch some mouse Actions
	if(evt->type() == Event_MouseButtonPress)
	    mousePressEvent((QMouseEvent *)evt);
	else if(evt->type() == Event_MouseButtonDblClick)
	    souShow();
	else if(evt->type() == Event_MouseMove)
	    mouseMoveEvent((QMouseEvent *)evt);
	else if(evt->type() == Event_MouseButtonRelease)
	    mouseReleaseEvent((QMouseEvent *)evt);
	else if(evt->type() == Event_Resize)
	{
	    if(locked) return TRUE;
	    if(myLook) itSized();
	    return FALSE;
	}
	else if(evt->type() == Event_Paint)
	{
	    //At first glance this looks REAL dumb, but it
	    //it is some magic done for the sake of having the
	    //8 dots show apropriatly.
	    if(invisibleComp()) hide();
	    if(paintee)
	    {
		paintee = 0;
		if(myLook) myLook->repaint();
		repaint();
		return TRUE;
	    }
	    else
	    {
		paintee = 1;
		return FALSE;
	    }
	}
	return TRUE;
    }
    else
    {
	if(evt->type() == Event_MouseButtonRelease)
	{
	    giveFocus();

	    QMouseEvent *me = (QMouseEvent *)evt;

	    if(me->button() == RightButton)
		popShow(mapToGlobal(me->pos()));
	    else if(me->button() == MidButton)
		lowerComp();
	}
	else if(evt->type() == Event_MouseButtonDblClick)
		souShow();
	return FALSE;
    }
}

void
BaseComponent::mouseMoveEvent (QMouseEvent *p)	
{
    QPoint gimp = mapToParent(p->pos());
    BaseComponent::at(0)->newXY(gimp.x(),gimp.y());

    //If it's locked set appropriate cursor and bail	
    if(locked)
    {
        QBitmap p;
        p.loadFromData((const unsigned char *)&lock_bmp_data,lock_bmp_len);
	QBitmap p2;
	p2.loadFromData((const unsigned char *)&lmask_bmp_data,lmask_bmp_len);
	myLook->setCursor(QCursor(p,p2));
	return;
    }

    //If it's a top level, just use the god given window decorations
    if(!parentWidget() && action != A_DRAW_SQUARE) return;

    //Draw pretty cursor representing action that will be taken
    if(!action)
    {	
	if(p->x() > width()-5 && p->y() > height()-5 && canResize())
	    myLook->setCursor(sizeFDiagCursor);
	else if(p->x() < 5 && p->y() > height()-5 && canResize())
	    myLook->setCursor(sizeBDiagCursor);
	else if(p->x() > width()-5 && p->y() < 5 && canResize())
	    myLook->setCursor(sizeBDiagCursor);
	else if(p->x() < 5 && p->y() < 5 && canResize())
	    myLook->setCursor(sizeFDiagCursor);
	else if(p->x() < 5 && canResize()) 
	    myLook->setCursor(sizeHorCursor);
	else if(p->x() > width()-5 && canResize())
	    myLook->setCursor(sizeHorCursor);
	else if(p->y() < 5 && canResize())
	    myLook->setCursor(sizeVerCursor);
	else if(p->y() > height()-5 && canResize())	
	    myLook->setCursor(sizeVerCursor);
	else
	    myLook->setCursor(sizeAllCursor);
    }

    QPoint mp = mapToParent(p->pos());
    int moveX = -1,moveY = -1;
    if(!snapTo)
    {
	//If there is no snap to, deciding legal move is easy.
	moveX = p->x();
	moveY = p->y();
    }
    else
    {
	int oldX = (int) x() / snapTo;
	int newX = (int) (mp.x() - perm.x()) / snapTo;
              
	int oldY = (int) y() / snapTo;
	int newY = (int) (mp.y() - perm.y()) / snapTo;

	if(action == A_MOVE)
	{
	    if(oldX != newX)
	    {
		at(0)->makeChange(myPosition);
		if(mult_sel)
		{
		    QPoint nXnY,mapNxNy;
		    mapNxNy=mapToParent(perm);

		    QListIterator<BaseComponent> it(sel_list);
		    for(;it.current();++it)
		    {
			nXnY=it.current()->mapFromParent(mapNxNy);
			it.current()->move(mp.x()-nXnY.x(),
					   it.current()->y());
		    }
		}
		else
		    move(mp.x()-perm.x(), y()); 
	    }
	    if(oldY != newY)
	    {
		at(0)->makeChange(myPosition);
		if(mult_sel)
		{
		    QPoint nXnY,mapNxNy;
		    mapNxNy=mapToParent(perm);

		    QListIterator<BaseComponent> it(sel_list);
		    for(;it.current();++it)
		    {
			nXnY=it.current()->mapFromParent(mapNxNy);
			it.current()->move(it.current()->x(),
					   mp.y()-nXnY.y());
		    }
		}
		else
		    move(x(), mp.y()-perm.y());
	    }
	    return;
	}

	if(click.x() / snapTo != p->x() / snapTo)
	{
	    moveY = click.y();
	    moveX = p->x();
	    click.setX(p->x());
	}
	if(click.y() / snapTo != p->y() / snapTo)
	{
	    moveX = click.x();
	    moveY = p->y();
	    click.setY(p->y());
	}
    }
	
    if(moveX != -1 || moveY != -1)
    {
	QPoint mapdOut = mapToParent(QPoint(moveX,moveY));
	if(action == A_DRAW_SQUARE)
	{
	    QRect rec(click.x(),click.y(),moveX-click.x(),moveY-click.y());
	    repaint(rec); if(myLook) myLook->repaint(rec);

	    QPainter p(myLook ? myLook : this);
	    p.setPen(red);
	    p.drawRect(rec);
	}
	else if(action == A_RESIZE_E)
	    setGeometry(mp.x(),y(),width()-moveX,height());
	else if(action == A_RESIZE_W)
	    setGeometry(x(),y(),moveX,height());
	else if(action == A_RESIZE_N)
	    setGeometry(x(),mp.y(),width(),height()-moveY);
	else if(action == A_RESIZE_S)
	    setGeometry(x(),y(),width(),moveY);
	else if(action == A_MOVE)
	{
	    if(mult_sel)
	    {
		QPoint nXnY,mapNxNy;
		mapNxNy=mapToParent(perm);

		QListIterator<BaseComponent> it(sel_list);
		for(;it.current();++it)
		{
		    nXnY=it.current()->mapFromParent(mapNxNy);
		    it.current()->move(mapdOut.x()-nXnY.x(),
				       mapdOut.y()-nXnY.y());
		}
	    }
	    else
	    {
		move(mapdOut.x() - perm.x(),  mapdOut.y() - perm.y());
	    }
	}
	else if(action == A_RESIZE_SE)
	    setGeometry(x(),y(),moveX, moveY);
	else if(action == A_RESIZE_SW)
	    setGeometry(mp.x(),y(),width()-moveX,moveY);
	else if(action == A_RESIZE_NE)
	    setGeometry(x(),mp.y(),moveX,height()-moveY);
	else if(action == A_RESIZE_NW)
	    setGeometry(mp.x(),mp.y(),width()-moveX,height()-moveY);

	if(action != A_NONE && action != A_DRAW_SQUARE) 
	    at(0)->makeChange(myPosition);
    }
}

void
BaseComponent::itSized()
{
    QString p = queryQType();
    if(p != "MenuBar" && !flag) resize(myLook->width(),myLook->height());
}

void 
BaseComponent::resizeEvent(QResizeEvent *)
{
    if(!flag && myLook)
    {
	flag = 1;
	myLook->setGeometry(0,0,width(),height());
	flag = 0;
    }
    if(myMenu && !parentWidget()) 
	myMenu->setGeometry(0,0,width(),myMenu->height());
    if(myLook) myLook->repaint();
    repaint();
}

void
BaseComponent::keyReleaseEvent (QKeyEvent *key)
{
    if(key->ascii() == 127)
	delShow();
    else if(key->key() == Key_Tab)
    {
	int nex = queryPosition() + 1;
	if(nex >= count()) nex = 0;
	at(nex)->giveFocus();
    }
    else if(key->key() == Key_M && key->state() == AltButton)
    {
	menu->show();
	menu->raise();
    }
    else if(key->key() == Key_C && key->state() == AltButton)
    {
	sigSlot->show();
	sigSlot->raise();
    }
    else if(key->key() == Key_H && key->state() == AltButton)
    {
	global->show();
	global->raise();
    }
    else if(key->key() == Key_A && key->state() == AltButton)
    {
	attrib->show();
	attrib->raise();
    }
    else if(key->key() == Key_S && key->state() == AltButton)
	souShow();
    else if(key->key() == Key_B && key->state() == AltButton)
    {
	memberInfo->lower(myPosition);
    }
    else if(key->key() == Key_Left || key->key() == Key_Right ||
	    key->key() == Key_Up || key->key() == Key_Down)
    {
	BaseComponent *par = (BaseComponent *)parentWidget();
	if(!par) return;
	int too = par->queryPosition() + par->numChildren(TRUE);

	int toMove = -1,diff=0;
	if(key->key() == Key_Right) diff=par->width();
	if(key->key() == Key_Left)  diff=-1;
	if(key->key() == Key_Down)  diff=par->height();
	if(key->key() == Key_Up)    diff=-1;

	for(int zz = par->queryPosition()+1,flag=0;zz<too;zz++,flag=0)
	{
	    if(!par->isMyChild(at(too))) continue;

	    if(key->key() == Key_Right &&
	       at(zz)->x() > x() && at(zz)->x() < diff)
		flag = 1;
	    if(key->key() == Key_Left &&
	       at(zz)->x()+at(zz)->width() < x() && 
	       at(zz)->x()+at(zz)->width() > diff)
		flag = 1;
	    if(key->key() == Key_Down &&
	       at(zz)->y() > y() && at(zz)->y() < diff)
		flag = 1;
	    if(key->key() == Key_Up &&
	       at(zz)->y()+at(zz)->height() < y() && 
	       at(zz)->y()+at(zz)->height() > diff)
		flag = 1;
	    if(flag)
	    {
		if(key->key() == Key_Left) 
		    diff=at(zz)->x()+at(zz)->width(); 
		if(key->key() == Key_Right)
		    diff=at(zz)->x();
		if(key->key() == Key_Up)
		    diff=at(zz)->y()+at(zz)->height();
		if(key->key() == Key_Down) 
		    diff=at(zz)->y();
		toMove=zz;
	    }
	}
	if(toMove != -1) at(toMove)->giveFocus(); 	
    }
    else
	key->ignore();
}

void
BaseComponent::addHead(char *f)
{
    global->appendHeader(f);
}

void 
BaseComponent::addMember(char *proto, char *bi="", char *source="", int virt=1,
			 int mode=1, int definedH=1)
{
    memberInfo->add(proto,bi,source,virt,mode,definedH);
}

void
BaseComponent::setActive(int x)
{
    int oldObj = currObj;
    if(x && currObj != myPosition)
    {
	currObj = myPosition;
	if(!mult_sel && at(oldObj)) at(oldObj)->setActive(0);

	if(myLook) myLook->repaint();
	repaint();
    }
    else if(!x)
    {
	sel_list.removeRef(this);
	if(myLook) myLook->repaint();
    }
}

void
BaseComponent::giveFocus(int doEmition)
{
    if(sel_list.findRef(this) == -1 && parentWidget())sel_list.append(this);

    //Setup children appropriatly
    BaseComponent *t = (BaseComponent *)parentWidget();
    if(numChildren() || !t) t = this;
    if(t->queryPosition() != queryCurrPar()) setCurrPar(t->queryPosition());

    setActive(1);
    currObj = myPosition;
    setFocus();

    if(doEmition) emit currentW(myPosition); 
}

void 
BaseComponent::mousePressEvent (QMouseEvent *p)
{
    BaseComponent *par = (BaseComponent *)parentWidget();
    if(!par) par = this;

    mult_sel = (p->state() == ShiftButton);
    if(!mult_sel)
    {
        while(sel_list.last()) sel_list.last()->setActive(0);
        sel_list.clear();
    }


    if(p->button() == LeftButton && !locked) 
    {	
	if(par != this) raise();
	grabMouse();
    }
    else if(p->button() == RightButton)
	popShow(mapToGlobal(p->pos()));
    else if(p->button() == MidButton && !locked)
    {
	memberInfo->lower(myPosition);
    }
    giveFocus(0);

    click.setX(p->x()); click.setY(p->y());
    perm.setX(p->x()); perm.setY(p->y());
    if(p->button() == LeftButton)
    {
	if(toolBar->currentPressed())
	    action = A_DRAW_SQUARE;
	else if(p->x() > width()-5 && p->y() > height()-5 && canResize())
	    action = A_RESIZE_SE;
	else if(p->x() < 5 && p->y() > height()-5 && canResize())
	    action = A_RESIZE_SW;
	else if(p->x() > width()-5 && p->y() < 5 && canResize())
	    action = A_RESIZE_NE;
	else if(p->x() < 5 && p->y() < 5 && canResize())
	    action = A_RESIZE_NW;
	else if(p->x() < 5 && canResize())
	    action = A_RESIZE_E;
	else if(p->x() > width()-5 && canResize())
	    action = A_RESIZE_W;
	else if(p->y() < 5 && canResize())
	    action = A_RESIZE_N;
	else if(p->y() > height()-5 && canResize())
	    action = A_RESIZE_S;
	else
	    action = A_MOVE;
    }
    repaint();
}	

void
BaseComponent::mouseReleaseEvent(QMouseEvent *e)
{
    cout << "released" << endl;
    releaseMouse();
    BaseComponent *par = (BaseComponent *)parentWidget();
    if(!par) par = this;

    if(e->button() == LeftButton && action == A_DRAW_SQUARE)
    {
	QRect rec(click.x(),click.y(),e->x()-click.x(),e->y()-click.y());
	if(rec.width() < 10) rec.setWidth(10);
	if(rec.height() < 10) rec.setHeight(10);

	repaint(rec); if(myLook) myLook->repaint(rec);

	BaseComponent *temp = ofType((BaseComponent *)this,toolBar->currentPressed());
	if(temp->canResize())
	    temp->setGeometry(rec);
	else
	    temp->move(click.x(),click.y());
	temp->show();
	toolBar->resetPressed();
    }
    action = A_NONE;

    showAttribs();

    if(!locked && e->button() == LeftButton && parentWidget()) raiseComp();
    giveFocus();
}

void
BaseComponent::setSnapTo(int newSnap)
{
    if(newSnap != snapTo && newSnap)
    {
        QObjectList *p = queryList("BaseComponent",0,TRUE,FALSE);
        QObjectListIt p2(*p);
	QWidget *temp;
        while(p2.current())
        {
	    QRect t;
	    temp = (QWidget *)p2.current();
	    //Snap each widget to the grid points
	    t.setLeft((int)((temp->x()/newSnap)+1)*newSnap);
	    t.setTop((int)((temp->y()/newSnap)+1)*newSnap);
	    t.setWidth((int)((temp->width()/newSnap)+1)*newSnap);
	    t.setHeight((int)((temp->height()/newSnap)+1)*newSnap);
	    temp->setGeometry(t);

	    ++p2;
        }
	delete p;
    }
    snapTo = newSnap;
}

void
BaseComponent::paintEvent(QPaintEvent *)
{
    if(parentWidget() && sel_list.findRef(this) != -1)
    {
	QColor col(255,0,0);

	QPainter paint;
	paint.begin(myLook ? myLook : this);
	paint.setBrush(col);

	//corners
	paint.fillRect(0,0,5,5,QBrush(col,SolidPattern));
	paint.fillRect(width()-5,0,5,5,QBrush(col,
					      SolidPattern));
	paint.fillRect(0,height()-5,5,5,QBrush(col,
					       SolidPattern));
	paint.fillRect(width()-5,height()-5,5,5,QBrush(col,
						       SolidPattern));
	//centers
	paint.fillRect((width()/2)-2,0,5,5,QBrush(col,
						  SolidPattern));
	paint.fillRect((width()/2)-2,height()-5,5,5,
		       QBrush(col, SolidPattern));
	paint.fillRect(0,(height()/2)-2,5,5,QBrush(col,
						   SolidPattern));
	paint.fillRect(width()-5,(height()/2)-2,5,5,
		       QBrush(col, SolidPattern));
	paint.end();
    }
    if(!parentWidget() && snapTo)
    {
	QPainter paint;
	paint.begin(myLook ? myLook : this);
	paint.setPen(black);

	int x,y;
	for(x = 0; x < width(); x+=snapTo)
	    for(y = 0; y < height(); y+=snapTo)
		paint.drawPoint(x,y);
	
	paint.end();
    }
}

void
BaseComponent::genericFillAttrib()
{
     QWidget *theLook = myLook ? myLook : this;
     ADDATTRIB("Name",(char *)theLook->name(),W_TEXT);

     ADDATTRIB("Specific Classname",queryStaticClass(),W_TEXT);

    if(!parentWidget() && myPosition) 
    {
 	ADDATTRIB("Main Widget",mainWidget == myPosition,W_TRUE);

 	ADDATTRIB("Caption",(char *)this->caption(),W_TEXT);

 	ADDATTRIB("Icon", iconPix->data(),W_FILE);
    }

     if((numChildren() && myPosition) || queryAction() == A_OPEN)
    {
 	ADDATTRIB("Snap-To", snapTo, W_LIST,9,
		  "None","4","6","8","10","15","20","25","30");

 	ADDATTRIB("Grid Managed", managed, W_TRUE);
    }

    if(!myPosition)
    {
	ADDATTRIB("Executable Name",target.data(),W_TEXT);

	ADDATTRIB("Program CFlags",CFlags.data(),W_TEXT);

	ADDATTRIB("Program LFlags",LFlags.data(),W_TEXT);
         
        ADDATTRIB("Application",BaseComponent::queryApp().data(),
                  W_LIST,2, "Generic", "KDE");

        ADDATTRIB("Generate MakeFile/Main",(bool) gMM,W_TRUE);
    }

    if((!locked || action == A_SAVE) && myPosition)
    {
	    if(parentWidget())
	    {
		    ADDATTRIB("Left",x(),W_TEXT);

		    ADDATTRIB("Top",y(),W_TEXT);
	    }
	    if(canResize() || !parentWidget())
	    {
		    ADDATTRIB("Width",width(),W_TEXT);
		    ADDATTRIB("Height",height(),W_TEXT);

		    QWidget *s = myLook ? myLook : this;

		    ADDATTRIB("Maximum Width", s->maximumSize().width(),W_TEXT);
		    ADDATTRIB("Maximum Height",s->maximumSize().height(),W_TEXT);

		    ADDATTRIB("Minimum Width", s->minimumSize().width(),W_TEXT);
		    ADDATTRIB("Minimum Height",s->minimumSize().height(),W_TEXT);
	    }
     }
	
    ADDATTRIB("Interface Style",uiStyle->data(),W_LIST,3,
	      "Default", "Windows", "Motif");

    if(parentWidget())
    {
	QString m = "Public";
	if(mode() == M_PUBLIC) m = "Public";
	else if(mode() == M_PRIVATE) m = "Private";
	else if(mode() == M_PUB_SLOT) m = "Public Slot";
	else if(mode() == M_SIGNAL) m = "Signal";
	else if(mode() == M_PROTECTED) m = "Protected";
	ADDATTRIB("Protection Mode",m.data(),W_LIST,5,
	          "Public","Private","Public Slot","Signal","Protected");
     }
}

void
BaseComponent::genericInterpAttrib()
{
    changeName(attrib->giveValue("Name").data());

    if(!myPosition)
    {
	target = attrib->giveValue("Executable Name");
		
	CFlags = attrib->giveValue("Program CFlags");
		
	LFlags = attrib->giveValue("Program LFlags");

        BaseComponent::setApp(
                 attrib->giveValue("Application").data());

        gMM = attrib->giveBoolValue("Generate MakeFile/Main");
    }

    if(!parentWidget() && myPosition) 
    {
	if(attrib->giveBoolValue("Main Widget") == TRUE) 
	    mainWidget = myPosition;

        setCaption(attrib->giveValue("Caption").data());

	*iconPix = attrib->giveValue("Icon");
	setIcon(*new QPixmap(iconPix->data()));
    }

    if((numChildren() && myPosition) || queryAction() == A_OPEN)
    {
	setSnapTo(attrib->giveIntValue("Snap-To"));	

        if(attrib->giveBoolValue("Grid Managed"))
	{
	    if(snapTo)
		managed = (int)attrib->giveBoolValue("Grid Managed");
	    else if(managed)
		managed = 0;
	    else
	    {
		QMessageBox p;
		p.setText("You should have a Snap-To assigned before\nusing grid management.");
		p.show();
	    }
	}
	else managed = 0;
    }


    if((!locked || action == A_OPEN) && myPosition)
    {
            if(parentWidget())
		move(attrib->giveIntValue("Left"), 
		     attrib->giveIntValue("Top"));
            
	    if(canResize() || !parentWidget())
	    {
		QWidget *s = myLook ? myLook : this;

		resize(
		    attrib->giveIntValue("Width") >= 0 ? 
		    attrib->giveIntValue("Width") : 0,
		    attrib->giveIntValue("Height")>= 0 ?
		    attrib->giveIntValue("Height"): 0);
		s->setMaximumWidth(
		    attrib->giveIntValue("Maximum Width") >= 0 ? 
		    attrib->giveIntValue("Maximum Width") : 0);
		s->setMaximumHeight(
		    attrib->giveIntValue("Maximum Height") >= 0 ?
		    attrib->giveIntValue("Maximum Height") : 0);
		s->setMinimumWidth(
		    attrib->giveIntValue("Minimum Width") >= 0 ?
		    attrib->giveIntValue("Minimum Width") : 0);
		s->setMinimumHeight(
		    attrib->giveIntValue("Minimum Height") >= 0 ?
		    attrib->giveIntValue("Minimum Height") : 0);
            }
     }

    setStaticClass(attrib->giveValue("Specific Classname").data());

    QString tmp = attrib->giveValue("Interface Style");
    makeStyle(&tmp);

    if(parentWidget())
    {
        QString setm = attrib->giveValue("Protection Mode"); 
	M_MODE m = M_PUBLIC;
        if(setm == "Public") m = M_PUBLIC;
        else if(setm == "Private") m = M_PRIVATE;
        else if(setm == "Public Slot") m = M_PUB_SLOT;
        else if(setm == "Signal") m = M_SIGNAL;
        else if(setm == "Protected") m = M_PROTECTED;
	setMode(m);
     }
}
	
void
BaseComponent::genericFillMembInfo()
{
    memberInfo->add("bool event(QEvent *p)");
    memberInfo->add("void mousePressEvent (QMouseEvent *m)");
    memberInfo->add("void mouseReleaseEvent (QMouseEvent *m)");
    memberInfo->add("void mouseDoubleClickEvent (QMouseEvent *m)");
    memberInfo->add("void mouseMoveEvent (QMouseEvent *m)");
    memberInfo->add("void keyPressEvent (QKeyEvent *k)");
    memberInfo->add("void keyReleaseEvent (QKeyEvent *k)");
    memberInfo->add("void focusInEvent (QFocusEvent *f)");
    memberInfo->add("void focusOutEvent (QFocusEvent *f)");
    memberInfo->add("void enterEvent (QEvent *e)");
    memberInfo->add("void leaveEvent (QEvent *e)");
    memberInfo->add("void paintEvent (QPaintEvent *p)");
    memberInfo->add("void moveEvent (QMoveEvent *m)");
    memberInfo->add("void resizeEvent(QResizeEvent *r)");
    memberInfo->add("void closeEvent (QCloseEvent *c)");
}

// Tells how many objects there are in an "array" in the ide.
int
BaseComponent::numElements(char *p)
{
    BaseComponent *par = (BaseComponent *)parentWidget();
    if(!par) par = this;
    int too = par->queryPosition() + par->numChildren(TRUE);

    QString i(p),t; int y = 0,fnum;
    for(int x = par->queryPosition(); x < too; x++)
    {
	if(!par->isMyChild(at(x))) continue;

	t = at(x)->name(); fnum = t.find('[');
	if(fnum != -1) t = t.left(fnum);

	if(i == t) y++;
    }
    return y;
}


char
*BaseComponent::qualifiedName(char *newName)
{
    static QString i;
    i.sprintf("%s %s%s",specialInher() ? specialInher() : queryQType(),
			parentWidget() ? "*" : "", newName ? newName : name());
    return i.data();
}

QString
BaseComponent::nextName(char *p, int array)
{
    int x,y;
    QString i;

    if(!array)
    {
	QString t; int fnum;
	i.sprintf("%s1",p);
	for(x = 0, y=1; x < count(); x++)
	{
	    if(at(x) && 
	      (at(x)->parentWidget() == parentWidget() || isMyChild(at(x))))
	    {
	        t = at(x)->name(); fnum = t.find('[');
		if(fnum != -1) t = t.left(fnum);
		if(i == t && x != myPosition) 
		{ i.sprintf("%s%d",p,++y); x=0; }
	    }
	}
    }
    else
    {
	i.sprintf("%s[0]",p);
	for(x = 0, y=0; x < count(); x++)
	{
            if(at(x)->parentWidget() == parentWidget() || isMyChild(at(x)))
            {
	        if(i == at(x)->name() && x != myPosition) 
	        {i.sprintf("%s[%d]",p,++y);x=0;}
	    }
	}
    }
    return i;
}

int
BaseComponent::toTopLev(int y)
{
    int flag = -1;

    if(y >= count()) return flag;

    for(int x = 0; x <= y; x++)
	if(!BaseComponent::at(x)->parentWidget()) flag++;
    return flag;			
}

int
BaseComponent::fromTopLev(int y)
{
    int flag = -1,x=-1,flag2 = -1;

    if(y >= count()) return flag;

    for(x = 0; x < count(); x++)
    {
	if(!BaseComponent::at(x)) continue;
	if(!BaseComponent::at(x)->parentWidget()) flag2++;
	if(flag2 == y)
	{
	    flag = x;
	    break;
	}
    }
    return flag;
}

BaseComponent
*BaseComponent::at(int x)
{
    if(x == -1) return 0;

    BaseComponent *now, *temp, *hold = 0;
#ifdef __USE_KDE
    QWidgetList  *list = KApplication::topLevelWidgets();
#else
    QWidgetList  *list = QApplication::topLevelWidgets();
#endif
    QWidgetListIt it( *list );  
    while (it.current()) 
    {
	if ( it.current()->inherits("BaseComponent") == TRUE )
	{
	    now = (BaseComponent *)it.current();	
	    if(now->queryPosition() == x) hold = now;
	    QObjectList *p = now->queryList(
		"BaseComponent",0,TRUE,TRUE);
	    QObjectListIt p2(*p);
	    while(p2.current())
	    {
		temp = (BaseComponent *) p2.current();
		if(temp->queryPosition() == x) hold = temp;
		++p2;
	    }
	    delete p;
	}
	++it;
    }
    delete list;
    return hold;
}

QString
BaseComponent::queryExecutable()
{
    return target;
}

void 
BaseComponent::writePalette(char *toWhom)
{
    int flag = 0; QString hold;
    for(int x = 0; !flag && x < defList.count(); x++)
    {
	hold = defList.at(x);
	if(hold.contains(QRegExp(".*Colour")) ||
	   hold.contains(QRegExp(".*Color"))) flag=1; 
    }
    if(!flag) return;

    QWidget *elook = myLook ? myLook : (QWidget *)this;

    QString i(3000);
    i.sprintf("setPalette(QPalette(\n\t  QColorGroup(QColor(%d,%d,%d), QColor(%d,%d,%d),\n\t  QColor(%d,%d,%d),QColor(%d,%d,%d),QColor(%d,%d,%d),\n\t  QColor(%d,%d,%d),QColor(%d,%d,%d)),\n\t  QColorGroup(QColor(%d,%d,%d), QColor(%d,%d,%d),\n\t  QColor(%d,%d,%d), QColor(%d,%d,%d), QColor(%d,%d,%d),\n\t  QColor(%d,%d,%d),QColor(%d,%d,%d)),\n\t  QColorGroup(QColor(%d,%d,%d), QColor(%d,%d,%d),\n\t  QColor(%d,%d,%d), QColor(%d,%d,%d), QColor(%d,%d,%d),\n\t  QColor(%d,%d,%d),QColor(%d,%d,%d))));\n",
	      elook->palette().normal().foreground().red(),
	      elook->palette().normal().foreground().green(),
	      elook->palette().normal().foreground().blue(),
	      elook->palette().normal().background().red(),
	      elook->palette().normal().background().green(),
	      elook->palette().normal().background().blue(),
	      elook->palette().normal().light().red(),
	      elook->palette().normal().light().green(),
	      elook->palette().normal().light().blue(),
	      elook->palette().normal().dark().red(),
	      elook->palette().normal().dark().green(),
	      elook->palette().normal().dark().blue(),
	      elook->palette().normal().mid().red(),
	      elook->palette().normal().mid().green(),
	      elook->palette().normal().mid().blue(),
	      elook->palette().normal().text().red(),
	      elook->palette().normal().text().green(),
	      elook->palette().normal().text().blue(),
	      elook->palette().normal().base().red(),
	      elook->palette().normal().base().green(),
	      elook->palette().normal().base().blue(),

	      elook->palette().disabled().foreground().red(),
	      elook->palette().disabled().foreground().green(),
	      elook->palette().disabled().foreground().blue(),
	      elook->palette().disabled().background().red(),
	      elook->palette().disabled().background().green(),
	      elook->palette().disabled().background().blue(),
	      elook->palette().disabled().light().red(),
	      elook->palette().disabled().light().green(),
	      elook->palette().disabled().light().blue(),
	      elook->palette().disabled().dark().red(),
	      elook->palette().disabled().dark().green(),
	      elook->palette().disabled().dark().blue(),
	      elook->palette().disabled().mid().red(),
	      elook->palette().disabled().mid().green(),
	      elook->palette().disabled().mid().blue(),
	      elook->palette().disabled().text().red(),
	      elook->palette().disabled().text().green(),
	      elook->palette().disabled().text().blue(),
	      elook->palette().disabled().base().red(),
	      elook->palette().disabled().base().green(),
	      elook->palette().disabled().base().blue(),

	      elook->palette().active().foreground().red(),
	      elook->palette().active().foreground().green(),
	      elook->palette().active().foreground().blue(),
	      elook->palette().active().background().red(),
	      elook->palette().active().background().green(),
	      elook->palette().active().background().blue(),
	      elook->palette().active().light().red(),
	      elook->palette().active().light().green(),
	      elook->palette().active().light().blue(),
	      elook->palette().active().dark().red(),
	      elook->palette().active().dark().green(),
	      elook->palette().active().dark().blue(),
	      elook->palette().active().mid().red(),
	      elook->palette().active().mid().green(),
	      elook->palette().active().mid().blue(),
	      elook->palette().active().text().red(),
	      elook->palette().active().text().green(),
	      elook->palette().active().text().blue(),
	      elook->palette().active().base().red(),
	      elook->palette().active().base().green(),
	      elook->palette().active().base().blue());

    if(!toWhom) writeInParent(i);
    else
    {
	QString toWrite = toWhom; toWrite += "->"; toWrite += i.data();
	writeLine(toWrite);
    }
	
}

void 
BaseComponent::setMenu(zMenuBar *x)
{
    if(myMenu)
    {
	menuContent->clear();
	delete myMenu;
    }
    myMenu = x;
}

void
BaseComponent::newXY(int x, int y)
{
    emit xyPos(x,y);
}

BaseComponent 
*BaseComponent::getLibComponent(BaseComponent *par, char *libLoc, void *keepHandle)
{
    BaseComponent *temp = 0;
    typedef BaseComponent* (*yourself_func)(QWidget *parent);
    yourself_func func = 0;

#if defined(FORCE_DYNLIB) || defined(__ELF__) || defined(AOUT)
    keepHandle = dlopen(libLoc,RTLD_NOW);
    if(!keepHandle)
    {
	QMessageBox p;
	p.setText(dlerror());
	p.show();
    }
    else if( (func = (yourself_func) dlsym(keepHandle,"yourself")) )
	temp = (*func)(par);
#endif
    return temp;
}

BaseComponent
*BaseComponent::findDynComponent(BaseComponent *par, QString ty)
{
    int fi;
    char *Buff = new char[150];

    BaseComponent *temp=0;

    QString i, fil(""), line;
    i.sprintf("%s/QtEZ/.QtEZLd",getenv("HOME"));
    ifstream p(i.data());
    if(p.fail()) return 0;
    while(p.getline(Buff,150,'\n'))
    {
	line = Buff;
	if((fi = line.find(';')) != -1 && line.at(0) != '#')
	{
	    void *handle;
	    fil = line.right(line.length()-(fi+1)).data();
	    temp = getLibComponent(par,fil.data(), handle);
	    if(temp && (ty == line.left(fi) || ty == temp->queryQType()))
	    {
		temp->setLibLocate(fil.data());
		break;
	    }
	    else
	    {
		if(temp)
		{
		    COMP_ACTION hac = action;
		    setAction(A_CLOSE);
		    delete temp;
		    temp = 0;
		    setAction(hac);
		}
#if defined(FORCE_DYNLIB) || defined(__ELF__) || defined(AOUT)
		if(handle) dlclose(handle);
#endif
	    }
	}
    }
    p.close();
    delete [] Buff;

    return temp;
}

BaseComponent
*BaseComponent::prepApp()
{
        zApplication *application = new zApplication(0);
	application->giveFocus();
        QObject::connect(application,SIGNAL(changeMade()),
                        menubar,SLOT(changeMade()));
        QObject::connect(application,SIGNAL(xyPos(int,int)),
                        menubar,SLOT(xy(int,int)));
        QObject::connect(sigSlot,SIGNAL(madeChange(int)),
                     application,SLOT(makeChange(int)));
        QObject::connect(global,SIGNAL(madeChange(int)),
                     application,SLOT(makeChange(int)));
        QObject::connect(attrib,SIGNAL(madeChange(int)),
                     application,SLOT(makeChange(int)));
        QObject::connect(source,SIGNAL(madeChange(int)),
                     application,SLOT(makeChange(int)));
	return application;
}

BaseComponent 
*BaseComponent::ofType(BaseComponent *par,QString type, int hasPar, int parentVersioning)
{
    BaseComponent *temp;
    BaseComponent *tempPar=0;

    if(hasPar != -2 && parentVersioning != -2)
    {
	if(parentVersioning) tempPar = at(hasPar);
	else tempPar = hasPar ? par : 0;
    }
    else	tempPar = par;

    if(type == "QDialog")
	temp = new zDialog(tempPar);
    else if(type == "QPushButton")
	temp = new zPushButton(tempPar);
    else if(type == "QTimer")
	temp = new zTimer(tempPar);
    else if(type == "QMultiLineEdit")
	temp = new zMTextBox(tempPar);
    else if(type == "QSlider")
	temp = new zSlider(tempPar);
    else if(type == "Custom")
	temp = new zCustom(tempPar);
    else if(type == "QLineEdit")
	temp = new zTextBox(tempPar);
    else if(type == "QLabel")
	temp = new zLabel(tempPar);
    else if(type == "QButtonGroup")
	temp = new zButtonGroup(tempPar);
    else if(type == "QScrollBar")
	temp = new zScrollBar(tempPar);
    else if(type == "QListBox")
	temp = new zListBox(tempPar);
    else if(type == "QComboBox")
	temp = new zComboBox(tempPar);
    else if(type == "QRadioButton")
	temp = new zRadioButton(tempPar);
    else if(type == "QCheckBox")
	temp = new zCheckBox(tempPar);
    else if(type == "QLCDNumber")
	temp = new zLcdNumber(tempPar);
    else if(type == "Application")
	temp = prepApp();
    else if(type == "MenuBar" || type == "QMenuBar")
    {
	temp = tempPar->queryMenu();
	if(!temp)
	{
	    tempPar->setMenu(new zMenuBar(tempPar));
	    temp = tempPar->queryMenu();
	}
    }
    else
    {
	BaseComponent *f = BaseComponent::findDynComponent(tempPar,type);
	if(!f)
	{
	    QMessageBox p;
	    QString o;
	    o.sprintf("Failed to find type '%s'\nUsing custom component.",
		      type.data());		
	    p.setText(o.data());
	    p.show();

	    zCustom *tmpCust = new zCustom(tempPar);
	    tmpCust->setType(type.data());
	    temp = tmpCust;
	}
	else
	    temp = f;
    }	
    return temp;
}

void BaseComponent::attShow() { action=A_NONE;attrib->show(); attrib->raise(); }
void BaseComponent::souShow() { action=A_NONE;source->show(); source->raise(); }
void BaseComponent::sigShow() { action=A_NONE;sigSlot->show();sigSlot->raise();}
void BaseComponent::menShow() { action=A_NONE;menu->show(); menu->raise(); }

void
BaseComponent::delShow()
{
    YesNo yn(0,"yn");
    QString k;

    if(mult_sel)
	k = "Delete Selected?";
    else
	k.sprintf("Delete %s?",name());
    if(yn.doit(k.data()))
    {
	if((QString) queryQType() == "MenuBar")
	{
	    BaseComponent *par;
	    par = (BaseComponent *)parentWidget();
	    par->setMenu(0);
	}
	else if(mult_sel)
	{
	    for(int x=0,y=sel_list.count();x<y;x++)
	    {
		delete sel_list.at(0);
	    }
	}
	else
	    delete this;
    }
}

void 
BaseComponent::setLock(int x)
{ 
    locked = x; popMenu->changeItem(locked ? "Unlock" : "Lock", lockId);
    at(0)->makeChange(myPosition);
}

void
BaseComponent::toggleLock()
{
    locked = !locked;
    for(int x = 0; x < sel_list.count(); x++)
    {
	sel_list.at(x)->setLock(locked);
    }
}

void BaseComponent::aboShow() 
{
    action=A_NONE;
    QMessageBox p;
    p.setCaption(queryQType());
    p.setIcon(QMessageBox::Information);
    p.setText(aboutComp());
    p.show();
}

void
BaseComponent::copyComp()
{
    if(!queryCurrBaseComp() ||
       !queryCurrBaseComp()->parentWidget() ||
       !queryCurrBaseComp()->copyAble()) return;

    int x = queryCurrObj();

    QString temp;
    temp.sprintf("%s/QtEZ/buffer.qtz",getenv("HOME"));

    CompIO::save(temp,x,x+sel_list.count()+sel_list.last()->numChildren(TRUE));
}

void
BaseComponent::cutComp()
{
    if(!queryCurrBaseComp() ||
       !queryCurrBaseComp()->parentWidget() ||
       !queryCurrBaseComp()->copyAble()) return;

    int currO = queryCurrObj();

    QString temp;
    temp.sprintf("%s/QtEZ/buffer.qtz",getenv("HOME"));

    CompIO::save(temp,currO,currO+sel_list.count()+sel_list.last()->numChildren(TRUE));

    //don't have to bother deleting selected's children as that will happen
    //automatically.
    for(int x=0,y=sel_list.count();x<y;x++) delete sel_list.at(0);
    at(0)->makeChange(queryCurrBaseComp()->queryPosition());
}

void
BaseComponent::pasteComp()
{
        if(!BaseComponent::at(BaseComponent::queryCurrPar())) return;

        int oat;
        QString temp;

        temp.sprintf("%s/QtEZ/buffer.qtz",getenv("HOME"));

        oat = CompIO::load(temp,O_PASTE);

        //Update slots
        SignalConnect *s;
        LinkList *l = BaseComponent::at(oat)->membInfo();
        for(int x = 0; x < l->connectCount(); x++)
        {
                s = l->connect(x);
                if(BaseComponent::at(s->querySlotOwner())->parentWidget() &&
                   BaseComponent::at(s->querySlotOwner())->parentWidget() !=
                   BaseComponent::at(oat)->parentWidget())
                {
                        l->removeConnection(x--);
                }
                else
                {
                        s->setSigOwner(oat);
                }
        }

	at(0)->makeChange(myPosition);
}

void
BaseComponent::raiseComp()
{
    BaseComponent *par = (BaseComponent *)parentWidget();
    if(!par) return;

    int hold = myPosition;
    if(myPosition - par->queryPosition() == 1)
  	raise();
    else
    	memberInfo->raise(myPosition);
}

void
BaseComponent::lowerComp()
{
    memberInfo->lower(myPosition);
}

void
BaseComponent::popShow(QPoint me)
{
    giveFocus();
    popMenu->move(me.x(), me.y());
    popMenu->show();
}

int 
BaseComponent::funcFind(const char *toFind,int start)
{
	int x;
	for(x = start; x < memberInfo->count(); x++)
	{
		if(memberInfo->source(x)->contains(QRegExp(toFind)) ||
		   memberInfo->memb(x)->contains(QRegExp(toFind)))
		{
			return x;
		}
	}
	return -1;
}

void
BaseComponent::doDeclaration(M_MODE mode, QString className, int doHead)
{
	int noSource = 0,x;
	QString protMode,i;
	BaseComponent *temp;

	switch(mode)
	{
	  case M_PRIVATE:
		protMode = "private";
	 	break;
	  case M_PROTECTED:
		protMode = "protected";
		break;
	  case M_PUBLIC:
		protMode = "public";
		break;
	  case M_SIGNAL:
		noSource = 1;
		protMode = "signals";
		break;
	  case M_PUB_SLOT:
		protMode = "public slots";
		break;

	 }

	if(doHead)
	{
		i.sprintf("%s:\n",protMode.data());
		writeLine(i,0);
	}

	if(mode == M_PRIVATE && isManaged())
	{
	    i.sprintf("QGridLayout *myGrid;\n");
	    writeLine(i);
	}

	QString ar; int abc;
	for(x = 0; x < count(); x++)
	{
           temp = at(x);
	   if(temp && isMyChild(temp) && temp->mode() == mode)
	   {
    		if((QString) at(x)->queryQType() == "MenuBar" && 
		   !parentWidget() && myMenu)
		{
		        for(int mc = 0; mc < menuContent->count(); mc++)
		        {
		            i.sprintf("QPopupMenu *%s;\n",
	                      menuContent->at(mc)->name());
		            writeLine(i);
		        }
		}

	        ar = temp->name();
	        abc = ar.find('[');

	        if(abc == -1 || ar.right(ar.length()-abc) == "[0]")
	        {
        	    if(abc != -1)
	            {
	                i = ar.left(abc);
	                ar.sprintf("%s[%d]",i.data(),numElements(i.data()));
	            }
	            QString type = temp->specialInher() && temp->noFuncs() ?
	                temp->specialInher() :
	                temp->queryYType();
	            if(temp->instantiate())
	            {
	                i.sprintf("%s *%s;\n",type.data(), ar.data());
	                writeLine(i);
	            }
	        }
	    }
	}

	for(x = 0; x < memberInfo->count(); x++)
	{
		QString t;
	        if(memberInfo->passInspection(x,mode,noSource))
	        {
	            if(memberInfo->isConstructor(x))
	            {
	                t = memberInfo->memb(x)->data();
	                t.replace(QRegExp("constructor"),
                          className.data());
	            }
	            else if(memberInfo->isDestructor(x))
	            {
	                if(memberInfo->source(x)->isEmpty())
	                    t = "";
	                else
	                {
	                    QString t2;
	                    t2.sprintf("~%s",className.data());
	                    t = memberInfo->memb(x)->data();
	                    t.replace(QRegExp("destructor"),
                              t2.data());
	                }
	            }
	            else
	                t = memberInfo->memb(x)->data();

	           if(!t.isEmpty() && !t.isNull())
        	   {
	                i.sprintf("%s;\n",t.data());
	                if(memberInfo->virt(x))
	                    i.insert(0,"virtual ");
	                writeLine(i);
        	    }
	        }
	}
}

int 
BaseComponent::isWritten(char *x)
{
	return defList.find(x) != -1; 
}

void 
BaseComponent::addWritten(char *x)
{ 
	if (!isWritten(x)) defList.append(x); 
}

void 
BaseComponent::delWritten(char *x)
{ 
	if (isWritten(x)) defList.remove(defList.find(x)); 
}

void
BaseComponent::menuApplyAttribs()
{
    if(!myMenu) return;
    if(currObj != myMenu->queryPosition()) myMenu->giveFocus();
    myMenu->applyAttribs();
}

LineF
BaseComponent::functionWith(int line)
{
    LineF tmpLineF;

    for(int y, x = 0; x < memberInfo->count(); x++)
    {
	/* -1 implies the member wasn't written */
	if(memberInfo->startLine(x) < line && memberInfo->startLine(x) != -1) 
	{
	    /* find the next member that was written */
	    for(y=x;y<memberInfo->count()&&memberInfo->startLine(y)!=-1;y++);	

	    if(y == memberInfo->count() || 
	       memberInfo->startLine(x) > memberInfo->startLine(y))
	    {
		   tmpLineF.setFunc(x);

		   int foundLine = line - memberInfo->startLine(x);
		   if(memberInfo->isConstructor(x)) foundLine-=queryConsCount();
		   tmpLineF.setLine(foundLine);		   
  	    }
	}
    }
    return tmpLineF;
}

void BaseComponent::setHeader(char *p) { memberInfo->setHeader(p); }
void BaseComponent::appendHeader(char *p) { memberInfo->appendHeader(p); }
QString BaseComponent::header() { return memberInfo->header(); }

/*****************************************************************
	BASE FRAME STUFF
******************************************************************/

BaseFrame::BaseFrame(QWidget *parent, char *name) : BaseComponent(parent,name)
{
	fShape = new QString;
	fStyle = new QString;
}

BaseFrame::~BaseFrame()
{
        //Delete your stuff, but don't delete look!
        delete fShape;
        delete fStyle;
}

void
BaseFrame::prepFrame(QFrame *look)
{
	if(look->frameShape() == QFrame::Box)
		*fShape = "Flat Box";
	else if(look->frameShape() == QFrame::Panel)
		*fShape = "Panel";
	else if(look->frameShape() == QFrame::WinPanel)
		*fShape = "Windows Panel";
	else if(look->frameShape() == QFrame::HLine)
		*fShape = "Horizontal Line";
	else if(look->frameShape() == QFrame::VLine)
		*fShape = "Vertical Line";
	else
		*fStyle = "None";

	if(look->frameStyle() == QFrame::Raised)
		*fStyle = "Raised";
	else if(look->frameStyle() == QFrame::Sunken)
		*fStyle = "Sunken";
	else
		*fStyle = "Plain";
}

void 
BaseFrame::showFrameAttrib(QFrame *look)
{
        ADDATTRIB("Frame Shape", fShape->data(),W_LIST,6,
        "None", "Flat Box", "Panel", "Windows Panel", "Horizontal Line",
        "Vertical Line");

        ADDATTRIB("Frame Style", fStyle->data(),W_LIST,3,
        "Plain", "Raised", "Sunken");
}

void 
BaseFrame::interpFrameAttrib(QFrame *look)
{
	int x,y;
        if(attrib->giveValue("Frame Shape") == "None")
        {
                *fShape = "None";
                x = QFrame::NoFrame;
        }
        else if(attrib->giveValue("Frame Shape") == "Flat Box")
        {
                *fShape = "Flat Box";
                x = QFrame::Box;
        }
        else if(attrib->giveValue("Frame Shape") == "Panel")
        {
                *fShape = "Panel";
                x = QFrame::Panel;
        }
        else if(attrib->giveValue("Frame Shape") == "Windows Panel")
        {
                *fShape = "Windows Panel";
                x = QFrame::WinPanel;
        }
        else if(attrib->giveValue("Frame Shape") == "Horizontal Line")
        {
                *fShape = "Horizontal Line";
                x = QFrame::HLine;
        }
        else if(attrib->giveValue("Frame Shape") == "Vertical Line")
        {
                *fShape = "Vertical Line";
                x = QFrame::VLine;
        }

        if(attrib->giveValue("Frame Style") == "Plain")
        {
                *fStyle = "Plain";
		y = QFrame::Plain;
        }
        else if(attrib->giveValue("Frame Style") == "Raised")
        {
                *fStyle = "Raised";
                y = QFrame::Raised;
        }
        else if(attrib->giveValue("Frame Style") == "Sunken")
        {
                *fStyle = "Sunken";
                y = QFrame::Sunken;
        }
	if(*fShape != "None") x = x | y;
        look->setFrameStyle(x);
}

void 
BaseFrame::writeFrame()
{
	QString style(""), shape("QFrame::NoFrame"),i;
        if(*fShape == "None")
                shape = "QFrame::NoFrame";
        else if(*fShape == "Flat Box")
                shape = "QFrame::Box";
        else if(*fShape == "Panel")
                shape = "QFrame::Panel";
        else if(*fShape == "Windows Panel")
                shape = "QFrame::WinPanel";
        else if(*fShape == "Horizontal Line")
                shape = "QFrame::HLine";
        else if(*fShape == "Vertical Line")
                shape = "QFrame::VLine";

        if(*fStyle == "Plain")
                style = "QFrame::Plain";
        else if(*fStyle == "Raised")
                style = "QFrame::Raised";
        else if(*fStyle == "Sunken")
                style = "QFrame::Sunken";

	QString first;
        i.sprintf("setFrameStyle(%s",shape.data());
	if(!style.isEmpty())
	{
		first = i.data();
		i.sprintf("%s | %s",first.data(),style.data());
	}
	i += ");\n";
       if(isWritten("Frame Shape") || isWritten("Frame Style"))
	 writeInParent(i);
}

/*****************************************************************
	END BASE FRAME STUFF
******************************************************************/

