/*  $Id: Deserialize.h,v 1.11 1998/07/27 16:35:06 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef DESERIALIZE_H
#define DESERIALIZE_H

extern float fileVersion;

#include <qstring.h>
#include <iostream.h>
#include <qlist.h>

/*******************************************************************************************************/
/* stack fu */

#define MAX_INCL_DEPTH 10

class
StackCount
{
	int _line, _depth;
	QString _dir, _filename;
public:
	StackCount() { clear(); }
	int depth() { return _depth; }
	int line() { return _line; }
	char *dir() { return _dir.data(); }
	char *file() { return _filename.data(); }

	void setFile( char *x) { _filename = x; }
	void setLine(int x) { _line = x; }
	void setDir(char *x) { _dir = x; }
	void setDepth(int x) { _depth = x; }

	void clear() { _line = 0; _dir = ""; _depth=0; _filename = ""; }
}; 


/******************************************************************************************************/
/* menubar fu */

class
MenubarElement
{
        int chkd, enab;
        int conObj, conSlot;
        QString captio, nam, shrtcut;
        int level;

   public:
        friend ostream &operator<<(ostream &, MenubarElement );
	MenubarElement(QString cap, QString na, int conO, int conS,
                QString scut, int chk, int ena, int lev)
	{
	    captio = cap.data();
	    nam = na.data();

	    shrtcut =  scut.data();

	        conObj = conO;
	        conSlot = conS;
	
	        chkd = chk;
	        enab = ena;
	        level = lev;
	}
                MenubarElement(MenubarElement &e)
	{   captio = e.queryCapt(); nam = e.queryName(); 
	    shrtcut = e.queryShrtCut(); conObj = e.queryConO(); 
	    conSlot = e.queryConS(); chkd = e.queryChk(); 
	    enab = e.queryEna(); level = e.queryLev(); }
	MenubarElement()	{   clear();	}

    void clear() { captio = ""; nam = ""; conObj = -1; conSlot = 0; 
    chkd = 0; level = 0;enab=1;  shrtcut="";}
	void setCapt(char *x) { captio = x; }
	void setNam (char *x) { nam = x;    }
	void setConO(int x)   { conObj = x;  }
	void setConS(int x)   { conSlot = x; }
	void setChk (int x)   { chkd = x;    }
	void setEna (int x)   { enab = x;    }
	void setLev (int x)   { level = x;   }
	void setStC (char *x) { shrtcut = x;}
 
        char *queryCapt() { return captio.data(); }
        char *queryName() { return nam.data(); }
        int queryConO() { return conObj; }
        int queryConS() { return conSlot;}
        int queryChk() { return chkd; }
        int queryEna() { return enab; }
        int queryLev() { return level; }
        char *queryShrtCut() { return shrtcut.data(); }
};
ostream &operator<<(ostream &, MenubarElement);


/******************************************************************************************************/
/* Signal fu */

class
SignalConnect
{
   protected:
	int sigOwn, sloOwn, sig, slo;

    public:
	friend ostream &operator<<(ostream &, SignalConnect );
        int querySlotOwner (){ return sloOwn; }
        int querySigOwner  (){ return sigOwn; }
        int querySig       (){ return sig;    }
        int querySlot      (){ return slo;    }

    int operator==(SignalConnect &rhs)
	{ return (this->querySlotOwner() == rhs.querySlotOwner() &&
		  this->querySigOwner () == rhs.querySigOwner () &&
		  this->querySig      () == rhs.querySig      () &&
	          this->querySlot     () == rhs.querySlot     ()); }
    
    void clear() { sloOwn = 0; sigOwn = 0; sig = 0; slo = 0; }
    void setSlotOwner(int x)  { sloOwn = x; }
    void setSigOwner (int x)  { sigOwn = x; }
    void setSig      (int x)  { sig    = x; }
    void setSlot     (int x)  { slo    = x; }

	SignalConnect(int sigO, int Sig, int sloO, int Slo)
	{  sigOwn = sigO; sig = Sig; sloOwn = sloO, slo = Slo; }
	SignalConnect(SignalConnect &o)
	{  sigOwn  = o.querySigOwner();  sig = o.querySig ();
	sloOwn = o.querySlotOwner(); slo = o.querySlot(); }
	SignalConnect()	{ clear(); }
        SignalConnect(char *desc, int addUp)
        {
                QString si[4], build;
		int count=0; 
	       	while(*desc != '\0')
	        {
	            if(*desc != ':')
			build += *desc;
		    else
		    {
			si[count++] = build.data();
			build = "";
		    }
		    desc++;
	        }
	        sigOwn = si[0].toInt(); sloOwn = si[2].toInt(); 
		if(fileVersion < (float) 0.75 || 1)
		{
		    sig = si[1].toInt(); slo = si[3].toInt();
		}

		//addup does not apply to the application object
		if(sigOwn) sigOwn+=addUp;
		if(sloOwn) sloOwn+=addUp;
        }

};

class
SignalConnectList : public QList<SignalConnect>
{
	public:
	       void printem(SignalConnect *,SignalConnect *);//for debuging
						     //defined in main.cc
	protected:
		virtual int compareItems(GCI c1, GCI c2)
		{
			SignalConnect *p1 = (SignalConnect *)c1;
			SignalConnect *p2 = (SignalConnect *)c2;
		
			//printem(p1,p2);
			return( !(*p1 == *p2));
		}
};
ostream &operator<<(ostream &, SignalConnect);


/******************************************************************************************************/
/* function fu */

class
FunctionElement
{
   protected:
              int _defined, _virt, _protection, _readonly, _startLine;
              QString _prototype, _source, _baseinit;

    public:
	friend ostream &operator<<(ostream &, FunctionElement );
    int startLine() { return _startLine; }
    int defined() { return _defined; }
    int virt() { return _virt; }
    int protection() { return _protection; }
    int readonly() { return _readonly; }
    QString *prototype() { return &_prototype; }
    QString *source() { return &_source; }
    QString *baseinit() { return &_baseinit; }

    int operator==(FunctionElement &rhs)
	{ return (this->defined() == rhs.defined() &&
		  this->virt() == rhs.virt() &&
		  this->protection() == rhs.protection() &&
		  this->readonly() == rhs.readonly() &&
		  this->prototype() == rhs.prototype() &&
		  this->source() == rhs.source() &&
		  this->baseinit() == rhs.baseinit() ); }

    void clear() 
     { _prototype="", _baseinit="", _source="",_virt=1,_protection=1,_defined=1; _readonly=0;
       _startLine=0; }

    void setStartLine(int x) { _startLine = x; }
    void setPrototype(char *p) { _prototype = p; }
    void setBaseinit(char *p) { _baseinit = p; }
    void setSource(char *p) { _source = p; }
    void appendSource(char *p) 	{ _source += p; }
    void setReadonly(int x) { _readonly = x; }
    void setVirt(int x) { _virt = x; }
    void setProtection(int x) { _protection = x; }
    void setDefined(int x) { _defined = x; }

    FunctionElement(char *memb, char *bi="",char *src="", int vrt=1,int mod=1, int d=1)
	{ _prototype=memb; _baseinit = bi; _source = src; _virt = vrt; 
	_protection = mod; _defined = d; _readonly = 0; _startLine = 0; }
    FunctionElement(FunctionElement &e)
	{ _prototype=e.prototype()->data(); _baseinit = e.baseinit()->data(); 
	  _source=e.source()->data(); _virt=e.virt();_protection=e.protection(); 
	  _defined=e.defined(); _readonly=e.readonly(); _startLine = 0;  }
    FunctionElement()
	{ clear(); }

};


class
FunctionList : public QList<FunctionElement>
{
	protected:
		virtual int compareItems(GCI c1, GCI c2)
		{
			FunctionElement *p1 = (FunctionElement *)c1;
			FunctionElement *p2 = (FunctionElement *)c2;

			return( *(p1->prototype()) != *(p2->prototype()));
		}
};


#endif
