/*  $Id: LinkList.h,v 1.5 1998/07/27 16:35:06 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef LINKLIST_H
#define LINKLIST_H

/* enum M_MODE { M_PRIVATE, M_PROTECTED, M_PUBLIC, M_SIGNAL, M_PUB_SLOT };
	Modes:
		0)  private
		1)  protected
		2)  public
	        3)  signal
	        4)  public slot
*/

#include "Deserialize.h"
class BaseComponent;

#include <iostream.h>
#include <qstrlist.h>
#include <qlist.h>
#include <qstring.h>

class
LineF
{
private:
    int _line, _func;
public:
    LineF() { _line = 0; _func = 0; }
    LineF(int l, int f) { _line = l; _func = f; }
    LineF(LineF &f) { _line = f.lineNo(); _func = f.func(); }

    int lineNo() { return _line; }
    int func() { return _func; }
    void setFunc(int x) { _func = x; }
    void setLine(int x) { _line = x; }

    void operator=(LineF &rhs) 
    { 
	if(&rhs == this) return;
	_line = rhs.lineNo(); 
	_func = rhs.func();
    }
};

class
LinkList
{

    QList<MenubarElement> mnuInfo;
    FunctionList functionList;
    SignalConnectList connectList;
    QString headers;
    int flag;
 
public:
    LinkList();

    int count();
    QString *memb(int);
    QString *source(int);
    QString *baseInit(int);
    SignalConnect *connect(int);
    SignalConnectList *connections() { return &connectList; }

    void setHeader(char *p) { headers = p; }
    void appendHeader(char *p) { headers += p; }
    QString header() { return headers; }
    
    int isConstructor(int);
    int isDestructor(int);
    int startLine(int);
    int isReadOnly(int);
    int virt(int);
    int mode(int);	
    int define(int);
    int connected(SignalConnect);
    int signal(int);
    int slot(int);
    char *signalSlotStr(int);
    int signalSlot(int);
    int passInspection(int, int, int=0 );
    
    void raise(int);
    void lower(int);

    int add(char *memb, char *bi="", char *source="", int virt=1, 
	     int mode=1, int d= 1);
    int add(FunctionElement);

    int connectCount();
    void addConnection(SignalConnect);
    void insertConnect(SignalConnect,int);

    void clearMenus();
    void appendMenu(MenubarElement);
    void modifyMenu(int where, QString cap, QString na, int conO, int conS,
		    QString scut, int chk, int ena, int lev);
    int menuCount();	
    MenubarElement *menu(int where);
    void removeMenu(int where);
    void insertMenu(int where);

    void remove(int,BaseComponent *);
    void fixConnections();
    void removeConnection(int);

    void setConnect(SignalConnect,int);
    void setStartLine(int, int);
    void setDef(int,int);
    void setMode(int, int);
    void setVirt(int, int);
    void setBaseInit(int, QString);
    void setSource(int,QString );
    void setMemb(int, QString );
    void setReadOnly(int,int);

    QString membNoDefs(int);
    QString membName(int);
    QString retType(int);
    QString membRight(int);

    int insertObject(BaseComponent *);
};
#endif

