/*  $Id: zBlank.h,v 1.3 1998/07/27 16:35:11 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef ZBLANK_H
#define ZBLANK_H

#include "BaseComp.h"
#include "../main.h"

class
zBlank : public BaseComponent
{
   private:
	QBlank *look;
   public:
	//Constructor
	zBlank(QWidget *parent);
	~zBlank();
	
	//Attribute Information passing
	virtual void fillAttributes();
        virtual void interpretAttributes();
	
	//Write your intialization routine for source dumping
	virtual void writeInits();

	//Fill in your initial members + member info
	virtual void fillMembInfo();

	//Of what type are you?
	virtual char *queryQType() { return "QBlank"; }


/******************************************************************************
		SPECIAL PURPOSE QUERIES, RARELY NECESARY
******************************************************************************/
        //Should be instantiated?
        virtual int instantiate() { return 1; }

   	 //This is to cause the linking/including of a special file.
         //Only of use in external components.
    	virtual int externalLinkage() { return 0;}

	//Can this widget be resize from the GUI?
	virtual int canResize() { return 1; }

        //Constructor overload (for instantiating in parent)
        //Returning 0 is the same as returning "(this,name)"
        virtual char *specialInit() { return 0; }

	//This will be the string used in the class definition, only use
	//if your component inherits something different the queryQType() 
	//returns.
        virtual char *specialInher() { return 0; }

	//Use this only if you want this widget not to be cut/copyable, mostly
	//because it has more interworkings, or you don't want multiple ones
	//etc..
	virtual int copyAble() { return 1; }

	//Not visible
	virtual int invisibleComp() { return 0; }

	virtual canHaveChildren() { return 1; }
};

/******************************************************************************
 Uncomment if you intend to link this in dynamically, otherwise not necesary
******************************************************************************/
/*
extern "C"
{
        zBlank *yourself(QWidget *parent);
}
*/
#endif
