/*  $Id: zCheckBox.cc,v 1.4 1998/07/27 16:35:07 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zCheckBox.h"

zCheckBox::zCheckBox(QWidget *parent) 
					: BaseComponent(parent,"check")
{
	myPicture = new QString("");
	look = new QCheckBox(this,"foo");
	setLook(look);
}

zCheckBox::~zCheckBox()
{
	delete myPicture;
}

void 
zCheckBox::fillAttributes()
{
        ADDATTRIB("Caption",(char *)look->text(),W_TEXT);

        ADDATTRIB("Pixmap",myPicture->data(),W_FILE);

	ADDATTRIB("Checked",look->isChecked(),W_TRUE);

        ADDATTRIB("Background Colour",look->backgroundColor(),W_COLOR);

        ADDATTRIB("Text Colour",look->colorGroup().text(),W_COLOR);

	ADDATTRIB("Font",(char *)myLook->font().family(),W_LIST,fontList);

	ADDATTRIB("Font Size",myLook->font().pointSize(),W_LIST,24,
              "10", "12", "14", "16", "18", "20", "22", "24", "26", "28",
              "30", "32", "34", "36", "38", "40", "44", "48", "52", "56",
              "60", "64", "68", "72");

	ADDATTRIB("Bold",myLook->font().bold(),W_TRUE);

	ADDATTRIB("Italic",myLook->font().italic(),W_TRUE);

	ADDATTRIB("Tool Tip",tooltipData->data(),W_TEXT);

        genericFillAttrib();
}

void 
zCheckBox::interpretAttributes()
{
        if(attrib->giveValue("Pixmap").isEmpty())
	{
		*myPicture = "";
		look->setPixmap(QPixmap());
                look->setText(attrib->giveValue("Caption").data());
	}
        else
        {
		look->setText("");
                look->setPixmap(QPixmap(attrib->giveValue("Pixmap").data()));
                *myPicture = attrib->giveValue("Pixmap");
        }

	look->setChecked(attrib->giveBoolValue("Checked"));

        QColorGroup p(look->foregroundColor(),
                         attrib->giveColor("Background Colour"),
                         QColor(255,255,255),QColor(96,96,96),
                         QColor(160,160,160), attrib->giveColor("Text Colour"),
                         QColor(255,255,255));

        look->setPalette(QPalette(p,
                look->palette().disabled(),look->palette().active()));

        int bo = attrib->giveBoolValue("Bold") ? QFont::Bold : QFont::Normal;
        myLook->setFont(QFont(attrib->giveValue("Font").data(),
                          attrib->giveIntValue("Font Size"),
                          bo,attrib->giveBoolValue("Italic")));

        *tooltipData = attrib->giveValue("Tool Tip");

        genericInterpAttrib();
}

void
zCheckBox::writeInits()
{
        QString i;

        if(look->pixmap())
        {
                i.sprintf("setPixmap(*new QPixmap(\"%s\"));\n",
                        myPicture->data());
                WRITEATTRIB("Pixmap",i);
        }
        else
        {
                i.sprintf("setText(\"%s\");\n",
                        (char *)look->text());
                WRITEATTRIB("Caption",i);
	}

	QString xtc;
	if(look->font().bold())
		xtc = "QFont::Bold";
	else
		xtc = "QFont::Normal";

	i.sprintf("setFont(QFont(\"%s\",%d,%s,(int)%d));\n",
        (char *)look->font().family(),look->font().pointSize(),
	xtc.data(),look->font().italic());
       if(isWritten("Font Size") || isWritten("Font") || isWritten("Bold") || isWritten("Italic"))
	   writeInParent(i);


        i.sprintf("setChecked(%s);\n",strBool(look->isChecked()));
        WRITEATTRIB("Checked",i);

        i.sprintf("setGeometry(%d,%d,%d,%d);\n",x(),y(), width(),height());
        writeInParent(i);

        if(!tooltipData->isEmpty())
        {
                QString p;
                if(noFuncs() == TRUE)
                        p = name();
                else
                        p = "this";

                i.sprintf(
                "QToolTip::add(%s,\"%s\");\n"
                        ,p.data(),tooltipData->data());
                writeLine(i);
        }

        writePalette();

       if(isWritten("Maximum Width") || isWritten("Maximum Height"))
       {
	   i.sprintf("setMaximumSize(%d,%d);\n",
		     look->maximumSize().width(),look->maximumSize().height());
	   writeInParent(i);
       }
       if(isWritten("Minimum Width") || isWritten("Minimum Height"))
       {
	   i.sprintf("setMinimumSize(%d,%d);\n",
		     look->minimumSize().width(),look->minimumSize().height());
	   writeInParent(i);
       }

        if(*uiStyle == "Motif")
               i.sprintf("setStyle(MotifStyle);\n");
        else if(*uiStyle == "Windows")
                i.sprintf("setStyle(WindowsStyle);\n");
        else
                i = "";
        if(!i.isEmpty()) writeInParent(i);

}

void
zCheckBox::fillMembInfo()
{
	//fills generic virtual protected stuffs
	genericFillMembInfo();

	addMember("destructor()","","",0,2,1);

       addMember("constructor(QWidget *parent=0, char *name=0)",
                        "init(parent,name)","",0,2,1);

        addMember("void clicked()","","",0,3,0);
        addMember("void pressed()","","",0,3,0);
        addMember("void released()","","",0,3,0);
        addMember("void toggled(bool f)","","",0,3,0);
}
