/*  $Id: zComboBox.cc,v 1.5 1998/07/27 16:35:07 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zComboBox.h"

zComboBox::zComboBox(QWidget *parent) 
					: BaseComponent(parent,"combo")
{
	rw = 0;
	look = new QComboBox(this,"foo");
	setLook(look);
}

zComboBox::~zComboBox()
{
	//Delete your stuff, but don't delete look!
}

void 
zComboBox::fillAttributes()
{
	ADDATTRIB("AutoResize",look->autoResize(), W_TRUE);
	
	ADDATTRIB("Maximum Items",look->maxCount(),W_TEXT);

        ADDATTRIB("Background Colour",look->backgroundColor(),W_COLOR);

        ADDATTRIB("Text Colour",look->colorGroup().text(),W_COLOR);

	ADDATTRIB("Read & Write",(bool)rw,W_TRUE);

        ADDATTRIB("Foreground Colour",look->colorGroup().foreground(),W_COLOR);

        ADDATTRIB("Font",(char *)myLook->font().family(),W_LIST,fontList);

        ADDATTRIB("Font Size",myLook->font().pointSize(),W_LIST,24,
              "10", "12", "14", "16", "18", "20", "22", "24", "26", "28",
              "30", "32", "34", "36", "38", "40", "44", "48", "52", "56",
              "60", "64", "68", "72");


        ADDATTRIB("Bold",myLook->font().bold(),W_TRUE);

        ADDATTRIB("Italic",myLook->font().italic(),W_TRUE);

        ADDATTRIB("Tool Tip",tooltipData->data(),W_TEXT);

        genericFillAttrib();
}

void 
zComboBox::interpretAttributes()
{
	look->setAutoResize(attrib->giveBoolValue("AutoResize"));

	look->setMaxCount(attrib->giveIntValue("Maximum Items"));

        QColorGroup p(attrib->giveColor("Foreground Colour"),
                         attrib->giveColor("Background Colour"),
                         QColor(255,255,255),QColor(96,96,96),
                         QColor(160,160,160), attrib->giveColor("Text Colour"),
                         QColor(255,255,255));

        look->setPalette(QPalette(p,
                look->palette().disabled(),look->palette().active()));

	rw = (int)attrib->giveBoolValue("Read & Write");
	
        int bo = attrib->giveBoolValue("Bold") ? QFont::Bold : QFont::Normal;
        myLook->setFont(QFont(attrib->giveValue("Font").data(),
                          attrib->giveIntValue("Font Size"),
                          bo,attrib->giveBoolValue("Italic")));

        *tooltipData = attrib->giveValue("Tool Tip");

        genericInterpAttrib();
}

void
zComboBox::writeInits()
{
	QString i;

	i.sprintf("setAutoResize(%s);\n",strBool(look->autoResize()));
	WRITEATTRIB("AutoResize",i);

	i.sprintf("setMaxCount(%d);\n",look->maxCount());
	WRITEATTRIB("Maximum Items",i);

        QString xtc;
        if(look->font().bold())
		xtc = "QFont::Bold";
	else
                xtc = "QFont::Normal";
	i.sprintf("setFont(QFont(\"%s\",%d,%s,(int)%d));\n",
	(char *)look->font().family(),look->font().pointSize(),
	xtc.data(),look->font().italic());
       if(isWritten("Font Size") || isWritten("Font") || isWritten("Bold") || isWritten("Italic"))
	   writeInParent(i);


	i.sprintf("setGeometry(%d,%d,%d,%d);\n",x(),y(),width(),height());
        writeInParent(i);

       if(isWritten("Maximum Width") || isWritten("Maximum Height"))
       {
	   i.sprintf("setMaximumSize(%d,%d);\n",
		     look->maximumSize().width(),look->maximumSize().height());
	   writeInParent(i);
       }
       if(isWritten("Minimum Width") || isWritten("Minimum Height"))
       {
	   i.sprintf("setMinimumSize(%d,%d);\n",
		     look->minimumSize().width(),look->minimumSize().height());
	   writeInParent(i);
       }

	if(!tooltipData->isEmpty())
        {
                QString p;
                if(noFuncs() == TRUE)
                        p = name();
                else
                        p = "this";

                i.sprintf(
                "QToolTip::add(%s,\"%s\");\n"
                        ,p.data(),tooltipData->data());
                writeLine(i);
        }

        writePalette();

        if(*uiStyle == "Motif")
               i.sprintf("setStyle(MotifStyle);\n");
        else if(*uiStyle == "Windows")
                i.sprintf("setStyle(WindowsStyle);\n");
        else
                i = "";
        if(!i.isEmpty()) writeInParent(i);
}

void
zComboBox::fillMembInfo()
{
        //fills generic virtual protected stuffs
        genericFillMembInfo();

        addMember("destructor()","","",0,2,1);

       addMember("constructor(bool rw, QWidget *parent=0, char *name=0)",
                        "init(rw, parent,name)","",0,2,1);
        
	addMember("void activated(int ind)","","",0,3,0);
        addMember("void higlighted(int ind)","","",0,3,0);
        addMember("void activated(const char *p)","","",0,3,0);
        addMember("void highlighted(const char *p)","","",0,3,0);
}
