/*  $Id: zDialog.cc,v 1.2 1998/07/27 16:35:07 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zDialog.h"
#include <qregexp.h>

zDialog::zDialog(QWidget *parent=0) :
					BaseComponent(parent,"project")
{
	flg = new QString("Normal Border");
	modal = 0; useLayout = 0;
	resize(420,320);
	setLook();
}

zDialog::~zDialog()
{
    delete flg;
}

void
zDialog::fillAttributes()
{
        if(!parentWidget())
	{
	    ADDATTRIB("Modal",(bool)modal,W_TRUE);

	    ADDATTRIB("Use Layout",(bool)useLayout,W_TRUE);
	}

        ADDATTRIB("Background Colour",backgroundColor(),W_COLOR);

        ADDATTRIB("Tool Tip",tooltipData->data(),W_TEXT);

	ADDATTRIB("Extra Flags",flg->data(),W_LIST,3,
	     "Normal Border", "Dialog Border", "No Border"); 

	genericFillAttrib();
}

void
zDialog::interpretAttributes()
{
        WFlags f = WStyle_Customize; *flg = attrib->giveValue("Extra Flags");
        if(*flg == "Normal Border")
                f = f | WStyle_NormalBorder;
        else if(*flg == "Dialog Border")
                f = f | WStyle_DialogBorder;
        else if(*flg == "No Border")
                f = f | WStyle_NoBorder;

/*	UNTIL TROLLS FIX RECREATE BUG
	if(oldFlg != flg->data())
	{
		int oldX = x(); int oldY = y();
	        recreate(0,f,QPoint(oldX,oldY),TRUE);
		attrib->raise();
	} */

        setBackgroundColor(attrib->giveColor("Background Colour"));

        if(!parentWidget())
	{	
                modal = attrib->giveBoolValue("Modal");

		useLayout = (int) attrib->giveBoolValue("Use Layout");
	}

        *tooltipData = attrib->giveValue("Tool Tip");

	genericInterpAttrib();
}

void
zDialog::writeInits()
{
        QString i;

        i.sprintf("setCaption(\"%s\");\n",caption());
        WRITEATTRIB("Caption",i);

        i.sprintf("resize(%d,%d);\n",width(),height());
        writeInParent(i);

        if(!tooltipData->isEmpty())
        {
                i.sprintf("QToolTip::add(this,\"%s\");\n",tooltipData->data());
                writeLine(i);
        }
	if(!iconPix->isEmpty())
	{
		i.sprintf("setIcon(*new QPixmap(\"%s\"));\n",iconPix->data());
		WRITEATTRIB("Pixmap",i);
	}

       if(isWritten("Maximum Width") || isWritten("Maximum Height"))
       {
	   i.sprintf("setMaximumSize(%d,%d);\n",
		     maximumSize().width(),maximumSize().height());
	   writeInParent(i);
       }
       if(isWritten("Minimum Width") || isWritten("Minimum Height"))
       {
	   i.sprintf("setMinimumSize(%d,%d);\n",
		     minimumSize().width(),minimumSize().height());
	   writeInParent(i);
       }

        i.sprintf("setBackgroundColor(QColor(%d,%d,%d));\n",
		backgroundColor().red(),
		backgroundColor().green(),
		backgroundColor().blue());
	WRITEATTRIB("Background Colour",i);

        if(*uiStyle == "Motif")
               i.sprintf("setStyle(MotifStyle);\n");
        else if(*uiStyle == "Windows")
                i.sprintf("setStyle(WindowsStyle);\n");
        else
                i = "";
        if(!i.isEmpty()) writeInParent(i);

}

void
zDialog::fillMembInfo()
{
        //fills generic virtual protected stuffs
        genericFillMembInfo();

        addMember("destructor()","","",0,2,1);

        QString i;
        i.sprintf("init(parent,name,&ISMODAL,&W_FLAGS)");
        addMember(
         "constructor(QWidget *parent=0, char *name=0)",
                        i.data(),"",0,2,1);
}

QString 
zDialog::parseInitSpecial(QString comingIn)
{
    QString goingOut = comingIn.data();

    QString i; i.sprintf("%s",strBool(modal));
    goingOut.replace(QRegExp("&ISMODAL"),i.data());

    QString flags = "WStyle_Customize | ";
    if(*flg == "Dialog Border")
	flags += "WStyle_DialogBorder";
    else if(*flg == "Normal Border")
	flags += "WStyle_NormalBorder";
    else if(*flg == "No Border")
	flags += "WStyle_NoBorder";
    goingOut.replace(QRegExp("&W_FLAGS"),flags.data());

    return goingOut;
}
