/*  $Id: zLcdNumber.cc,v 1.4 1998/07/27 16:35:08 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zLcdNumber.h"

zLcdNumber::zLcdNumber(QWidget *parent) 
					: BaseFrame(parent,"lcd")
{
    resize(100,60);
    look = new QLCDNumber(this,"foo");

    style = new QString;
    if(look->segmentStyle() == QLCDNumber::Outline)
	*style = "Outline";
    else if(look->segmentStyle() == QLCDNumber::Filled)
	*style = "Filled";
    else if(look->segmentStyle() == QLCDNumber::Flat)
	*style = "Flat";

    prepFrame(look);
    setLook(look);
}

zLcdNumber::~zLcdNumber()
{
	//Delete your stuff, but don't delete look!
	delete style;
}

void 
zLcdNumber::fillAttributes()
{
	ADDATTRIB("Number of Digits",look->numDigits(),W_TEXT);

	ADDATTRIB("Value",look->intValue(),W_TEXT);

	ADDATTRIB("Style",style->data(),W_LIST,3,
	"Outline","Filled","Flat");

	ADDATTRIB("Tool Tip",tooltipData->data(),W_TEXT);

        ADDATTRIB("Background Colour",look->backgroundColor(),W_COLOR);

        ADDATTRIB("Text Colour",look->colorGroup().text(),W_COLOR);

        ADDATTRIB("Foreground Colour",look->colorGroup().foreground(),W_COLOR);

	genericFillAttrib();

	showFrameAttrib(look);
}

void 
zLcdNumber::interpretAttributes()
{
	look->setNumDigits(attrib->giveIntValue("Number of Digits"));

	look->display(attrib->giveIntValue("Value"));

	*style = attrib->giveValue("Style");
	if(*style == "Outline")
		look->setSegmentStyle(QLCDNumber::Outline);
	else if(*style == "Filled")
		look->setSegmentStyle(QLCDNumber::Filled);
	else if(*style == "Flat")
		look->setSegmentStyle(QLCDNumber::Flat);

        *tooltipData = attrib->giveValue("Tool Tip");

        QColorGroup p(attrib->giveColor("Foreground Colour"),
                         attrib->giveColor("Background Colour"),
                         QColor(255,255,255),QColor(96,96,96),
                         QColor(160,160,160), attrib->giveColor("Text Colour"),
                         QColor(255,255,255));

        look->setPalette(QPalette(p,
                look->palette().disabled(),look->palette().active()));

	genericInterpAttrib();

	interpFrameAttrib(look);
}

void
zLcdNumber::writeInits()
{
	QString i;

	i.sprintf("setNumDigits(%d);\n",look->numDigits());
	WRITEATTRIB("Number of Digits",i);

	i.sprintf("display(%d);\n",look->intValue());
	WRITEATTRIB("Value",i);

	i.sprintf("setSegmentStyle(QLCDNumber::%s);\n",style->data());
	WRITEATTRIB("Style",i);

        if(!tooltipData->isEmpty())
        {
                QString p;
                if(noFuncs() == TRUE)
                        p = name();
                else
                        p = "this";

                i.sprintf(
                "QToolTip::add(%s,\"%s\");\n"
                        ,p.data(),tooltipData->data());
                writeLine(i);
        }

        i.sprintf(
        "setGeometry(%d,%d,%d,%d);\n"
                ,x(),y(),width(),height());
        writeInParent(i);

        writePalette();

       if(isWritten("Maximum Width") || isWritten("Maximum Height"))
       {
	   i.sprintf("setMaximumSize(%d,%d);\n",
		     look->maximumSize().width(),look->maximumSize().height());
	   writeInParent(i);
       }
       if(isWritten("Minimum Width") || isWritten("Minimum Height"))
       {
	   i.sprintf("setMinimumSize(%d,%d);\n",
		     look->minimumSize().width(),look->minimumSize().height());
	   writeInParent(i);
       }

        if(*uiStyle == "Motif")
               i.sprintf("setStyle(MotifStyle);\n");
        else if(*uiStyle == "Windows")
                i.sprintf("setStyle(WindowsStyle);\n");
        else
                i = "";
        if(!i.isEmpty()) writeInParent(i);

	writeFrame();
}

void
zLcdNumber::fillMembInfo()
{
        //fills generic virtual protected stuffs
        genericFillMembInfo();

        addMember("destructor()","","",0,2,1);

       addMember("constructor(QWidget *parent=0, char *name=0)",
                        "init(parent,name)","",0,2,1);

	addMember("void display(int num)","","",0,4,0);
	addMember("void display(double num)","","",0,4,0);
        addMember("void display(const char *str)","","",0,4,0);
        addMember("void setHexMode()","","",0,4,0);
        addMember("void setDecMode()","","",0,4,0);
        addMember("void setOctMode()","","",0,4,0);
        addMember("void setBinMode()","","",0,4,0);
        addMember("void setSmallDecimalPoint(bool f)","","",0,4,0);
        addMember("void overflow()","","",0,3,0);
}
