/*  $Id: zMenuBar.cc,v 1.4 1998/07/27 16:35:08 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zMenuBar.h"
#include "LinkList.h"

zMenuBar::zMenuBar(QWidget *parent)
					: BaseComponent(parent,"menu")
{
	look = new QMenuBar(this,"foo");
	resize(parent->width(),look->height()+10);
	setLook(look);
}

zMenuBar::~zMenuBar()
{
	//Delete your stuff, but don't delete look!
}

void 
zMenuBar::fillAttributes()
{
        ADDATTRIB("Font",(char *)myLook->font().family(),W_LIST,fontList);

        ADDATTRIB("Font Size",myLook->font().pointSize(),W_LIST,9,
        "10","12","14","16","18","20","24","30","34");

        ADDATTRIB("Bold",myLook->font().bold(),W_TRUE);

        ADDATTRIB("Italic",myLook->font().italic(),W_TRUE);

        ADDATTRIB("Background Colour",look->backgroundColor(),W_COLOR);

        ADDATTRIB("Text Colour",look->colorGroup().text(),W_COLOR);

	genericFillAttrib();
}

void 
zMenuBar::interpretAttributes()
{
	QString i;

        int x;
        if(attrib->giveBoolValue("Bold"))
                x = QFont::Bold;
        else
                x = QFont::Normal;

        myLook->setFont(QFont(attrib->giveValue("Font").data(),
                attrib->giveIntValue("Font Size"),
                x,attrib->giveBoolValue("Italic")));

        QColorGroup p(myLook->foregroundColor(),
                         attrib->giveColor("Background Colour"),
                         QColor(255,255,255),QColor(96,96,96),
                         QColor(160,160,160), attrib->giveColor("Text Colour"),
                         QColor(255,255,255));

        look->setPalette(QPalette(p,
                look->palette().disabled(),look->palette().active()));

	BaseComponent *par = (BaseComponent *) parentWidget();
	for(int xx = 0; xx < par->queryMenuContent()->count(); xx++)
	{
		par->queryMenuContent()->at(xx)->setPalette(myLook->palette());

		par->queryMenuContent()->at(xx)->setStyle(myLook->style());

		par->queryMenuContent()->at(xx)->setFont(myLook->font());
	}

	genericInterpAttrib();
}

void
zMenuBar::writeMenus()
{
	QString i;
	int x;

	BaseComponent *par = (BaseComponent *)parentWidget();

	LinkList *lst = par->membInfo();
	int furthest=0;
	for(x = 0; x < lst->menuCount(); x++)
	    if(lst->menu(x)->queryLev() > furthest) 
			furthest = lst->menu(x)->queryLev();
	QString ho;
	int cnt = 0;
	int flag = 1;
	while(furthest != 0)
	{
		flag = 0;
		for(x = 0; x < lst->menuCount(); x++)
		{
			if(lst->menu(x)->queryLev() == furthest)
			{
				if(!flag)
				{
					writeLine("\n");
					i.sprintf(
					"%s = new QPopupMenu(0,\"%s\");\n",
					lst->menu(x)->queryName(),
					lst->menu(x)->queryName());
					writeLine(i);
					ho = lst->menu(x)->queryName();

					allInits(lst->menu(x)->queryName());
					i.sprintf(
					"%s->setCheckable(TRUE);\n",
					ho.data());
					writeLine(i);

					flag = 1;
				}
				if(x == lst->menuCount() -1 ||
				   lst->menu(x+1)->queryLev() <= furthest)
				{
					QString s = lst->menu(x)->queryCapt();

					if(s != "-")
					{
					    i.sprintf(
		 			    "%s->insertItem(\"%s\",%d);\n",
					    ho.data(),lst->menu(x)->queryCapt(),
			 		    cnt);
					    writeLine(i);

					    s = lst->menu(x)->queryShrtCut();
					    if(!s.isEmpty())
					    {
					        i.sprintf(
					        "%s->setAccel(%s,%d);\n",
						ho.data(),s.data(),cnt);
						writeLine(i);
					
					    }
					
					    int tempSlotO;
					    tempSlotO = lst->menu(x)->queryConO();
					    int tempSlot;
					    tempSlot = lst->menu(x)->queryConS();
					    if(tempSlotO != -1)
					    {
						QString cTo;
						cTo = at(tempSlotO)->name();
						if(noFuncs() == TRUE &&
						   cTo == parentWidget()->name()
						)
							cTo = "this";
                                                else if(noFuncs() == FALSE &&
                                                   cTo == parentWidget()->name()                                                )
                                                        cTo = "parent";


				if(!at(tempSlotO)->parentWidget()
				      && at(tempSlotO)!=parentWidget())
				{
					//Have connection made in main()
					i.sprintf(
                                        "%s.%s->connectItem(%d,&%s,SLOT(%s));\n"
                                          ,parentWidget()->name(),ho.data(),cnt,
                                           cTo.data(),
                                           at(tempSlotO)->membInfo()->membName(                                                at(tempSlotO)->membInfo()->slot(                                                 tempSlot)).data());
					mainAux += i.data();
				}
				else
				{	
					//Make connection here in constructor
                                        i.sprintf(
                                        "%s->connectItem(%d,%s,SLOT(%s));\n",
					   ho.data(),cnt,cTo.data(),
                                           at(tempSlotO)->membInfo()->membName(
                                               at(tempSlotO)->membInfo()->slot(
                                                tempSlot)).data());
					writeLine(i);
				}
			    }
	
					    i.sprintf(
					    "%s->setItemChecked(%d,%s);\n"
						,ho.data(),cnt,
					    strBool(lst->menu(x)->queryChk()));
					    writeLine(i);

                                            i.sprintf(
                                           "%s->setItemEnabled(%d,%s);\n"
                                               ,ho.data(),cnt, 
					    strBool(lst->menu(x)->queryEna()));
                                            writeLine(i);

					    ++cnt;
					}
					else
					{
					    i.sprintf(
					    "%s->insertSeparator();\n",
					    ho.data());
					    writeLine(i);
					}
				}
				else
				{
					i.sprintf(
					"%s->insertItem(\"%s\",%s);\n",
					ho.data(),lst->menu(x)->queryCapt(),
					lst->menu(x+1)->queryName());	
					writeLine(i);
				}
			}	
			else if(lst->menu(x)->queryLev() < furthest)
			{    flag = 0; cnt = 0; }
		}
		--furthest;
	}
	writeLine("\n");
	allInits((char *)name());
	for(x = 0; x < lst->menuCount(); x++)
	{
		if(!lst->menu(x)->queryLev())
		{
			QString s = lst->menu(x)->queryCapt();
			if(s == "-")
				i.sprintf("%s->insertSeparator();\n",name());
			else if(x+1 < lst->menuCount())
				i.sprintf("%s->insertItem(\"%s\",%s);\n",name(),
			        lst->menu(x)->queryCapt(),
			        lst->menu(x+1)->queryName());

			writeLine(i);
		}
	}
}

void
zMenuBar::allInits(char *x)
{
	QString i;

	i = x;
        if(*uiStyle == "Motif")
               i += "->setStyle(MotifStyle);\n";
        else if(*uiStyle == "Windows")
               i += "->setStyle(WindowsStyle);\n";
        else
                i = "";
        if(!i.isEmpty()) WRITEATTRIB("Interface Style",i);

        QString xtc;
        if(look->font().bold())
                xtc = "QFont::Bold";
        else
                xtc = "QFont::Normal";
        i.sprintf("%s->setFont(QFont(\"%s\",%d,%s,(int)%d));\n",x,
        (char *)look->font().family(),look->font().pointSize(),
        xtc.data(),look->font().italic());
       if(isWritten("Font Size") || isWritten("Font") || 
	  isWritten("Bold") || isWritten("Italic"))
	   writeLine(i);


	if(isWritten("Background Colour") || isWritten("Text Colour"))
		writePalette(x);	
}

void
zMenuBar::fillMembInfo()
{
        //fills generic virtual protected stuffs
        genericFillMembInfo();

        //empty destructor
        addMember("destructor()","","",0,2,1);

        //very generic constructor
       addMember("constructor(QWidget *parent=0, char *name=0)",
                        "init(parent,name)","",0,2,1);        QString i;

        addMember("void activated(int itemi)","","",0,3,0);
        addMember("void highlighted(int itemi)","","",0,3,0);
}
