/*  $Id: zTextBox.cc,v 1.4 1998/07/27 16:35:10 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zTextBox.h"

zTextBox::zTextBox(QWidget *parent)
					: BaseComponent(parent,"text")
{
	echoT = new QString("Normal");
	look = new QLineEdit(this,"foo");
	setLook(look);
}

zTextBox::~zTextBox()
{
	delete echoT;
	//Delete your stuff, but don't delete look!
}

void 
zTextBox::fillAttributes()
{
	ADDATTRIB("Text",(char *)look->text(),W_TEXT);

	ADDATTRIB("Echo Mode",echoT->data(),W_LIST,3,
	"Normal", "None", "Password");

	ADDATTRIB("Frame",look->frame(),W_TRUE);

        ADDATTRIB("Font",(char *)myLook->font().family(),W_LIST,fontList);

        ADDATTRIB("Font Size",myLook->font().pointSize(),W_LIST,24,
              "10", "12", "14", "16", "18", "20", "22", "24", "26", "28",
              "30", "32", "34", "36", "38", "40", "44", "48", "52", "56",
              "60", "64", "68", "72");


        ADDATTRIB("Bold",myLook->font().bold(),W_TRUE);

        ADDATTRIB("Italic",myLook->font().italic(),W_TRUE);

        ADDATTRIB("Tool Tip",tooltipData->data(),W_TEXT);

	genericFillAttrib();
}

void 
zTextBox::interpretAttributes()
{
	look->setText(attrib->giveValue("Text").data());			

	look->setFrame(attrib->giveBoolValue("Frame"));

	*echoT = attrib->giveValue("Echo Mode");

        int bo = attrib->giveBoolValue("Bold") ? QFont::Bold : QFont::Normal;
        myLook->setFont(QFont(attrib->giveValue("Font").data(),
                          attrib->giveIntValue("Font Size"),
                          bo,attrib->giveBoolValue("Italic")));

        *tooltipData = attrib->giveValue("Tool Tip");

	genericInterpAttrib();
}

void
zTextBox::writeInits()
{
	QString xtc;
	QString i;

	i = look->text();
	if(i != "")
	{
		i.sprintf(
		"setText(\"%s\");\n"
			,(char *)look->text());
		WRITEATTRIB("Text",i);
	}
	
        if(look->font().bold())
        	xtc = "QFont::Bold";
	else
        	xtc = "QFont::Normal";
	i.sprintf("setFont(QFont(\"%s\",%d,%s,(int)%d));\n",
	(char *)look->font().family(),look->font().pointSize(),
	xtc.data(),look->font().italic());
       if(isWritten("Font Size") || isWritten("Font") || isWritten("Bold") || isWritten("Italic"))
	   writeInParent(i);


	i.sprintf(
	"setFrame(%s);\n"
		,strBool(look->frame()));
	WRITEATTRIB("Frame",i);

	
	if(*echoT == "Normal")
		xtc = "QLineEdit::Normal";
	else if(*echoT == "None")
		xtc = "QLineEdit::NoEcho";
	else if(*echoT == "Password")
		xtc = "QLineEdit::Password";
	i.sprintf(
	"setEchoMode(%s);\n", xtc.data());
	WRITEATTRIB("Echo Mode",i);

	i.sprintf(
	"setGeometry(%d,%d,%d,%d);\n"
		,x(),y(),width(),height());
	writeInParent(i);

        if(!tooltipData->isEmpty())
        {
                QString p;
                if(noFuncs() == TRUE)
                        p = name();
                else
                        p = "this";

                i.sprintf(
                "QToolTip::add(%s,\"%s\");\n"
                        ,p.data(),tooltipData->data());
                writeLine(i);
	}

        writePalette();

       if(isWritten("Maximum Width") || isWritten("Maximum Height"))
       {
	   i.sprintf("setMaximumSize(%d,%d);\n",
		     look->maximumSize().width(),look->maximumSize().height());
	   writeInParent(i);
       }
       if(isWritten("Minimum Width") || isWritten("Minimum Height"))
       {
	   i.sprintf("setMinimumSize(%d,%d);\n",
		     look->minimumSize().width(),look->minimumSize().height());
	   writeInParent(i);
       }

        if(*uiStyle == "Motif")
               i.sprintf("setStyle(MotifStyle);\n");
        else if(*uiStyle == "Windows")
                i.sprintf("setStyle(WindowsStyle);\n");
        else
                i = "";
        if(!i.isEmpty()) writeInParent(i);

}

void 
zTextBox::fillMembInfo()
{
        //fills generic virtual `protected stuffs
        genericFillMembInfo();

        addMember("destructor()","","",0,2,1);

       addMember("constructor(QWidget *parent=0, char *name=0)",
                        "init(parent,name)","",0,2,1);

	addMember("void textChanged (const char *se)","","",0,3,0);
	addMember("void returnPressed ()","","",0,3,0);
}
