/*  $Id: zTimer.cc,v 1.3 1998/07/27 16:35:10 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zTimer.h"
#include "pix/zTimer.h"

zTimer::zTimer(QWidget *parent)
					: BaseComponent(parent,"timer")
{
	active = TRUE; interv = 2000; singles = FALSE;
	
	resize(63,55);
	QPixmap p;
	p.loadFromData((const unsigned char *)&zTimer_bmp_data,zTimer_bmp_len);
	setLook(p);
}

void 
zTimer::fillAttributes()
{
	ADDATTRIB("Active",active, W_TRUE);

	ADDATTRIB("Interval (msecs)", interv, W_TEXT);

	ADDATTRIB("Single Shot",singles,W_TRUE);

	genericFillAttrib();
}

void 
zTimer::interpretAttributes()
{
	active = attrib->giveBoolValue("Active");

	interv = attrib->giveIntValue("Interval (msecs)");

	singles = attrib->giveBoolValue("Single Shot");

	genericInterpAttrib();
}

void
zTimer::writeInits()
{
	QString i;
	if(active == TRUE)
	{
		i.sprintf("start(%d,%s);\n",interv, strBool(singles));
		writeInParent(i);
	}
}

void
zTimer::fillMembInfo()
{
        addMember("destructor()","","",0,2,1);

       addMember("constructor(QWidget *parent=0, char *name=0)",
                        "init(parent,name)","",0,2,1);

	addMember("bool event(QEvent *e)","","",1,1,1);
        addMember("void timeout()","","",0,3,0);
}
