/*  $Id: configs.cc,v 1.5 1998/08/30 18:46:32 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "configs.h"

#include "components/CompIO.h"

#include <qapp.h>
#include <stdlib.h>
#include <fstream.h>
#include <qfontmet.h>

#include <Xlib.h>

#include "MenuBar.h"
extern MenuBar *menubar;

QRect
getRect(QString p)
{
        int x, y, w, h;

	x = p.left(p.find(',')).toInt();p=p.right(p.length() - p.find(',')-1);
        y = p.left(p.find(',')).toInt();p=p.right(p.length() - p.find(',')-1);
        w = p.left(p.find(',')).toInt();p=p.right(p.length() - p.find(',')-1);
        h = p.left(p.find(',')).toInt();

        return QRect(x,y,w,h);
}

Configuration::Configuration(QWidget *parent, char *name) 
	: QTabDialog(parent,name,FALSE,WStyle_Customize | WStyle_NormalBorder )
{
	setCaption("Configuration");
	resize(350,415);
	setMinimumSize(width(),height());
	setMaximumSize(width(),height());
	setOkButton("&Ok");
	setCancelButton("&Cancel");

	timer = new QTimer(this);
	QObject::connect(timer,SIGNAL(timeout()),this,SLOT(timerShot()));

	QObject::connect(this,SIGNAL(applyButtonPressed()),
		SLOT(okPressed()));
	QObject::connect(this,SIGNAL(cancelButtonPressed()),
		SLOT(cancelPressed()));
	
//******************************************************************
//*****************MAKEFILE TAB*************************************
	makeFile = new QWidget(this,"makefile");

	label = new QLabel(makeFile, "label3");
	label->setText("X Library Location:");
	label->setFont(QFont("times",14,QFont::Normal,(int)0));
	label->setAlignment(AlignLeft | AlignTop);
	label->setFrameStyle(QFrame::Raised | QFrame::Box);
	label->setGeometry(6,6,324,74);
	
	label = new QLabel(makeFile, "label8");
	label->setText("Qt Locations:");
	label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,80,324,85);
	label = new QLabel(makeFile,"label9");
	label->setText("Include: ");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setGeometry(15,107,100,20);
	label = new QLabel(makeFile,"label10");
	label->setText("Library: ");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setGeometry(15,137,100,20);

	label = new QLabel(makeFile, "label8");
	label->setText("KDE Locations:");
	label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,165,324,85);
	label = new QLabel(makeFile,"label9");
	label->setText("Include: ");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setGeometry(15,192,100,20);
	label = new QLabel(makeFile,"label10");
	label->setText("Library: ");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setGeometry(15,222,100,20);

	label = new QLabel(makeFile, "label8");
	label->setText("Extra Flags:");
	label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,250,324,85); 
	label = new QLabel(makeFile,"label9");
	label->setText("CFLAGS: ");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setGeometry(15,277,100,20);
	label = new QLabel(makeFile,"label10");
	label->setText("LFLAGS: ");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setGeometry(15,307,100,20);

	txtXLib = new QLineEdit(makeFile, "txtXLib");
	txtXLib->setText("/usr/X11R6/lib");
	txtXLib->setGeometry(18,35,290,30);
	
	txtQInc = new QLineEdit(makeFile, "txtQInc");
	txtQInc->setText("$(KDEDIR)/include");
	txtQInc->setGeometry(80,100,230,30);

  	txtQLib = new QLineEdit(makeFile, "txtQLib");
	txtQLib->setText("$(QTDIR)/lib");
	txtQLib->setGeometry(80,130,230,30);
	
	txtKInc = new QLineEdit(makeFile, "txtKInc");
	txtKInc->setText("$(KDEDIR)/include");
	txtKInc->setGeometry(80,185,230,30);

	txtKLib = new QLineEdit(makeFile, "txtKLib");
	txtKLib->setText("$(KDEDIR)/lib");
	txtKLib->setGeometry(80,215,230,30);
	
	txtCFlags = new QLineEdit(makeFile,"txtCFlags");
        txtCFlags->setGeometry(80,270,230,30);

	txtLFlags = new QLineEdit(makeFile,"txtLFlags");
        txtLFlags->setGeometry(80,300,230,30);
	
	addTab(makeFile,"Makefile");

//**********************************************************
//**************GENERAL TAB*********************************
	general = new QWidget(this,"general");

        label = new QLabel(general, "label4");
        label->setText("Default Fonts:");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,3,324,74);

	label = new QLabel(general,"label11");
	label->setText("Run Display:");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignTop);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,77,324,74);

	txtWhereD = new QLineEdit(general,"whereD");
	txtWhereD->setText(":0.0");
	txtWhereD->setGeometry(13,110,299,30);

	int c, p1, p2; 
	fontList = new QStrList;	
	char **names = XListFonts(QPaintDevice::x11Display(),"*",500,&c);
	fontName = new QComboBox(FALSE,general, "fontName");
	for(int x = 0; x < c; x++) 
	{
		QString s(names[x]);
		if (*names[x] == '-') 
		{
			p1 = s.find('-', 1) + 1;
			p2 = s.find('-', p1);
			s = s.mid(p1, p2 - p1);
	        }
	        else 
		{
	            if ((p1 = s.find('-')) != -1)
        	        s = s.left(p1);
	        }

	        if (s != "nil" && fontList->find(s) == -1) 
		{
	            // insert if this font family can be matched
	            QFont f(s); QFontInfo fi(f);
	            if (fi.family() == s) fontList->inSort(s);
		}
	}	  
	fontName->insertStrList(fontList);
	XFreeFontNames(names);
	QString t = QApplication::font()->family();
	if(fontList->find(t.data()) == -1)
		fontName->setCurrentItem(0);
	else
		fontName->setCurrentItem(fontList->find(t.data()));
        fontName->setGeometry(12,33,224,30);

        fontSize = new QComboBox(TRUE,general, "fontSize");
	fontSize->insertItem("30");
	fontSize->insertItem("28");
	fontSize->insertItem("26");
	fontSize->insertItem("24");
	fontSize->insertItem("22");
	fontSize->insertItem("20");
	fontSize->insertItem("18");
	fontSize->insertItem("16");
	fontSize->insertItem("14");
	fontSize->setCurrentItem(7);
        fontSize->setGeometry(235,33,85,30);

	tooltip = new QCheckBox(general,"tooltip");
	tooltip->setText("Show ToolTips");
	tooltip->setChecked((bool)1);
	tooltip->setGeometry(10,204,300,30);

	enaTimeBk = new QCheckBox(general,"enaTimeBk");
	enaTimeBk->setText("Timed backup every       minutes");
	enaTimeBk->setChecked((bool)1);
	enaTimeBk->setGeometry(10,234,300,30);
	txtTimeBk = new QLineEdit(general,"txtTimeBk");
	txtTimeBk->setText("2");
	txtTimeBk->setGeometry(
	  30+enaTimeBk->fontMetrics().width("Timed backup every"),234,30,30);

        overwrite = new QCheckBox(general,"overwrite");
        overwrite->setText("Overwrite Existing files on save?");
        overwrite->setChecked((bool)0);
        overwrite->setGeometry(10,264,300,30);

	showCompile = new QCheckBox(general,"showCompile");
	showCompile->setText("Show Compile Progress on Compile?");
        showCompile->setChecked((bool)1);
        showCompile->setGeometry(10,294,300,30);
	
	addTab(general,"General");

//********************************************************
//*********************COMPILATION TAB********************
	compilation = new QWidget(this,"compilation");

        label = new QLabel(compilation, "label5");
        label->setText("Debugger:");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignVCenter);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,3,324,45);

        txtDebug = new QLineEdit(compilation, "txtDebug");
        txtDebug->setText("/usr/bin/gdb");
        txtDebug->setGeometry(80,10,240,30);

        label = new QLabel(compilation, "label6");
        label->setText("XTerm:");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignVCenter);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,51,324,45);

        txtTerm = new QLineEdit(compilation, "txtTerm");
        txtTerm->setText("/usr/X11R6/bin/xterm");
        txtTerm->setGeometry(80,58,240,30);

	label = new QLabel(compilation, "label7");
	label->setText("Make:");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignVCenter);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,99,324,45);

	txtMake = new QLineEdit(compilation,"txtMake");
	txtMake->setText("/usr/bin/make");
        txtMake->setGeometry(80,106,240,30);

	label = new QLabel(compilation,"label8");
	label->setText("Compiler:");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignVCenter);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,147,324,45);
	
        txtCpp = new QLineEdit(compilation, "txtCpp");
        txtCpp->setText("/usr/bin/g++");
        txtCpp->setGeometry(80,154,240,30);

	label = new QLabel(compilation,"label8");
	label->setText("Moc:");
        label->setFont(QFont("times",14,QFont::Normal,(int)0));
        label->setAlignment(AlignLeft | AlignVCenter);
        label->setFrameStyle(QFrame::Raised | QFrame::Box);
        label->setGeometry(6,195,324,45);

	txtQMoc = new QLineEdit(compilation, "txtQMoc");
	txtQMoc->setText("$(QTDIR)/bin/moc");
	txtQMoc->setGeometry(80,202,240,30);

	debugComp = new QCheckBox(compilation,"debugComp");
	debugComp->setText("Compile Debug Info?");
	debugComp->setChecked((bool)0);
	debugComp->setGeometry(10,300,145,30);

	addTab(compilation,"Compilation");

        hintButt = new Hint("Configuration:\nYou shouldn't need to use this dialog much after\nyour first configuration. All info is stored in\n~/QtEZ/.configs in case you need to edit \nthis manually for some reason. Use is fairly straight forward, the \ninclude, moc, and lib paths are all put into the Makefile of subsequent\nprojects. The fonts effect most large text areas on the program's \neditors. You can dis/en-able automatic backup on the general\ntab, this will prevent you from losing a project in the\nevent something goes wrong and QtEZ is killed your project\nwill not be lost and you can hopefully recover. The X\nTerminal, and debugger location are both used when you\nrun | debug a project. And finally the Debug info checkbox\nis so that debug tokens will be kept for later debugging\npurposes (might be necesary to remake all for the tokens to ALL\nbe put into place.)",this,"hintButt");
        hintButt->move(width()-hintButt->width(),3);

	getConfigs(1);		
}

int
Configuration::queryFontWidth()
{
    QFont fn(queryFontN(), queryFontS());    QFontMetrics i(fn);
    return i.maxWidth(); 
}

int 
Configuration::queryFontHeight()
{
    QFont fn(queryFontN(), queryFontS());    QFontMetrics i(fn);
    return i.height(); 
}

void
Configuration::getConfigs(int prelim)
{
	char *Buff = new char [100];

	QString i;
	i.sprintf("%s/QtEZ/.configs",getenv("HOME"));
	ifstream p(i.data()); 
	if(p.fail()) return;
        while(p.getline(Buff,100,'\n'))
        {
                i = Buff;

		if(!prelim)
		{
			if(i.find("ATTRIB_LOC:") == 0)
				attrib->setGeometry(getRect(Buff+11));
	                if(i.find("GLOBAL_LOC:") == 0)
	                        global->setGeometry(getRect(Buff+11));
	                if(i.find("SOURCE_LOC:") == 0)
	                        source->setGeometry(getRect(Buff+11));
	                if(i.find("PROJVIEW_LOC:") == 0)
	                        projView->setGeometry(getRect(Buff+13));
			if(i.find("TOOLBAR_LOC:") == 0)
				toolBar->setGeometry(getRect(Buff+12));
			if(i.find("MENUBAR_LOC:") == 0)
			        menubar->setGeometry(getRect(Buff+12));
			if(i.find("SIGSLOT_LOC:") == 0)
			    sigSlot->setGeometry(getRect(Buff+12));
			if(i.find("TOOLBAR_ISVIS") == 0)
			{
			    toolBar->show();
			    toolBar->raise();
			    toolBar->repaint();
			}
			if(i.find("PROJVIEW_ISVIS") == 0)
			{
			    projView->show();
			    projView->raise();
			    projView->repaint();
			}
		}

		if(i.find("XLIB:") == 0)
		        txtXLib->setText(Buff + 5);
                if(i.find("COMP:") == 0)
                        txtCpp->setText(Buff + 5);
		if(i.find("DISP:") == 0)
			txtWhereD->setText(Buff + 5);
		if(i.find("LFLAGS:") == 0)
			txtLFlags->setText(Buff + 7);
		if(i.find("CFLAGS:") == 0)
			txtCFlags->setText(Buff + 7);
                if(i.find("LIB:") == 0)
                        txtQLib->setText(Buff + 4);
                if(i.find("INC:") == 0)
                        txtQInc->setText(Buff + 4);
		if(i.find("KLIB:") == 0)
		        txtKLib->setText(Buff + 5);
		if(i.find("KINC:") == 0)
		        txtKInc->setText(Buff + 5);
                if(i.find("MOC:") == 0)
                        txtQMoc->setText(Buff + 4);
		if(i.find("DEBUGGER:") == 0)
			txtDebug->setText(Buff + 9);
		if(i.find("XTERM:") == 0)
			txtTerm->setText(Buff + 6);
		if(i.find("MAK:") == 0)
			txtMake->setText(Buff + 4);
		if(i.find("TIMEDELAY:") == 0)
			txtTimeBk->setText(Buff + 10);
		if(i.find("FNAME:") == 0)
		{
			i = Buff + 6;
			i = i.stripWhiteSpace();
			fontName->setCurrentItem(i.toInt());
		}
		if(i.find("COMPILE_P:") == 0)
                {
                        i = Buff + 10;
                        i = i.stripWhiteSpace();
                        showCompile->setChecked((bool)i.toInt());
                }
		if(i.find("TOOLTIP:") == 0)
                {
                        i = Buff + 8;
                        i = i.stripWhiteSpace();
                        tooltip->setChecked((bool)i.toInt());
                }
		if(i.find("TIMEBK:") == 0)
		{
			i = Buff + 7;
                        i = i.stripWhiteSpace();
			enaTimeBk->setChecked(i.toInt());
                }
                if(i.find("DEBUG_C:") == 0)
                {
                        i = Buff + 8;
                        i = i.stripWhiteSpace();
                        debugComp->setChecked((bool)i.toInt());
                }
                if(i.find("OVRWRT:") == 0)
                {
                        i = Buff + 7;
                        i = i.stripWhiteSpace();
                        overwrite->setChecked((bool)i.toInt());
                }
		if(i.find("FSIZE:") == 0)
		{

			i = Buff + 6;
			i = i.stripWhiteSpace();

			int flag = 0;
			for(int x = 0; x < fontSize->count(); x++)
			{
				if(i == fontSize->text(x))
				{
					fontSize->setCurrentItem(x);
					flag = 1;
				}
			}
			if(!flag)
			{
				fontSize->insertItem(i.data());
				fontSize->setCurrentItem(fontSize->count()-1);
			}
		}
	}
	p.close();
	delete [] Buff;

	applyConf();
}

void
Configuration::saveYourself()
{
	QString i;
	i.sprintf("%s/QtEZ/.configs",getenv("HOME"));
	ofstream p(i.data());
	p << "LIB:" << queryQtLib() << endl;
	p << "INC:" << queryQtInc() << endl;
	p << "KLIB:" << queryKDELib() << endl;
	p << "KINC:" << queryKDEInc() << endl;
	p << "XLIB:" << queryXLib() << endl;
	p << "MOC:" << queryMoc() << endl;
	p << "MAK:" << queryMak() << endl;
	p << "DISP:" << queryWhereDisp() << endl;
	p << "CFLAGS:" << queryCFlags() << endl;
	p << "LFLAGS:" << queryLFlags() << endl;
	p << "FNAME:" << fontName->currentItem() << endl;
	p << "FSIZE:" << fontSize->currentText() << endl;
	p << "DEBUGGER:" << queryDebug() << endl;
	p << "XTERM:" << queryTerm() << endl;
	p << "DEBUG_C:" << queryShouldDebug() << endl;
	p << "OVRWRT:" << queryOverWrite() << endl;
	p << "COMP:" << queryCPP() << endl;
	p << "COMPILE_P:" << queryCompile() << endl;
	p << "TOOLTIP:" << queryToolTips() << endl;
	p << "TIMEBK:" << enaTimeBk->isChecked() << endl;
	p << "TIMEDELAY:" << txtTimeBk->text() << endl;
	p << "SIGSLOT_LOC:" << sigSlot->x() << "," << sigSlot->y() << ",";
	p << sigSlot->width() << "," << sigSlot->height() << "," << endl;
	p << "ATTRIB_LOC:" << attrib->x() << "," << attrib->y() << ",";
	p << attrib->width() << "," << attrib->height() << "," << endl;
        p << "GLOBAL_LOC:" << global->x() << "," << global->y() << ",";
        p << global->width() << "," << global->height() << "," << endl;
        p << "SOURCE_LOC:" << source->x() << "," << source->y() << ",";
        p << source->width() << "," << source->height() << "," << endl;
        p << "PROJVIEW_LOC:" << projView->x() << "," << projView->y() << ",";
        p << projView->width() << "," << projView->height() << "," << endl;
        p << "TOOLBAR_LOC:" << toolBar->x() << "," << toolBar->y() << ",";
        p << toolBar->width() << "," << toolBar->height() << "," << endl;
	p << "MENUBAR_LOC:" << menubar->x() << "," << menubar->y() << ",";
	p << menubar->width() << "," << menubar->height() << "," << endl;
	if(projView->isVisible()) p << "PROJVIEW_ISVIS" << endl;
	if(toolBar->isVisible()) p << "TOOLBAR_ISVIS" << endl;

	p.close();
	applyConf();
}

void
Configuration::applyConf()
{
	QString p(txtTimeBk->text());
	timer->stop();
	if(enaTimeBk->isChecked()) timer->start(p.toInt() * 60 * 1000); 
}

void
Configuration::timerShot()
{
	QString p; p.sprintf("%s/QtEZ/tmpbk.qtz",getenv("HOME"));
	CompIO::save(p.data());
}

void
Configuration::okPressed()
{
	saveYourself();
	close();
}

void
Configuration::cancelPressed()
{
	getConfigs(1);
	close();
}
