/*  $Id: configs.h,v 1.3 1998/07/27 16:35:03 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef CONFIGURATION_H
#define CONFIGURATION_H
class Configuration;

#ifndef QTEZ_MAIN_HEADER
#define COME_FROM_CONFIG
#endif

#include "main.h"
#include "Hint.h"
#include <qtabdlg.h>
#include <qlined.h>
#include <qcombo.h>
#include <qchkbox.h>
#include <qlabel.h>
#include <qrect.h>
#include <qstrlist.h>
#include <qtimer.h>

QRect getRect(QString p);


class
Configuration : public QTabDialog
{
private:
    Q_OBJECT
    QWidget *makeFile, *compilation, *general;
    QStrList *fontList;
    QTimer *timer;
    QLineEdit *txtXLib;
    QLineEdit *txtKInc;
    QLineEdit *txtKLib;
    QLineEdit *txtQInc;
    QLineEdit *txtQMoc;
    QLineEdit *txtQLib;
    QLineEdit *txtTerm;
    QLineEdit *txtDebug;
    QLineEdit *txtMake;
    QLineEdit *txtCpp;
    QLineEdit *txtTimeBk;
    QComboBox *fontName;
    QComboBox *fontSize;
    QLineEdit *txtCFlags, *txtLFlags;
    QLineEdit *txtWhereD;
    QCheckBox *debugComp, *overwrite, *showCompile, *enaTimeBk, *tooltip;
    QLabel *label;
    Hint *hintButt;
public slots:
    void timerShot();
public:
    Configuration(QWidget *parent=0, char *name=0);
    ~Configuration() { delete fontList; }
    char *queryFontN() 
	{ return (char *)fontName->text(fontName->currentItem()); }	
    int queryFontS()  
	{ QString i(fontSize->currentText()); i = i.stripWhiteSpace();	return i.toInt(); }
    int queryFontWidth();
    int queryFontHeight();
    const QStrList *queryFontList()
        { return fontList; }
    const char *queryWhereDisp()
	{ return txtWhereD->text();          }
    const char *queryCPP()
	{ return txtCpp->text();              }
    const char *queryQtInc()   
	{ return txtQInc->text();            }
    const char *queryXLib()
	{ return txtXLib->text(); }
    const char *queryMak()
	{ return txtMake->text(); 	      }
    const char *queryMoc()   
	{ return txtQMoc->text();            }
    const char *queryKDEInc()
	{ return txtKInc->text(); }
    const char *queryKDELib()
	{ return txtKLib->text(); }
    const char *queryQtLib()  
	{ return txtQLib->text();            }
    const char *queryTerm()
	{ return txtTerm->text();            }
    const char *queryDebug()
	{ return txtDebug->text();           }
    const int queryShouldDebug()
	{ return (int) debugComp->isChecked(); }
    const char *queryCFlags()
	{ return txtCFlags->text();          }
    const char *queryLFlags()
	{ return txtLFlags->text();          }
    const int queryOverWrite()
	{ return (int) overwrite->isChecked(); }
    const int queryCompile()
	{ return (int) showCompile->isChecked(); }
    const int queryToolTips()
	{ return (int) tooltip->isChecked(); }
    void getConfigs(int);
    void saveYourself();
protected:
    signals:
	public slots:
	void okPressed();
    void applyConf();
    void cancelPressed();
};
#endif
