/*  $Id: main.cc,v 1.12 1998/07/28 17:48:51 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#define MAIN_FUNC

#include "main.h"
#include "version.h"
#include "QtEZLogo.h"
#include "components/BaseComp.h"
#include "components/LinkList.h"
#include "MenuBar.h"
#include "YesNo.h"

ProjectViewer *projView;
Attributes *attrib;
SourceEdit *source;
Configuration *configs;
MnuEditor *menu;
SigSlotEdit *sigSlot;
Globals *global;
MenuBar *menubar;
ToolBar *toolBar;

#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#ifdef __USE_KDE
#include <kapp.h>
#else
#include <qapp.h>
#endif
#include <qregexp.h>

int
main(int argc,char **argv)
{
#ifdef __USE_KDE
    KApplication a (argc,argv);
#else
    QApplication a (argc,argv);
#endif

    QString i;
    i.sprintf("%s/QtEZ",getenv("HOME"));
    mkdir(i.data(),0755);	

    configs = new Configuration(0,"configs");
    configs->hide();

    projView = new ProjectViewer(0,"projView");
    projView->hide();

    attrib = new Attributes(0,"attrib");
    attrib->hide();

    source = new SourceEdit(0,"source");
    source->hide();

    global = new Globals(0,"global");
    global->hide();

    toolBar = new ToolBar();
    toolBar->hide();

    menu = new MnuEditor(0,"menu");
    menu->hide();
        
    sigSlot = new SigSlotEdit(0,"sigSlo");
    sigSlot->hide();

    //DO LAST!!!
    menubar = new MenuBar;
    menubar->gnuProject();
    a.setMainWidget(menubar);
    toolBar->installEventFilter(menubar);
    menu->installEventFilter(menubar);
    sigSlot->installEventFilter(menubar);
    global->installEventFilter(menubar);
    source->installEventFilter(menubar);
    configs->installEventFilter(menubar);
    attrib->installEventFilter(menubar);
    projView->installEventFilter(menubar);
    configs->getConfigs(0);

    menubar->show();

    argc--; argv++;
    FILE *test; i.sprintf("%s/QtEZ/tmpbk.qtz",getenv("HOME"));
    if( (test = fopen(i.data(),"r")) )
    {
	fclose(test);
	YesNo yn(0,"yn",340);
	if(yn.doit("A leftover backup of your previous project\nhas been found, do you wish to load this?"))

	    CompIO::load(i.data(),O_OPEN);
    }
    else if(argc == 1) 
    {
	test = fopen(*argv,"r");
	if(!test)
	{
	    cerr << "Error opening " << *argv << "." << endl;
	    fclose(test);
	}
	else
	{
	    fclose(test);
	    CompIO::load(*argv,O_OPEN);
	}
    }
			
    return a.exec();
}

/* Mostly left to output different types for debugging purposes */

ostream &operator<<(ostream &os, SignalConnect rhs)
{
    os << rhs.querySigOwner()  << ':' << rhs.querySig() << ':'
       << rhs.querySlotOwner() << ':' << rhs.querySlot()<< ':';
    return os;
}

ostream &operator<<(ostream &os, MenubarElement rhs)
{
    os << rhs.queryCapt() << ':' << rhs.queryName() << ':'
       << rhs.queryConO() << ':' << rhs.queryConS()<< ':'
       << rhs.queryChk()  << ':' << rhs.queryEna() << ':' 
       << rhs.queryLev()  << ':' << rhs.queryShrtCut() << ':';
    return os;
}

void
SignalConnectList::printem(SignalConnect *p1,SignalConnect *p2)
{
    if(p1)
    {
        cout << "comparing: " << endl;
        cout << BaseComponent::at(p1->querySigOwner())->name() << " ";
        cout << BaseComponent::at(p1->querySigOwner())->membInfo()->membName(p1->querySig()).data() << " ";
        cout << BaseComponent::at(p1->querySlotOwner())->name() << " ";
        cout << BaseComponent::at(p1->querySlotOwner())->membInfo()->membName(
	    BaseComponent::at(p1->querySlotOwner())->membInfo()->slot(p1->querySlot())).data() << endl;
    }

    if(p2)
    {
        cout << BaseComponent::at(p2->querySigOwner())->name() << " ";
        cout << BaseComponent::at(p2->querySigOwner())->membInfo()->membName(p2->querySig()).data() << " ";
        cout << BaseComponent::at(p2->querySlotOwner())->name() << " ";
        cout << BaseComponent::at(p2->querySlotOwner())->membInfo()->membName(
	    BaseComponent::at(p2->querySlotOwner())->membInfo()->slot(p2->querySlot())).data() << endl;
        cout << endl;
    }
}

